---------------------------------------------
-- DEFAULTS
---------------------------------------------

--[[===[@debug@
local debug

local debugDefaults = {
	CheckForEngage = true,
	CombatStop = false,
	CHAT_MSG_MONSTER_YELL = false,
	GROUP_ROSTER_UPDATE = false,
	GROUP_ROSTER_UPDATE = false,
	BlockBossEmotes = false,
	TriggerDefeat = false,
	UNIT_NAME_UPDATE = false,
	INSTANCE_ENCOUNTER_ENGAGE_UNIT = true,
}
--@end-debug@]===]]

local defaults = {
	global = {
		Locked = true,
		AdvancedMode = true,
		-- NPC id -> Localized name
		L_NPC = {},
		--[===[@debug@
		debug = debugDefaults,
		--@end-debug@]===]
		motd_read_v = false,
		seenmovies = {},
	},
	--[[
BackgroundColor = {0, 0, 0, 0.5},
					BorderColor = {0.15, 0.24, 0.31, 1},
					BorderWidth = 12,
					BorderTexture = "IshBorder",	
					-- Statusbar
					StatusbarTexture = "HalD",
					StatusbarColor = {0.22, 0.34, 0.46, 1},
--]]
	profile = {
		Enabled = true,
		Positions = {},
		Dimensions = {},
		Scales = {},
		Encounters = {},
		Globals = {
			BarTexture = "Blizzard",
			Font = "Franklin Gothic Medium",
			TimerFont = "Bastardus Sans",
			Border = "Blizzard Tooltip",
			BorderColor = {0.33,0.33,0.33,0.74},
			BorderEdgeSize = 8,
			BackgroundColor = {0,0,0,0.8},
			BackgroundInset = 2,
			BackgroundTexture = "Blizzard Tooltip",
			AnimationSpeed = 0.3,
			TransitionTime = 5,
			GlobalBarCrl = "MIDBLUE",
		},
		--[[Globals = {
			BarTexture = "Minimalist",
			Font = "accid", -- Franklin Gothic Medium
			TimerFont = "Bastardus Sans",
			Border = "IshBorder",
			BorderColor = {0.15, 0.24, 0.31, 1},
			BorderEdgeSize = 12,
			BackgroundColor = {0,0,0,0.8},
			BackgroundInset = 4.2,
			BackgroundTexture = "Blizzard Tooltip"
		},--]]
		Pane = {
			Show = true,
			Scale = 1,
			Width = 220,
			OnlyInRaid = false,
			OnlyInParty = false,
			OnlyInRaidInstance = false,
			OnlyInPartyInstance = false,
			OnlyIfRunning = false,
			OnlyOnMouseover = false,
			BarGrowth = "UP",
			FontColor = {1,1,1,1},
			TitleFontSize = 11,
			HealthFontSize = 12,
			NeutralColor = {0,0,1,1},
			LostColor = {0.66,0.66,0.66,1},
			BarSpacing = 0,
		},
		Misc = {
			BlockBossEmoteMessages = false,
			BlockRaidWarningMessages = false,
			BlockBossEmoteFrame = true,
			BlockRaidWarningFrame = true,
			BlockMovies = false,
			BlockGarrison = false,
			BlockGuildChallenge = false,
		},
		Windows = {
			TitleBarColor = {0,0,0.82,1},
			Proxtype = "RADAR",
		},
		Proximity = {
			AutoPopup = true,
			AutoHide = true,
			BarAlpha = 0.4,
			Range = 10,
			Delay = 0.05,
			ClassFilter = {['*'] = true},
			Invert = false,
			Dummy = false,
			Rows = 5,
			NameFontSize = 9,
			TimeFontSize = 9,
			NameOffset = -12,
			NameAlignment = "CENTER",
			TimeOffset = -12,
			IconPosition = "LEFT",
			DotSize = 12,
			RaidIcons = "REPLACE",
			Sound = true,
			SoundDelay = 2,
		},
		AlternatePower = {
			AutoPopup = true,
			AutoHide = true,
			BarAlpha = 0.4,
			Threshold = 1,
			Delay = 0.5, -- raised delay for less cpu pain
			ClassFilter = {['*'] = true},
			Invert = false,
			Dummy = false,
			Rows = 5,
			NameFontSize = 9,
			TimeFontSize = 9,
			NameOffset = -12,
			NameAlignment = "CENTER",
			TimeOffset = -12,
			IconPosition = "LEFT",
		},
		Sounds = {
			ALERT1 = "Bell Toll Alliance",
			ALERT2 = "Bell Toll Horde",
			ALERT3 = "Low Mana",
			ALERT4 = "Low Health",
			ALERT5 = "Zing Alarm",
			ALERT6 = "Wobble",
			ALERT7 = "Bottle",
			ALERT8 = "Lift Me",
			ALERT9 = "Neo Beep",
			ALERT10 = "PvP Flag Taken",
			ALERT11 = "Beware",
			ALERT12 = "Run Away",
			ALERT13 = "Bell",
			ALERT14 = "Bell 2",
			ALERT15 = "Raid Warning",
			ALERT16 = "War Drums",
			ALERT17 = "Destruction",
			ALERT18 = "Not Prepared",
			ALERT19 = "Adds Incoming",
			VICTORY = "FF1 Victory",
			VoiceSound = "US_Female",
			PROXIMITY = "Bit Blip"
		},
		MessageAnchor = {
			messagescale = 1,
			messageholdtime = 3,
			messageShowLeftIcon = true,
			messageShowRightIcon = false,
			messagefadeintime = 0.4,
			messagefadeouttime = 0.7,
			MessageFont = "Prototype",
			MessageSize = 12,
			MessageFlags = "THICKOUTLINE",
			MessageGrowth = "UP",
		},
		TopMessageAnchor = {
			TopMessageFont = "Prototype",
			TopMessageSize = 35,
			TopMessageFlags = "THICKOUTLINE",
			TopMessageShowLeftIcon = true,
			TopMessageShowRightIcon = false,
		},
		InformMessageAnchor = {
			InformMessageFont = "Prototype",
			InformMessageSize = 24,
			InformMessageFlags = "THICKOUTLINE",
			InformMessageShowLeftIcon = true,
			InformMessageShowRightIcon = false,			
		},
		Announces = {
			ReplaceMe = true,
			Throttle = 4,
		},
		Kills = {
			KEnabled = true,
			ShowKill = true,
			ShowBestKill = true,
			ShowKillCount = true,
			ShowWipe = true,
			ShowWipeCount = true,
			BarCrl = "GOLD",
			BiggerBar = false,
		},
		RespawnBar = {
			Enabled = true,
			BarColor = "GREEN",
			BiggerBar = false,
		},
		Enrage = {
			Enabled = true,
			BarColor = "RED",
			FlashBarColor = "ORANGE",
			AudioCd = false,
			Audiotime = 5,
			Flashtime = 15,
			BiggerBar = false,
			EnableMessage = true,
			MessageColor = "TAN",
			Audio = "ALERT13",
			EnabledHalf = true,
			AudioHalf = "ALERT13",
			MessageHalfColor = "DCYAN",
			Enable1m = true,
			Audio1m = "ALERT4",
			Message1mColor = "YELLOW",
			Enable30 = true,
			Audio30 = "ALERT9",
			Message30Color = "ORANGE",
			Enable15 = true,
			Audio15 = "ALERT16",
			Message15Color = "BROWN",
			EnableEnrage = true,
			AudioEnrage = "ALERT17",
			MessageEnrageColor = "RED",			
		},	
		Engage = {
			EnableEngage = true,
			MessageEngageColor = "DCYAN",
			AudioEngage = "None",
			EngageTextSize = 30,
			FlashScreenEngage = false,	
			EnableDefeated = true,
			MessageDefeatedColor = "GREEN",
			--AudioDefeated = "None",
			Victory = true,
			DefeatedTextSize = 30,	
			FlashScreenDefeated	= false,		
		},		
		Notes = {
			DefaultText = "",
		},
		CustomSounds = {},
	},
}

---------------------------------------------
-- INITIALIZATION
---------------------------------------------

local addon = LibStub("AceAddon-3.0"):NewAddon("DXE","AceEvent-3.0","AceTimer-3.0","AceComm-3.0","AceSerializer-3.0")
_G.DXE = addon
addon.version = 693
addon:SetDefaultModuleState(false)
addon.callbacks = LibStub("CallbackHandler-1.0"):New(addon)
addon.defaults = defaults

---------------------------------------------
-- UPVALUES
---------------------------------------------

local wipe,remove,sort = table.wipe,table.remove,table.sort
local match,find,gmatch,sub = string.match,string.find,string.gmatch,string.sub
local _G,select,tostring,type,tonumber = _G,select,tostring,type,tonumber
local GetTime,GetNumGroupMembers,GetNumSubgroupMembers,GetRaidRosterInfo = GetTime,GetNumGroupMembers,GetNumSubgroupMembers,GetRaidRosterInfo
local UnitName,UnitGUID,UnitIsEnemy,UnitClass,UnitAffectingCombat,UnitHealth,UnitHealthMax,UnitIsFriend,UnitIsDead,UnitIsConnected =
		UnitName,UnitGUID,UnitIsEnemy,UnitClass,UnitAffectingCombat,UnitHealth,UnitHealthMax,UnitIsFriend,UnitIsDead,UnitIsConnected
local UnitInVehicle = UnitInVehicle
local rawget,unpack = rawget,unpack

local db,gbl,pfl
local killtime = nil
local id,zoneid
local Throttle = {}

---------------------------------------------
-- LIBS
---------------------------------------------

local AceTimer = LibStub("AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("DXE")
local SM = LibStub("LibSharedMedia-3.0")
local LDS = LibStub("LibDualSpec-1.0",true)

-- Localized spell names
local SN = setmetatable({},{
	__index = function(t,k)
		local name
		--if type(k) ~= "number" then return "nil" end
		if type(k) == "number" then
			name = GetSpellInfo(k)
		elseif type(k) == "string" then
			name = EJ_GetSectionInfo(string.sub(k, 3)) or ""
		end
		if not name then
			geterrorhandler()("Invalid spell name attempted to be retrieved")
			return tostring(k)
		end
		t[k] = name
		return name
	end,
})

-- Spell textures - caching is unnecessary
local ST = setmetatable({},{
	__index = function(t,k)
		local texture
		if type(k) == "number" then
			texture = select(3,GetSpellInfo(k))
		else
			local ejID = tonumber(k:match("^ej(%d+)$"))
			if ejID then
				local icon = select(4,EJ_GetSectionInfo(ejID))
				if icon and icon:trim():len() > 0 then
					texture = icon
				else
					texture = "Interface\\Icons\\Ability_creature_cursed_04"
				end
			end
		end
		--if not texture then
			--geterrorhandler()("Invalid spell texture attempted to be retrieved")
		--	return "Interface\\Buttons\\WHITE8X8"
		--end
		return texture
	end,
})

-- Localized Encounter Journal Entries
-- Input: sectionID
-- Output: Localized name of section
local EJSN = setmetatable({},{
	__index = function(t,k)
		if type(k) ~= "number" then return "nil" end
		local name = EJ_GetSectionInfo(k)
		if not name then
			geterrorhandler()("Invalid EJ section attempted to be retrieved")
			return tostring(k)
		end
		return name
	end,
})
-- Encounter Journal textures
local EJST = setmetatable({},{
	__index = function(t,k)
		if type(k) ~= "number" then return "nil" end
		local texture = select(4,EJ_GetSectionInfo(k))
		if texture and texture:trim():len() > 0 then
			return texture
		else
			--geterrorhandler()("Invalid spell texture attempted to be retrieved")
			return "Interface\\Icons\\Ability_creature_cursed_04"
		end
	end,
})
function addon:ReturnUnitID(guid)
	if not guid then return 1 end
	local _, _, _, _, _, id = strsplit("-", guid)
	return tonumber(id) or 1
end

-- NPC IDs
local GUID_LENGTH = 18
local UT_NPC = 3
local UT_VEHICLE = 5

local NID = setmetatable({},{
	__index = function(t,guid)
		--if type(guid) ~= "string" or #guid ~= GUID_LENGTH or not guid:find("%xx%x+") then return end
		--local ut = tonumber(sub(guid,5,5),16) % 8
		--local isNPC = ut == UT_NPC or ut == UT_VEHICLE
		local npcid = addon:ReturnUnitID(guid)
		--if WOD then
		--	npcid = isNPC and addon:ReturnUnitID(guid)
		--	print("NID:",npcid)
		--else
		--	npcid = isNPC and tonumber(sub(guid,6,10),16)
		--end
		t[guid] = npcid
		return npcid
	end,
})

-- Color name
local class_to_color = {}
for class,color in pairs(RAID_CLASS_COLORS) do
	class_to_color[class] = ("|cff%02x%02x%02x"):format(color.r * 255, color.g * 255, color.b * 255)
end

local CN = setmetatable({}, {__index =
	function(t, unit)
		local class = select(2,UnitClass(unit))
		if not class then return unit end
		local name = UnitName(unit)
		if not name then return end
		local prev = rawget(t,name)
		if prev then return prev end
		t[name] = class_to_color[class]..name.."|r"
		return t[name]
	end,
})

do
	local embeds = {
		L = L,
		LDS = LDS,
		SN = SN,
		NID = NID,
		CN = CN,
		SM = SM,
		ST = ST,
		EJSN = EJSN,
		EJST = EJST,
	}
	for k,v in pairs(embeds) do addon[k] = v end
end

---------------------------------------------
-- UTILITY
---------------------------------------------

local ipairs,pairs = ipairs,pairs

local util = {}
addon.util = util

local function tablesize(t)
	local n = 0
	for _ in pairs(t) do n = n + 1 end
	return n
end

local function search(t,value,i)
	for k,v in pairs(t) do
		if i then
			if type(v) == "table" and v[i] == value then return k end
		elseif v == value then return k end
	end
end

local function blend(c1, c2, factor)
	local r = (1-factor) * c1.r + factor * c2.r
	local g = (1-factor) * c1.g + factor * c2.g
	local b = (1-factor) * c1.b + factor * c2.b
	return r,g,b
end

local function safecall(func,...)
	local success,err = pcall(func,...)
	if not success then geterrorhandler()(err) end
	return success
end

util.tablesize = tablesize
util.search = search
util.blend = blend
util.safecall = safecall

---------------------------------------------
-- MODULES
---------------------------------------------

function addon:EnableAllModules()
	for name in self:IterateModules() do
		self:EnableModule(name)
	end
end

function addon:DisableAllModules()
	for name in self:IterateModules() do
		self:DisableModule(name)
	end
end

---------------------------------------------
-- PROXIMITY CHECKING
---------------------------------------------

do
	-- 18 yards
	local bandages = {
		[72986] = true, -- Heavy Windwool Bandage
		[53051] = true, -- Dense Embersilk Bandage
		[72985] = true, -- Windwool Bandage
		[53050] = true, -- Heavy Embersilk Bandage
		[53049] = true, -- Embersilk Bandage
		[34722] = true, -- Heavy Frostweave Bandage
		[34721] = true, -- Frostweave Bandage
		[21991] = true, -- Heavy Netherweave Bandage
		[21990] = true, -- Netherweave Bandage
		[14530] = true, -- Heavy Runecloth Bandage
		[14529] = true, -- Runecloth Bandage
		[8545] = true, -- Heavy Mageweave Bandage
		[8544] = true, -- Mageweave Bandage
		[6451] = true, -- Heavy Silk Bandage
		[6450] = true, -- Silk Bandage
		[3531] = true, -- Heavy Wool Bandage
		[3530] = true, -- Wool Bandage
		[2581] = true, -- Heavy Linen Bandage
		[1251] = true, -- Linen Bandage
	}
	-- CheckInteractDistance(unit,i)
	-- 2 = Trade, 11.11 yards
	-- 3 = Duel, 9.9 yards
	-- 4 = Follow, 28 yards

	local IsItemInRange = IsItemInRange
	local knownBandage
	-- Keys refer to yards
	local ProximityFuncs = {
		[10] = function(unit) return CheckInteractDistance(unit,3) end,
		[11] = function(unit) return CheckInteractDistance(unit,2) end,
		[18] = function(unit)
			if knownBandage then
				return IsItemInRange(knownBandage,unit) == 1
			else
				for itemid in pairs(bandages) do
					if IsItemInRange(itemid,unit) == 1 then
						knownBandage = itemid
						return true
					end
				end
				-- default to 11
				return CheckInteractDistance(unit,2)
			end
		end,
		[28] = function(unit) return CheckInteractDistance(unit,4) end,
	}

	function addon:GetProximityFuncs()
		return ProximityFuncs
	end
end

function addon:ShowProximity()
	if pfl.Windows.Proxtype == "RADAR" then
		addon:Radar()
	else
		addon:Proximity()
	end
end

function addon:UpdateProximityProfile()
	if pfl.Windows.Proxtype == "RADAR" then
		addon:UpdateRadarSettings()
	else
		addon:UpdateProximitySettings()
	end
end

---------------------------------------------
-- RAID DIFFICULTY
---------------------------------------------
--14 - 10-30-player flexible raid
--15 - 10-30-player flexible heroic raid
--16 - 20-player mythic raid
--17 - 10-30-player flexible LFR
function addon:Is25Raid()
	if select(5,GetInstanceInfo()) == 25 then 
		return true
	else
		return false
	end
end
function addon:CheckLFR()
	local diff = select(3,GetInstanceInfo())
    if diff == 7 or diff == 17 then return true end
	return false
end
function addon:CheckFlex() -- WoD normal mode
    if select(3,GetInstanceInfo()) == 14 then return true end
	return false
end
function addon:GetRaidDifficulty()
	local diff
	local _, type, index = GetInstanceInfo()

	if type == "raid" then
		diff = index - 2 -- for backwards compatibility
		if diff == 5 then diff = 0 end -- LFR to 0
		if diff == 12 then diff = 5 end -- Wod Normal (formor Flex)
		if diff == 13 then diff = 7 end -- Wod Heroic (formor normal)
		if diff == 14 then diff = 8 end -- Mythic (formor heroic)
		if diff == 15 then diff = 6 end -- New Variable LFR
	end
	
	return diff
end
function addon:IsRaidHeroic()
	local _, type, index = GetInstanceInfo()
	
	if type == "raid" then
		if index == 5 or index == 6 or index == 15 then return true end 
	end
	return false
end
function addon:IsHeroic()
	local _, type, index = GetInstanceInfo()

	if index == 2 or index == 11 then return true end 
	return false
end
function addon:CheckMythic()
    if select(3,GetInstanceInfo()) == 16 then return true end
	return false
end

function addon:GetMaxPlayers()
	if addon:CheckMythic() then
		return select(5,GetInstanceInfo())
	else
		return select(9,GetInstanceInfo())
	end
end

function addon:InstanceSize() -- For use of 5 man
	if IsInRaid() then
		return select(5,GetInstanceInfo())
	else
		tmpMembers = GetNumSubgroupMembers()
		if tmpMembers > 0 then
			return 5
		else
			return 0
		end
	end
end
---------------------------------------------
-- FUNCTION THROTTLING
---------------------------------------------

do
	-- Error margin added to ScheduleTimer to ensure it fires after the throttling period
	local _epsilon = 0.2
	-- @param _postcall A boolean determining whether or not the function is called
	-- 		           after the end of the throttle period if called during it. If this
	--					     is set to true the function should not be passing in arguments
	--         		     because they will be lost
	local function ThrottleFunc(_obj,_func,_time,_postcall)
		--[===[@debug@
		assert(type(_func) == "string","Expected _func to be a string")
		assert(type(_obj) == "table","Expected _obj to be a table")
		assert(type(_obj[_func]) == "function","Expected _obj[func] to be a function")
		assert(type(_time) == "number","Expected _time to be a number")
		assert(type(_postcall) == "boolean","Expected _postcall to be a boolean")
		assert(AceTimer.embeds[_obj],"Expected obj to be AceTimer embedded")
		--@end-debug@]===]
		local _old_func = _obj[_func]
		local _last,_handle = GetTime() - _time
		_obj[_func] = function(self,...)
			local _t = GetTime()
			if _last + _time > _t then
				if _postcall and not _handle then
					_handle = self:ScheduleTimer(_func,_last + _time - _t + _epsilon)
				end
				return
			end
			_last = _t
			self:CancelTimer(_handle,true)
			_handle = nil
			return _old_func(self,...)
		end
	end

	addon.ThrottleFunc = ThrottleFunc
end

---------------------------------------------
-- ENCOUNTER MANAGEMENT
-- Credits to RDX
---------------------------------------------
local EDB = {}
addon.EDB = EDB
-- Current encounter data
local CE
-- Received database
local RDB

local DEFEAT_NID
local DEFEAT_NIDS

local RegisterQueue = {}
local Initialized = false
function addon:RegisterEncounter(data)
	local key = data.key

	-- Convert version
	data.version = type(data.version) == "string" and tonumber(data.version:match("%d+")) or data.version

	-- Add to queue if we're not loaded yet
	if not Initialized then RegisterQueue[key] = data return end

	--[===[@debug@
	local success = safecall(self.ValidateData,self,data)
	if not success then return end
	--@end-debug@]===]

	-- Upgrading
	if RDB[key] and RDB[key] ~= data then
		if RDB[key].version <= data.version then
			local version = RDB[key].version
			RDB[key] = nil
			if version == data.version then
				-- Don't need to do anything
				return
			else
				self:UnregisterEncounter(key)
			end
		else
			-- RDB version is higher
			return
		end
	end

	-- Unregister before registering the same encounter
	if EDB[key] then error("Encounter "..key.." already exists - Requires unregistering") return end

	-- Only encounters with field key have options
	if key ~= "default" then
		self:AddEncounterDefaults(data)
		self:RefreshDefaults()
		self.callbacks:Fire("OnRegisterEncounter",data)
		self:UpdateTriggers()
	end

	EDB[key] = data
end

--- Remove an encounter previously added with RegisterEncounter.
function addon:UnregisterEncounter(key)
	if key == "default" or not EDB[key] then return end

	-- Swap to default if we're trying to unregister the current encounter
	if CE.key == key then self:SetActiveEncounter("default") end

	self:UpdateTriggers()
	self.callbacks:Fire("OnUnregisterEncounter",EDB[key])
	EDB[key] = nil
end

--- Get the name of the currently-active encounter
function addon:GetActiveEncounter()
	return CE and CE.key or "default"
end

function addon:SetCombat(flag,event,func)
	if flag then self:RegisterEvent(event,func) end
end

function addon:OpenWindows()
	local encdb = pfl.Encounters[CE.key]
	local proxdb = encdb and encdb.proxwindow
	-- proximity window
	if proxdb and proxdb.enabled and proxdb.proxrange ~= nil then
		local range = proxdb.proxrange
		if range and proxdb.proxoverride then 
			if pfl.Windows.Proxtype == "RADAR" then
				self:Radar(true,range)
			else
				self:Proximity(true,range)
			end
		end
	end
	-- alternate power bar window
	local apbdb = encdb and encdb.apbwindow
	if apbdb and apbdb.enabled and apbdb.apboverride then
		local threshold = apbdb.apboverride and apbdb.apbthreshold
		if apbdb.apbspellid then
			self:AlternatePower(true,threshold,apbdb.apbspellid)
		else
			self:AlternatePower(true,threshold)
		end
	end
end

function addon:OpenWindow(range,players,multi,spellid)
	local encdb = pfl.Encounters[CE.key]
	local proxdb = encdb and encdb.proxwindow
	if proxdb and proxdb.enabled then 
		if proxdb.proxoverride and proxdb.proxrange ~= nil then range = proxdb.proxrange end
		
		if pfl.Windows.Proxtype == "RADAR" then
			self:Radar(true,range,players,multi,spellid)
		else
			self:Proximity(true,range,players,multi,spellid)
		end
	end
end
function addon:CloseWindow()
	if pfl.Windows.Proxtype == "RADAR" then
		self:HideRadar()
	else
		self:HideProximity()
	end
end

function addon:OpenAlternate(spellid)
	local encdb = pfl.Encounters[CE.key]
	local apbdb = encdb and encdb.apbwindow
	if apbdb and apbdb.enabled then
		local threshold = apbdb.apboverride and apbdb.apbthreshold
		if spellid then
			self:AlternatePower(true,threshold,spellid)
		else
			self:AlternatePower(true,threshold)
		end
	end
end
function addon:CloseAlternate()
	self:HideAlternatePower()
end
---------------------------------------------------------------
do
	local frame = CreateFrame("Frame")
	local DEFEAT_YELL
	local DEFEAT_TBL = {}

	frame:SetScript("OnEvent",function(self,event,msg)
		if find(msg,DEFEAT_YELL) then addon:TriggerDefeat() end
	end)

	function addon:ResetDefeat()
		wipe(DEFEAT_TBL)
		wipe(Throttle)
		DEFEAT_NID = nil
		DEFEAT_NIDS = nil
		DEFEAT_YELL = nil
		frame:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		frame:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
	end

	function addon:ResetDefeatTbl()
		for k in pairs(DEFEAT_TBL) do DEFEAT_TBL[k] = false end
	end

	function addon:TriggerDefeat()
		self.callbacks:Fire("TriggerDefeat",CE)
		self:StopEncounter()
		if pfl.Engage.Victory then PlaySoundFile(SM:Fetch("sound",pfl.Sounds.VICTORY)) end
		if pfl.Proximity.AutoHide then
			self:HideProximity()
			self:HideRadar()
		end
		if pfl.AlternatePower.AutoHide then	self:HideAlternatePower() end
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		if CE.icon and pfl.Engage.EnableDefeated then
			self:BossDefeated(CE.name..L.alert[" has been |cffABD473Defeated"],3,pfl.Engage.AudioDefeated,pfl.Engage.MessageDefeatedColor,pfl.Engage.FlashScreenDefeated,CE.icon,pfl.Engage.DefeatedTextSize)
		end		
		--[===[@debug@
		debug("TriggerDefeat","key: %s",CE.key)
		--@end-debug@]===]
	end
	
	function addon:TriggerEndCombat()
		self.callbacks:Fire("TriggerDefeat",CE)
		self:StopEncounter()
		if pfl.Proximity.AutoHide then
			self:HideProximity()
			self:HideRadar()
		end
		if pfl.AlternatePower.AutoHide then	self:HideAlternatePower() end
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end	

	function addon:SetDefeat(defeat)
		if not defeat then return end
		if type(defeat) == "number" then
			DEFEAT_NID = defeat
		elseif type(defeat) == "string" then
			DEFEAT_YELL = defeat
		elseif type(defeat) == "table" then
			for k,v in ipairs(defeat) do
				if type(v) == "number" then
					DEFEAT_TBL[v] = false
				elseif type(v) == "string" then
					DEFEAT_YELL = v
				end
			end
			DEFEAT_NIDS = DEFEAT_TBL
		end

		if DEFEAT_YELL then frame:RegisterEvent("CHAT_MSG_MONSTER_YELL") end
		
	end
end

--- Change the currently-active encounter.
function addon:SetActiveEncounter(key)
	--[===[@debug@
	assert(type(key) == "string","String expected in SetActiveEncounter")
	--@end-debug@]===]
	-- Check the new encounter

	if not EDB[key] then return end

	-- Already set to this encounter
	if CE and CE.key == key then return end

	CE = EDB[key]
	addon.CE = CE
	--if CE.onactivate.delayrecombat then
	--	if killtime and GetTime() - killtime < (CE.onactivate.delayrecombat or 10) then return end
	--end
	self:SetTracerStart(false)
	self:SetTracerStop(false)

	self:StopEncounter()

	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
	self:UnregisterEvent("ENCOUNTER_START")
	self:UnregisterEvent("ENCOUNTER_END")	

	self.Pane.SetFolderValue(key)

	self:OpenWindows()

	self:CloseAllHW()
	self:ResetSortedTracing()

	self:ResetDefeat()

	if CE.onactivate then
		local oa = CE.onactivate
		self:SetTracerStart(oa.tracerstart)
		self:SetTracerStop(oa.tracerstop)

		-- Either could exist but not both
		self:SetSortedTracing(oa.sortedtracing)
		self:SetTracing(oa.tracing or oa.unittracing,CE.name,CE.triggers.ejid or 0)
		--print("6",CE.key,CE.name)
		self:SetCombat(oa.combatstop,"PLAYER_REGEN_ENABLED","CombatStop")
		self:SetCombat(oa.combatstart,"PLAYER_REGEN_DISABLED","CombatStart")
		self:SetDefeat(oa.defeat)
		id = CE.triggers.encounterid or 0
		zoneid = CE.zone or ""
	end

	self:RegisterEvent("ENCOUNTER_START")
	self:RegisterEvent("ENCOUNTER_END")	
	self:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")

	-- For the empty encounter
	self:ShowFirstHW()
	self:LayoutHealthWatchers()
	self.callbacks:Fire("SetActiveEncounter",CE)
end

local EDBids2 = {}
local activeDurations = {}

function addon:ENCOUNTER_START(event, encounterID, name, difficulty, size, success)
	-- event, id, name, difficulty, size
	--print("ENCOUNTER_START",CE.name,encounterID, name, difficulty, size, success)
	--self.callbacks:Fire("ENCOUNTER_START",encounterID, name, difficulty, size, success)
		-- helper
	local function add_data(tbl,info,key)
		if type(info) == "table" then
			-- Info contains ids
			for _,id in ipairs(info) do
				tbl[id] = key
			end
		else
			-- Info is the id
			tbl[info] = key
		end
	end
		
	--local EDBids2 = {}
	for key, data in addon:IterateEDB() do
		if data.triggers then
			local encounterid1 = data.triggers.encounterid
			if encounterid1 then
				add_data(EDBids2,encounterid1,key)
			end
		end
	end

	--for k,v in pairs({encounterID}) do
		--if v then
			--print("EDBids2",EDBids2[encounterID])
			if EDBids2[encounterID] then
				local key = EDBids2[encounterID]	
				--print("EDBids2inside",key)				
				self:SetActiveEncounter(key)
				self:StopEncounter()
				self:StartEncounter()
				--return true
			end
		--end
	--end

	if encounterID then
		activeDurations[encounterID] = GetTime()
		
		local sDB = DXEDB
		if not sDB[zoneid] then sDB[zoneid] = {} end
		if not sDB[zoneid][encounterID] then sDB[zoneid][encounterID] = {} end
		sDB = sDB[zoneid][encounterID]
		if not sDB[difficulty] then sDB[difficulty] = {} end
		if sDB[difficulty].best and pfl.Kills.KEnabled then
			addon.Alerts:Dropdown("FastKillBestTime",L.alert["Fastest Kill"],sDB[difficulty].best,10,nil,pfl.Kills.BarCrl,nil,nil,"Interface\\Icons\\spell_holy_borrowedtime")
		end
	end
end
function addon:ENCOUNTER_END(event,encounterID, name, difficulty, size, success)
	--print("ENCOUNTER_END",CE.name,encounterID, name, difficulty, size, success)  --   success = 1(win), success = 0(wipe)
	--[[if EDBids2[encounterID] then 
		print("encounterID")
	end--]]
	--self.callbacks:Fire("ENCOUNTER_END",encounterID, name, difficulty, size, success)
	if self:IsRunning() then
		self:StopEncounter()
		addon.Alerts:QuashByPattern("^invoker")
		addon.Alerts:QuashByPattern("^raidauras")
		addon.Alerts:QuashByPattern("^handler")		
		addon.Alerts:QuashByPattern("FastKillBestTime")
	end
	
	if success == 0 and pfl.RespawnBar.Enabled and CE.respawntime then
		addon.Alerts:CenterPopup("respawn_RespawnTime",L.alert["Respawn"],CE.respawntime,10,nil,pfl.RespawnBar.BarColor,nil,nil,"Interface\\Icons\\spell_holy_borrowedtime")
	end
	
	--if not activeDurations[encounterID] then return end
	
	if pfl.Kills.KEnabled and encounterID and activeDurations[encounterID] then
		local elapsed = GetTime()-activeDurations[encounterID]
		local sDB = DXEDB[zoneid][encounterID][difficulty]
		local tmp
		
		if success == 1 then
			sDB.kills = sDB.kills and sDB.kills + 1 or 1
			--print("EncounterEnd",elapsed,SecondsToTime(elapsed))
			if pfl.Kills.ShowKill then
				tmp = L["Defeated %s' after %s"]:format(CE.name, SecondsToTime(elapsed))
				addon:Print(tmp)
			end
			if pfl.Kills.ShowBestKill and (not sDB.best or elapsed < sDB.best) then
				if sDB.best then
					tmp = ("%s (-%s)"):format(L["New best time!"], SecondsToTime(sDB.best-elapsed))
					addon:Print(tmp)
				end
				sDB.best = elapsed
			end
			if pfl.Kills.ShowKillCount then
				tmp = ("%s: %s"):format(L["Total kill count"], sDB.kills)
				addon:Print(tmp)
			end
		else
			if elapsed > 30 then
				sDB.wipes = sDB.wipes and sDB.wipes + 1 or 1
				if pfl.Kills.ShowWipe then
					tmp = L["Wiped on %s' after %s"]:format(CE.name, SecondsToTime(elapsed))
					addon:Print(tmp)
				end
				if pfl.Kills.ShowWipeCount then
					tmp = ("%s: %s"):format(L["Total wipe count"], sDB.wipes)
					addon:Print(tmp)
				end
			end
		end
	end
	activeDurations[encounterID] = nil
end
--Backup method to detect combat start (should eventually replace combatstart)
function addon:INSTANCE_ENCOUNTER_ENGAGE_UNIT()
	if not self:IsRunning() then
		--print("INSTANCE_ENCOUNTER_ENGAGE_UNIT NOT RUNNING")
		addon:Engaged()
	end
end

function addon:Engaged()
	--if not CE then return end
	
	--if self:IsRunning() then return end
	--if CE.onactivate.encounterid ~= nil and self:IsRunning() then return end
	
	-- Get any boss' name
	local boss1 = UnitName("boss1")
	local boss2 = UnitName("boss2")
	local boss3 = UnitName("boss3")
	local boss4 = UnitName("boss4")
	local boss5 = UnitName("boss5")
	
	if CE.bypassstartid then
		local encounterID = CE.bypassstartid
		activeDurations[encounterID] = GetTime()
	end
	--print("instance:",CE.name,boss1)
	-- we have a correct active encounter so start the CE
	if (CE.name == boss1 or  CE.name == boss2 or CE.name == boss3 or CE.name == boss4 or CE.name == boss5) and not self:IsRunning() then
		self:StartEncounter()
		--print("INSTANCE_ENCOUNTER_ENGAGE_UNIT","CE",CE.name,"was good and started")
		--[===[@debug@
		debug("INSTANCE_ENCOUNTER_ENGAGE_UNIT","CE %s was good and started",CE.name)
		--@end-debug@]===]
	-- we don't have a CE or wrong CE, so we need to compare the npcid from bossX to the scan ids in Encounters.lua
	elseif not self:IsRunning() and (CE.name ~= boss1 and CE.name ~= boss2 and CE.name ~= boss3 and CE.name ~= boss4 or CE.name ~= boss5) or not CE or CE.key == "default" then
		--[===[@debug@
		debug("INSTANCE_ENCOUNTER_ENGAGE_UNIT","no running and no CE")
		--@end-debug@]===]

		-- helper
		local function add_data(tbl,info,key)
			if type(info) == "table" then
				-- Info contains ids
				for _,id in ipairs(info) do
					tbl[id] = key
				end
			else
				-- Info is the id
				tbl[info] = key
			end
		end

		local id1,id2,id3,id4,id5
		if boss1 then id1 = addon:ReturnUnitID(UnitGUID("boss1")) end
		if boss2 then id2 = addon:ReturnUnitID(UnitGUID("boss2")) end
		if boss3 then id3 = addon:ReturnUnitID(UnitGUID("boss3")) end
		if boss4 then id4 = addon:ReturnUnitID(UnitGUID("boss4")) end
		if boss5 then id5 = addon:ReturnUnitID(UnitGUID("boss5")) end
		--print("not running, boss 1 id is:",id1)

		--[===[@debug@
		debug("INSTANCE_ENCOUNTER_ENGAGE_UNIT","ids1-4: %s %s %s %s",id1,id2,id3,id4)
		--@end-debug@]===]

		local EDBids = {}
		for key, data in addon:IterateEDB() do
			if data.triggers then
				local scan = data.triggers.scan
				if scan then
					add_data(EDBids,scan,key)
				end
			end
		end

		for k,v in pairs({id1,id2,id3,id4,id5}) do
			if v then
				if EDBids[v] then
					local key = EDBids[v]			
					self:SetActiveEncounter(key)
					self:StopEncounter()
					self:StartEncounter()
					return true
				end
			end
		end
	end
end
function addon:UNIT_TARGET(event,unit)
	local guid = UnitGUID(unit.."target")

	local function add_data(tbl,info,key)
		if type(info) == "table" then
			-- Info contains ids
			for _,id in ipairs(info) do
				tbl[id] = key
			end
		else
			-- Info is the id
			tbl[info] = key
		end
	end	
		
	if guid then
		local _, _, _, _, _, id = strsplit("-", guid)
		local mobId = tonumber(id)

		local EDBids3 = {}
		for key, data in addon:IterateEDB() do
			if data.triggers then
				local scan = data.triggers.scan
				if scan then
					add_data(EDBids3,scan,key)
				end
			end
		end

		if EDBids3[mobId] then
			local key = EDBids3[mobId]			
			self:SetActiveEncounter(key)
			--self:UnregisterEvent("UNIT_TARGET")
			--if InCombatLockdown() or UnitAffectingCombat("player") and not self:IsRunning() then
				--	self:StopEncounter()
				--	self:StartEncounter()
			--end
			--self:StopEncounter()
			--self:StartEncounter()
		end		
	end
end
-- Start the current encounter
function addon:StartEncounter(...)
	if self:IsRunning() then return end
	if killtime and GetTime() - killtime < (CE.onactivate.delayrecombat or 10) then return end
	CombatLogClearEntries()
	
	self:ToggleRaidBossEmoteFrame(1)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("RAID_BOSS_WHISPER")
	--self:UnregisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
	self.callbacks:Fire("StartEncounter",...)
	self:StartTimer()
	self:StartSortedTracing()
	self:UpdatePaneVisibility()
	self:PauseScanning()
end

-- Stop the current encounter
function addon:StopEncounter()
	if not self:IsRunning() then return end
	--self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	--self:RegisterEvent("UNIT_TARGET")
	self:UnregisterEvent("RAID_BOSS_WHISPER")
	self.callbacks:Fire("StopEncounter")
	killtime = GetTime()
	self:ToggleRaidBossEmoteFrame(0)
	self:ClearSortedTracing()
	self:StopSortedTracing()
	self:StopTimer()
	self:UpdatePaneVisibility()
	self:ResumeScanning()
	self:ResetDefeatTbl()
end
function addon:WipeEncounter()
	-- Wiped
	--print("WipeEncounter")
	self.callbacks:Fire("WipeEncounter")
end
do
	local function iter(t,i)
		local k,v = next(t,i)
		if k == "default" then return next(t,k)
		else return k,v end
	end

	function addon:IterateEDB()
		return iter,EDB
	end
end

---------------------------------------------
-- ROSTER
---------------------------------------------
local Roster = {}
addon.Roster = Roster
local rID,pID = {},{}
do
	for i=1,40 do
		rID[i] = "raid"..i
		if i <= 5 then
			pID[i] = "party"..i
		end
	end
end

local targetof = setmetatable({},{
	__index = function(t,k)
		if type(k) ~= "string" then return end
		t[k] = k.."target"
		return t[k]
	end
})
addon.targetof = targetof

local class_color = {}
for class,color in pairs(RAID_CLASS_COLORS) do
	class_color[class] = ("|cff%02x%02x%02x"):format(color.r * 255, color.g * 255, color.b * 255)
end

local refreshFuncs = {
	name_to_unit = function(t,id)
		t[UnitName(id)] = id
	end,
	guid_to_unit = function(t,id)
		local guid = id == "player" and addon.PGUID or UnitGUID(id)
		t[guid] = id
	end,
	unit_to_unittarget = function(t,id)
		t[id] = targetof[id]
	end,
	name_to_class = function(t,id)
		--text = text.." "..class_color[class]..name.."|r"
		--t[UnitName(id)] = class_color[select(2,UnitClass(id))]
		--if not id then return end
		t[UnitName(id)] = select(2,UnitClass(id))
	end,
}

for k in pairs(refreshFuncs) do
	Roster[k] = {}
end

local numOnline = 0
local numMembers = 0
local prevGroupType = "NONE"
local RosterHandle
addon.GroupType = "NONE"
--[[
function addon:GetPartyType()
	return ((select(2, IsInInstance()) == "PVP" and "BATTLEGROUND") 
	or (select(2, IsInInstance()) == "ARENA" and "BATTLEGROUND") 
	or (GetNumGroupMembers() > 5 and "RAID") 
	or (GetNumSubgroupMembers() > 0 and "PARTY") 
	or "NONE")
end--]]
function addon:GROUP_ROSTER_UPDATE()
	--[===[@debug@
	debug("GROUP_ROSTER_UPDATE","Invoked")
	--@end-debug@]===]

	--local tmpOnline,tmpMembers = 0, GetNumGroupMembers()
	local tmpOnline = 0
	local tmpMembers = GetNumGroupMembers()
	--addon.GroupType = self:GetPartyType()
	--print("group roster",addon.GroupType)
	--if tmpMembers > 0 then
	if IsInRaid() then
		addon.GroupType = "RAID"
		--self.Pane.dificulty:SetDificulty(1)
	else
		--tmpMembers = GetNumSubgroupMembers() -- only party without player
		addon.GroupType = tmpMembers > 0 and "PARTY" or "NONE"
		--self.Pane.dificulty:SetDificulty(2)
	end

	-- Switches to default if we leave a group
	if prevGroupType ~= "NONE" and addon.GroupType == "NONE" then
		self:UnregisterEvent("UNIT_TARGET")
		self:SetActiveEncounter("default")
		self.Pane.dificulty:SetDificulty(0)
	end
	prevGroupType = addon.GroupType

	if not RosterHandle and tmpMembers > 0 then
		-- Refresh roster tables every half minute to detect offline players
		RosterHandle = self:ScheduleRepeatingTimer("GROUP_ROSTER_UPDATE",30)
	elseif tmpMembers == 0 then
		self:CancelTimer(RosterHandle,true)
		RosterHandle = nil
	end

	for k,t in pairs(Roster) do
		wipe(t)
		refreshFuncs[k](t,"player")
	end

	if addon.GroupType == "RAID" then
		for i=1,tmpMembers do
			local name, rank, _, _, _, _, _, online = GetRaidRosterInfo(i)
			if online then
				local unit = rID[i]
				tmpOnline = tmpOnline + 1
				for k,t in pairs(Roster) do
					refreshFuncs[k](t,unit)
				end
			end
		end
	elseif addon.GroupType == "PARTY" then
		--self.Pane.dificulty:SetDificulty(2)
		for i=1,tmpMembers do
			local name,online = UnitName(pID[i]),UnitIsConnected(pID[i])
			if online then
				local unit = pID[i]
				--[===[@debug@
				debug("GROUP_ROSTER_UPDATE","name: %s unit: %s guid: %s",name,unit,UnitGUID(unit))
				--@end-debug@]===]
				--print("Party debug ",name,unit,UnitGUID(unit),tmpMembers)
				tmpOnline = tmpOnline + 1
				for k,t in pairs(Roster) do
					refreshFuncs[k](t,unit)
				end
			end
		end
	end

	--- Number of member differences

	if tmpMembers ~= numMembers then
		self:UpdatePaneVisibility()
		self:RefreshVersionList()
	end

	numMembers = tmpMembers

	if tmpOnline < numOnline then
		self:CleanVersions()
	end

	numOnline = tmpOnline
end

function addon:IsPromoted()
	return UnitIsGroupLeader("player") or UnitIsGroupAssistant("player")
end

function addon:VehicleNames()
	local names = {}
	for name in pairs(Roster.name_to_unit) do
		if UnitInVehicle(name) then
			names[#names+1] = name
		end
	end
	return names
end

---------------------------------------------
-- TRIGGERING
---------------------------------------------

local TRGS_NPCID = {} -- NPC ids activations. Source: data.triggers.scan
local TRGS_ENCOUNTERID = {} -- ENCOUNTER ids activations. Source: data.triggers.encounterid
local TRGS_YELL = {} -- Yell activations. Source: data.triggers.yell
local TRGS_EMOTE = {} -- Emote activations. Source: data.triggers.emote
do
	local function add_data(tbl,info,key)
		if type(info) == "table" then
			-- Info contains ids
			for _,id in ipairs(info) do
				tbl[id] = key
			end
		else
			-- Info is the id
			tbl[info] = key
		end
	end

	local function BuildTriggerLists()
		local zone = GetRealZoneText()
		local scanFlag,yellFlag,emoteFlag,encounteridFlag = false,false,false,false
		
		for key, data in addon:IterateEDB() do
		--print("AQWE",zone,data.zone,data.triggers,data.triggers.scan)
			if data.zone == zone then
				if data.triggers then
					local scan = data.triggers.scan
					if scan then
						add_data(TRGS_NPCID,scan,key)
						scanFlag = true
					end
					local encounterid = data.triggers.encounterid
					if encounterid then
						add_data(TRGS_ENCOUNTERID,encounterid,key)
						encounteridFlag = true
					end					
					local yell = data.triggers.yell
					if yell then
						add_data(TRGS_YELL,yell,key)
						yellFlag = true
					end
					local emote = data.triggers.emote
					if emote then
						add_data(TRGS_EMOTE,emote,key)
						emoteFlag = true
					end
				end
			end
		end
		return scanFlag, yellFlag, emoteFlag,encounteridFlag
	end

	local ScanHandle
	function addon:PauseScanning()
		if ScanHandle then self:CancelTimer(ScanHandle); ScanHandle = nil end
	end

	function addon:ResumeScanning()
		if not ScanHandle then ScanHandle = self:ScheduleRepeatingTimer("ScanUpdate",5) end
	end

	function addon:UpdateTriggers()
		-- Clear trigger tables
		wipe(TRGS_NPCID)
		wipe(TRGS_ENCOUNTERID)
		wipe(TRGS_YELL)
		self:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		wipe(TRGS_EMOTE)
		self:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		self:CancelTimer(ScanHandle,true)
		ScanHandle = nil
		
		-- Build trigger lists
		local scan, yell, emote, encounterid = BuildTriggerLists()
		self.TriggerZone = scan or yell or emote
		-- Start invokers
		if scan then ScanHandle = self:ScheduleRepeatingTimer("ScanUpdate",5) end
		if yell then self:RegisterEvent("CHAT_MSG_MONSTER_YELL") end
		if emote then self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE") end
	end
	addon:ThrottleFunc("UpdateTriggers",1,true)
end

function addon:Scan()
	for _,unit in pairs(Roster.unit_to_unittarget) do
		if UnitExists(unit) then
			local guid = UnitGUID(unit)
			local npcid = NID[guid]
			--print("Scan:",TRGS_NPCID[npcid])
			if TRGS_NPCID[npcid] and not UnitIsDead(unit) then
				--print("Scan TRGS_NPCID:",TRGS_NPCID[npcid])
				return TRGS_NPCID[npcid]
			else
				--print("Scan:",UnitName(unit))
				return UnitName(unit)
			end
		end
	end
end

function addon:ScanUpdate()
	local key = self:Scan()
	if key then self:SetActiveEncounter(key) end
end

function addon:ScanStart(encounterID)
	--local guid = UnitGUID(unit)
	--local npcid = NID[guid]
	if TRGS_ENCOUNTERID[encounterID] then
		---print("Scan TRGS_ENCOUNTERID:",TRGS_ENCOUNTERID[encounterID])
		return TRGS_ENCOUNTERID[encounterID]
	else
		--print("ScanStart:",encounterID)
	end
end
---------------------------------------------
-- PLAYER CONSTANTS
---------------------------------------------

function addon:SetPGUID(n)
	if n == 0 then return end
	self.PGUID = UnitGUID("player")
	if not self.PGUID then self:ScheduleTimer("SetPGUID",1,n-1) end
end
function addon:SetPNAME(n)
	if n == 0 then return end
	self.PNAME = UnitName("player")
	if not self.PNAME then self:ScheduleTimer("SetPNAME",1,n-1) end
end
function addon:SetUnitClass(n)
	if n == 0 then return end
	self.UnitClass = UnitClass("player")
	if not self.UnitClass then self:ScheduleTimer("SetUnitClass",1,n-1) end
end

function addon:SetPlayerConstants()
	self.PGUID = UnitGUID("player")
	self.PNAME = UnitName("player")
	self.UnitClass = UnitClass("player")
	-- Just to be safe
	if not self.PGUID then self:ScheduleTimer("SetPGUID",1,5) end
	if not self.PNAME then self:ScheduleTimer("SetPNAME",1,5) end
	if not self.UnitClass then self:ScheduleTimer("SetUnitClass",1,5) end
end

---------------------------------------------
-- GENERIC EVENTS
---------------------------------------------

function addon:PLAYER_ENTERING_WORLD()
	self:UpdatePaneVisibility()
	self:UpdateTriggers()
	self:StopEncounter()
end

---------------------------------------------
-- WARNING BLOCKS
-- Credits: BigWigs
---------------------------------------------

local forceBlockDisable

function addon:AddMessageFilters()
	local OTHER_BOSS_MOD_PTN = "%*%*%*"
	local OTHER_BOSS_MOD_PTN2 = "DBM"
	local OTHER_BOSS_MOD_PTN3 = "<BW>"

	local RaidWarningFrame_OnEvent = RaidWarningFrame:GetScript("OnEvent")
	RaidWarningFrame:SetScript("OnEvent", function(self,event,msg,...)
		if not forceBlockDisable and pfl.Misc.BlockRaidWarningFrame and
			type(msg) == "string" and (find(msg,"^Pull in %d sec$") or find(msg,"Pull now!")) then
			-- Do nothing
		else
			return RaidWarningFrame_OnEvent(self,event,msg,...)
		end
	end)

	local function OTHER_BOSS_MOD_FILTER(self,event,msg)
		if not forceBlockDisable and pfl.Misc.BlockRaidWarningMessages
			and type(msg) == "string" and (find(msg,OTHER_BOSS_MOD_PTN) or find(msg,OTHER_BOSS_MOD_PTN2) or find(msg,OTHER_BOSS_MOD_PTN3) or find(msg,"^Pull in %d sec$") or find(msg,"Pull now!")) then
			return true
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", OTHER_BOSS_MOD_FILTER)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", OTHER_BOSS_MOD_FILTER)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", OTHER_BOSS_MOD_FILTER)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", OTHER_BOSS_MOD_FILTER)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT", OTHER_BOSS_MOD_FILTER)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT_LEADER", OTHER_BOSS_MOD_FILTER)	

	self.AddMessageFilters = nil
end
function addon:ToggleRaidBossEmoteFrame(option)
	if option == 1 then
		if pfl.Misc.BlockBossEmoteFrame then RaidBossEmoteFrame:UnregisterEvent("RAID_BOSS_EMOTE") end
		if pfl.Misc.BlockBossEmoteMessages then RaidBossEmoteFrame:UnregisterEvent("RAID_BOSS_WHISPER") end
		if pfl.Misc.BlockGarrison then 
			AlertFrame:UnregisterEvent("GARRISON_MISSION_FINISHED")
			AlertFrame:UnregisterEvent("GARRISON_BUILDING_ACTIVATABLE")
			AlertFrame:UnregisterEvent("GARRISON_FOLLOWER_ADDED")
			AlertFrame:UnregisterEvent("GARRISON_RANDOM_MISSION_ADDED")
		end
		if pfl.Misc.BlockGuildChallenge then AlertFrame:UnregisterEvent("GUILD_CHALLENGE_COMPLETED") end
	elseif option == 0 then
		if pfl.Misc.BlockBossEmoteFrame then RaidBossEmoteFrame:RegisterEvent("RAID_BOSS_EMOTE") end
		if pfl.Misc.BlockBossEmoteMessages then RaidBossEmoteFrame:RegisterEvent("RAID_BOSS_WHISPER") end
		if pfl.Misc.BlockGarrison then 
			AlertFrame:RegisterEvent("GARRISON_MISSION_FINISHED")
			AlertFrame:RegisterEvent("GARRISON_BUILDING_ACTIVATABLE")
			AlertFrame:RegisterEvent("GARRISON_FOLLOWER_ADDED")
			AlertFrame:RegisterEvent("GARRISON_RANDOM_MISSION_ADDED")			
		end
		if pfl.Misc.BlockGuildChallenge then AlertFrame:RegisterEvent("GUILD_CHALLENGE_COMPLETED") end
	end
end
---------------------------------------------
-- Movie Blocker
-- Credits: BigWigs
---------------------------------------------
local knownMovies = {
	[16] = true, -- Lich King death
	[73] = true, -- Ultraxion death
	[74] = true, -- DeathwingSpine engage
	[75] = true, -- DeathwingSpine death
	[76] = true, -- DeathwingMadness death
	[152] = true, -- Garrosh defeat
}
function addon:PLAY_MOVIE(_, id)
	if pfl.Misc.BlockMovies then
		if knownMovies[id] then
			if gbl.seenmovies[id] then
				addon:Print(L.alert["You've seen this movie before and has been skipped. You can disable it at Options->Miscellaneous."])
				MovieFrame:Hide()
			else
				gbl.seenmovies[id] = true
			end
		end
	end
end
	
local cinematicZones = {
	["800:1"] = true, -- Firelands bridge lowering
	["875:1"] = true, -- Gate of the Setting Sun gate breach
	["930:3"] = true, -- Tortos cave entry -- Doesn't work, apparently Blizzard don't want us to skip this..?
	["930:7"] = true, -- Ra-Den room opening
	["953:2"] = true, -- After Immerseus, entry to Fallen Protectors
	["953:8"] = true, -- Blackfuse room opening, just outside the door
	["953:9"] = true, -- Blackfuse room opening, in Thok area
	["953:12"] = true, -- Mythic Garrosh Phase 4
	["964:1"] = true, -- Bloodmaul Slag Mines, activating bridge to Roltall
	["969:2"] = true, -- Shadowmoon Burial Grounds, final boss introduction
	["984:1"] = {false, -1, true}, -- Auchindoun has 2 cinematics. One before the 1st boss (false) and one after the 3rd boss (true), 2nd arg is garbage for the iterator to work.
	["993:2"] = true, -- Grimrail Depot, boarding the train
	["993:4"] = true, -- Grimrail Depot, destroying the train
	["994:3"] = true, -- Highmaul, Kargath Death
}
function addon:CINEMATIC_START()
	if pfl.Misc.BlockMovies then
		SetMapToCurrentZone()

		local areaId = GetCurrentMapAreaID() or 0
		local areaLevel = GetCurrentMapDungeonLevel() or 0
		local id = tonumber(("%d.%d"):format(areaId, areaLevel))

		if cinematicZones[id] then
			if type(cinematicZones[id]) == "table" then
				if not gbl.seenmovies[id] then gbl.seenmovies[id] = {} end
				for i=#cinematicZones[id], 1, -1 do
					local _, _, done = C_Scenario.GetCriteriaInfoByStep(1,i)
					if done == cinematicZones[id][i] then
						if gbl.seenmovies[id][i] then
							self:Print(L.alert["You've seen this movie before and has been skipped. You can disable it at Options->Miscellaneous."])
							CinematicFrame_CancelCinematic()
						else
							gbl.seenmovies[id][i] = true
						end
						return
					end
				end
			else
				if gbl.seenmovies[id] then
					self:Print(L.alert["You've seen this movie before and has been skipped. You can disable it at Options->Miscellaneous."])
					CinematicFrame_CancelCinematic()
				else
					gbl.seenmovies[id] = true
				end
			end
		end
	end
end
---------------------------------------------
-- MotD
---------------------------------------------
function addon:DisplayMOTD()
	local really = false
	if not really then return end

	local lastv = gbl.motd_read_v
	local motd_text = "This is the alpha version for Patch 6.2.0. Highmaul and Blackrock Foundry encounters are included, expect to see some errors."	
	local motd = format("|cff99ff33DXE Information|r\n Welcome to DXE v%s.\n\n %s \n\n This message will only display once.",addon.version,motd_text)
	if not lastv or lastv < addon.version then
		StaticPopupDialogs["DXE_MOTD"] = {
		text = "%s",
		button1 = "ok",
		OnAccept = function()
			gbl.motd_read_v = addon.version
			return
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
		}
		StaticPopup_Show("DXE_MOTD",motd)
	end
end

---------------------------------------------
-- MAIN
---------------------------------------------


-- Replace default Print
local print,format = print,string.format
function addon:Print(s)
	print(format("|cff99ff33DXE|r: %s",s or "")) -- 0.6, 1, 0.2
end

do
	local funcs = {}
	function addon:AddToRefreshProfile(func)
		--[===[@debug@
		assert(type(func) == "function")
		--@end-debug@]===]
		funcs[#funcs+1] = func
	end

	function addon:RefreshProfilePointers()
		for k,func in ipairs(funcs) do func(db) end
	end

	function addon:RefreshProfile()
		pfl = db.profile
		-- Has to go before pointers are refreshed
		self:LoadAllScales()
		self:LoadAllDimensions()

		self:RefreshProfilePointers()

		self:LoadAllPositions()
		self.Pane:SetScale(pfl.Pane.Scale)
		self:LayoutHealthWatchers()
		self:SkinPane()
		self:UpdatePaneVisibility()

		self[pfl.Enabled and "Enable" or "Disable"](self)
	end
end

-- Initialization
function addon:OnInitialize()
	Initialized = true

	-- Database
	self.db = LibStub("AceDB-3.0"):New("DXEDB",self.defaults)
	if LDS then LDS:EnhanceDatabase(self.db,"DXE") end
	
	db = self.db
	gbl,pfl = db.global,db.profile

	self:RefreshProfilePointers()

	-- Options
	db.RegisterCallback(self, "OnProfileChanged", "RefreshProfile")
	db.RegisterCallback(self, "OnProfileCopied", "RefreshProfile")
	db.RegisterCallback(self, "OnProfileReset", "RefreshProfile")

	--[===[@debug@
	debug = self:CreateDebugger("Core",gbl,debugDefaults)
	--@end-debug@]===]

	-- Received database
	RDB = self.db:RegisterNamespace("RDB", {global = {}}).global
	self.RDB = RDB

	-- Pane
	self:CreatePane()
	self:SkinPane()

	self:SetupSlashCommands()

	-- The default encounter
	self:RegisterEncounter({key = "default", name = L["Default"], title = L["Default"]})
	self:SetActiveEncounter("default")

	--[===[@debug@
	-- Register addon/received encounter data
	for key,data in pairs(RegisterQueue) do
		if RDB[key] and RDB[key].version > data.version then
			self:RegisterEncounter(RDB[key])
		else
			self:RegisterEncounter(data)
			RDB[key] = nil
		end

		RegisterQueue[key] = nil
	end
	--@end-debug@]===]

	-- The rest that don't exist
	for key,data in pairs(RDB) do
		-- nil out old RDB data that uses data.name as the key
		if key:find("[A-Z]") then
			RDB[key] = nil
		elseif not EDB[key] then
			self:RegisterEncounter(data)
		end
	end

	RegisterQueue = nil

	self:AddMessageFilters()

	self:SetEnabledState(pfl.Enabled)
	--self:Print(L["Loaded - Type |cffffff00/dxe|r for slash commands"])
	self:Print(L["Loaded - |cffffff00/dxe|r Opens the configuration"])
	self.OnInitialize = nil
end

function addon:OnEnable()
	-- Patch to refresh Pane texture
	self:NotifyAllMedia()
	
	forceBlockDisable = false
	self:SetPlayerConstants()
	self:UpdateTriggers()
	addon:UpdateLock()
	self:LayoutHealthWatchers()

	-- Events
	self:RegisterEvent("GROUP_ROSTER_UPDATE")
	self:GROUP_ROSTER_UPDATE()
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA","UpdateTriggers")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("CINEMATIC_START")
	self:RegisterEvent("PLAY_MOVIE")

	self:SetActiveEncounter("default")
	self:EnableAllModules()
	self:RegisterComm("DXE")
	self:UpdatePaneVisibility()
	self:BroadcastAllVersions()
	self:RegisterEvent("UNIT_TARGET")
	self:DisplayMOTD()
end

function addon:OnDisable()
	forceBlockDisable = true
	self:UpdateLockedFrames("Hide")
	self:StopEncounter()
	self:SetActiveEncounter("default")
	self.Pane:Hide()
	self:DisableAllModules()
	RosterHandle = nil
	self:UnregisterEvent("CINEMATIC_START")
	self:UnregisterEvent("PLAY_MOVIE")	
end

function addon:RefreshDefaults()
	self.db:RegisterDefaults(defaults)
end

---------------------------------------------
-- SCALES
---------------------------------------------

do
	local frameNames = {}

	function addon:SaveScale(f)
		pfl.Scales[f:GetName()] = f:GetScale()
	end

	-- Used after the profile is changed
	function addon:LoadAllScales()
		for name in pairs(frameNames) do
			self:LoadScale(name)
		end
	end

	function addon:LoadScale(name)
		local f = _G[name]
		if not f then return end
		frameNames[name] = true
		f:SetScale(pfl.Scales[name] or 1)
	end

	function addon:RegisterDefaultScale(f)
		defaults.profile.Scales[f:GetName()] = f:GetScale()
		self:RefreshDefaults()
	end
end

---------------------------------------------
-- DIMENSIONS
---------------------------------------------

do
	local frameNames = {}

	function addon:SaveDimensions(f)
		local name = f:GetName()
		local dims = pfl.Dimensions[name]
		dims.width = f:GetWidth()
		dims.height = f:GetHeight()
	end

	-- Used after the profile is changed
	function addon:LoadAllDimensions()
		for name in pairs(frameNames) do
			self:LoadDimensions(name)
		end
	end

	function addon:LoadDimensions(name)
		local f = _G[name]
		if not f then return end
		frameNames[name] = true
		local dims = pfl.Dimensions[name]
		if not dims then
			pfl.Dimensions[name] = {
				width = f:GetWidth(),
				height = f:GetHeight(),
			}
		else
			f:SetWidth(dims.width)
			f:SetHeight(dims.height)
		end
	end

	function addon:RegisterDefaultDimensions(f)
		local dims = {}
		dims.width = f:GetWidth()
		dims.height = f:GetHeight()
		defaults.profile.Dimensions[f:GetName()] = dims
		self:RefreshDefaults()
	end
end

---------------------------------------------
-- POSITIONING
---------------------------------------------

do
	local frameNames = {}

	function addon:SavePosition(f)
		local point, relativeTo, relativePoint, xOfs, yOfs = f:GetPoint()
		local name = f:GetName()
		local pos = pfl.Positions[name]
		pos.point = point
		pos.relativeTo = relativeTo and relativeTo:GetName()
		pos.relativePoint = relativePoint
		pos.xOfs = xOfs
		pos.yOfs = yOfs
		f:SetUserPlaced(false)
	end

	-- Used after the profile is changed
	function addon:LoadAllPositions()
		for name in pairs(frameNames) do
			self:LoadPosition(name)
		end
	end

	function addon:LoadPosition(name)
		local f = _G[name]
		if not f then return end
		frameNames[name] = true
		f:ClearAllPoints()
		local pos = pfl.Positions[name]
		if not pos then
			f:SetPoint("CENTER",UIParent,"CENTER",0,0)
			pfl.Positions[name] = {
				point = "CENTER",
				relativeTo = "UIParent",
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0,
			}
		else
			f:SetPoint(pos.point,_G[pos.relativeTo] or UIParent,pos.relativePoint,pos.xOfs,pos.yOfs)
		end
	end

	local function StartMovingShift(self)
		if IsShiftKeyDown() then
			if self.__redirect then
				self.__redirect:StartMoving()
			else
				self:StartMoving()
			end
		end
	end

	local function StartMoving(self)
		if self.__redirect then
			self.__redirect:StartMoving()
		else
			self:StartMoving()
		end
	end

	local function StopMoving(self)
		if self.__redirect then
			self.__redirect:StopMovingOrSizing()
			addon:SavePosition(self.__redirect)
		else
			self:StopMovingOrSizing()
			addon:SavePosition(self)
		end
	end

	-- Registers saving positions in database
	function addon:RegisterMoveSaving(frame,point,relativeTo,relativePoint,xOfs,yOfs,withShift,redirect)
		--[===[@debug@
		assert(type(frame) == "table","expected 'frame' to be a table")
		assert(frame.IsObjectType and frame:IsObjectType("Region"),"'frame' is not a blizzard frame")
		if redirect then
			assert(type(redirect) == "table","expected 'redirect' to be a table")
			assert(redirect.IsObjectType and redirect:IsObjectType("Region"),"'frame' is not a blizzard frame")
		end
		--@end-debug@]===]
		frame.__redirect = redirect
		if withShift then
			frame:SetScript("OnMouseDown",StartMovingShift)
		else
			frame:SetScript("OnMouseDown",StartMoving)
		end
		frame:SetScript("OnMouseUp",StopMoving)

		-- Add default position
		local pos = {
			point = point,
			relativeTo = relativeTo,
			relativePoint = relativePoint,
			xOfs = xOfs,
			yOfs = yOfs,
		}

		defaults.profile.Positions[redirect and redirect:GetName() or frame:GetName()] = pos
		self:RefreshDefaults()
	end
end

---------------------------------------------
-- TOOLTIP TEXT
---------------------------------------------

do
	local function OnEnter(self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		if self._ttTitle then GameTooltip:AddLine(self._ttTitle,nil,nil,nil,true) end
		if self._ttText then GameTooltip:AddLine(self._ttText,1,1,1,true) end
		GameTooltip:Show()
	end

	local function OnLeave(self)
		GameTooltip:Hide()
	end

	function addon:AddTooltipText(obj,title,text)
		obj._ttTitle = title
		obj._ttText = text
		obj:HookScript("OnEnter",OnEnter)
		obj:HookScript("OnLeave",OnLeave)
	end
end

---------------------------------------------
-- CONFIG
---------------------------------------------

function addon:ToggleConfig()
	if not addon.Options then
		if select(6,GetAddOnInfo("DXE_Options")) == "MISSING" then self:Print((L["Missing %s"]):format("DXE_Options")) return end
		if not IsAddOnLoaded("DXE_Options") then self.Loader:Load("DXE_Options") end
	end
	addon.Options:ToggleConfig()
end

---------------------------------------------
-- COMMS
---------------------------------------------

function addon:SendWhisperComm(target,commType,...)
	--[===[@debug@
	assert(type(target) == "string")
	assert(type(commType) == "string")
	--@end-debug@]===]
	self:SendCommMessage("DXE",self:Serialize(commType,...),"WHISPER",target)
end

function addon:SendRaidComm(commType,...)
	--[===[@debug@
	assert(type(commType) == "string")
	--@end-debug@]===]
	if addon.GroupType == "NONE" then return end
	self:SendCommMessage("DXE",self:Serialize(commType,...),addon.GroupType)
end

function addon:OnCommReceived(prefix, msg, dist, sender)
	--print("comm",prefix,msg,dist,sender)
	if (dist ~= "RAID" and dist ~= "INSTANCE_CHAT" and dist ~= "WHISPER") or sender == self.PNAME then return end
	if (dist == "RAID" or dist == "INSTANCE_CHAT" or dist == "PARTY" or dist == "WHISPER") and find(msg,"^DXEVersionRequest") then
		self:WhisperAddonVersion(sender)
	end

	self:DispatchComm(sender, self:Deserialize(msg))
end

function addon:DispatchComm(sender,success,commType,...)
	if success then
		local callback = "OnComm"..commType
		self.callbacks:Fire(callback,commType,sender,...)
	end
end

function addon:WhisperAddonVersion(target)
	local msg = format("DXEVersionReply:%s",tostring(addon.version))
	self:SendCommMessage("DXE",msg,"WHISPER",target)
end

---------------------------------------------
-- ENCOUNTER DEFAULTS
---------------------------------------------

do
	local EncDefaults = {
		alerts = {
			L = L["Bars"],
			order = 100,
			defaultEnabled = true ,
			defaults = {
				color1 = "Clear",
				color2 = "Off",
				sound = "None",
				flashscreen = false,
				counter = false,
				--flashtime = 5,
				audiocd = false,
				audiotime = 5,
				exhealer = false,
				extank = false,
				exdps = false,
				ex25 = false,
				exlfr = false,
				exflex = false,
				exheroic = false,
				exmythic = false,
				exmelee = false,
				exranged = false,
				excaster = false,
				maxplayers = false,
				ability = "",
				biggerbar = false,
				type = "Warning",
				textsize = 0,
				maxplayerssize = 0,
			},
		},
		raidicons = {
			L = L["Raid Icons"],
			order = 200,
			defaultEnabled = true,
			defaults = {
				exlfr = false,
				exflex = false,
				exheroic = false,
				exmythic = false,
			},
		},
		arrows = {
			L = L["Arrows"],
			order = 300,
			defaultEnabled = true,
			defaults = {
				sound = "None",
				exhealer = false,
				extank = false,
				exdps = false,
				--ex25 = false,
				exmelee = false,
				exranged = false,
				excaster = false,
				exlfr = false,
				exflex = false,
				exheroic = false,
				exmythic = false,
			},
		},
		announces = {
			L = L["Announces"],
			order = 400,
			defaultEnabled = true,
			defaults = {
				--player = false,
				type = "SAY",
				flashcolor = "Off",
				sound = "None",
				exhealer = false,
				extank = false,
				exdps = false,
			--	ex25 = false,
				exlfr = false,
				exflex = false,
				exheroic = false,
				exmythic = false,
				exmelee = false,
				exranged = false,
				excaster = false,
				Throttle = 7,
				ReplaceMe = true,
			},
		},
		messages = {
			L = L["Messages"],
			order = 500,
			defaultEnabled = true,
			defaults = {
				color1 = "Clear",
				sound = "None",
				exhealer = false,
				extank = false,
				exdps = false,
				--ex25 = false,
				exlfr = false,
				exflex = false,
				exheroic = false,
				exmythic = false,
				exmelee = false,
				exranged = false,
				excaster = false,
				counter2 = false,
				--exmythic = false,
				maxplayers = false,	
				maxplayerssize = 0,		
				type = "Message",
				textsize = 35,					
			},
		},
		-- always add options
		windows = {
			L = L["Windows"],
			order = 600,
			override = true,
			list = {
				proxwindow = {
					defaultEnabled = false,
					varname = L["Proximity"],
					options = {
						-- var => default value
						proxoverride = false,
						proxrange = 10,
					},
				},
				apbwindow = {
					defaultEnabled = false,
					varname = L["Alternate Power"],
					options = {
						-- var => default value
						apboverride = false,
						apbthreshold = 10,
						apbspellid = 0,
					},
				},
			}
		},
		--[[abilities = {
			L = L["Abilities"],
			order = 700,
			defaultEnabled = true,
			defaults = {},
		}--]]
	}

	addon.EncDefaults = EncDefaults

	function addon:AddEncounterDefaults(data)
		local defaults = {}
		self.defaults.profile.Encounters[data.key] = defaults

		------------------------------------------------------------
		-- Sound upgrading from versions < 375
		if pfl.Encounters[data.key] then
			for var,info in pairs(pfl.Encounters[data.key]) do
				if type(info) == "table" then
					if info.sound and info.sound:find("^DXE ALERT%d+") then
						info.sound = (info.sound:gsub("DXE ",""))
					end
				elseif type(info) == "boolean" then
					-- It should never be a boolean
					pfl.Encounters[data.key][var] = nil
				end
			end
		end
		------------------------------------------------------------

		for optionType,optionInfo in pairs(EncDefaults) do
			local optionData = data[optionType]
			if optionData and not optionInfo.override then
				for var,info in pairs(optionData) do
					defaults[var] = {}
					-- Add setting defaults
					defaults[var].enabled = optionInfo.defaultEnabled

					----------------------------------------------------
					-- Special case
					-- When an alert with type 'simple' is changed to 'centerpopup', color1 can get "stuck" on 'Clear'
					-- Reset color1 if this happens
					if optionType == "alerts" then
						local db = pfl.Encounters[data.key]
						if db and db[var]
							and (info.type == "centerpopup" or info.type == "dropdown" or info.type == "debuff" or info.type == "message")
							and db[var].color1 == "Clear" then
							db[var].color1 = nil
						end
					end
					----------------------------------------------------
					for k,varDefault in pairs(EncDefaults[optionType].defaults) do
						defaults[var][k] = info[k] or varDefault
					end
				end
			end
		end

		for var,winData in pairs(EncDefaults.windows.list) do
			defaults[var] = {}
			if data.windows and data.windows[var] then
				defaults[var].enabled = data.windows[var]
			else
				defaults[var].enabled = winData.defaultEnabled
			end

			-- options
			if winData.options then
				for optvar,value in pairs(winData.options) do
					if data.windows and data.windows[optvar] then
						defaults[var][optvar] = data.windows[optvar]
					else
						defaults[var][optvar] = value
					end
				end
			end
		end
	end
end

---------------------------------------------
-- REGEN START/STOPPING
---------------------------------------------

do
	local dead
	local started = 0

	-- PLAYER_REGEN_ENABLED
	function addon:CombatStop()
		--[===[@debug@
		debug("CombatStop","Invoked")
		--@end-debug@]===]
		--if IsEncounterInProgress() or InCombatLockdown() then
		--	self:ScheduleTimer("CombatStop",4)
		--	return
		local wipe = true

		if IsEncounterInProgress() then
			wipe = true
			for i = 1, 5 do
				if UnitExists("boss"..i) then
					wipe = false
					self:ScheduleTimer("CombatStop",4)
					return
					--break
				end
			end
			if wipe then 
				-- Check for all players
				local uId = (IsInRaid() and "raid") or "party"
				for i = 0, GetNumGroupMembers() do
					local id = (i == 0 and "player") or uId..i
					if UnitAffectingCombat(id) and not UnitIsDeadOrGhost(id) then
						wipe = false -- Someone still in combat. No wipe
						--print("Someone still in combat. No wipe - 1")
						self:ScheduleTimer("CombatStop",4)
						return
						--break
					end
				end	
			end
			if wipe then 
				--print("IsEncounterInProgress but no boss")
				self:StopEncounter()
				self:WipeEncounter()
			end
		elseif UnitHealth("player") > 0 and not UnitAffectingCombat("player") then
			-- If this doesn't work then scan the raid for units in combat
			if dead then
				self:ScheduleTimer("CombatStop",4)
				dead = nil
				return
			end
			local key = self:Scan()
			if not key then
				-- Shouldn't wipe in less than 4 seconds after engaging
				if GetTime() > started + 4 then
					self:StopEncounter()
				else
					self:ScheduleTimer("CombatStop",4)
				end
				return
			end
			if not IsEncounterInProgress() then
				self:StopEncounter()
				--print("reset?")
				return
			end
			self:ScheduleTimer("CombatStop",4)
		elseif UnitIsDeadOrGhost("player") then -- UnitIsDead("player")
			dead = true
			if IsEncounterInProgress() then --or InCombatLockdown()
				wipe = true
				local uId = (IsInRaid() and "raid") or "party"
				for i = 0, GetNumGroupMembers() do
					local id = (i == 0 and "player") or uId..i
					if UnitAffectingCombat(id) and not UnitIsDeadOrGhost(id) then
						wipe = false -- Someone still in combat. No wipe
						--print("Someone still in combat. No wipe - 2")
						self:ScheduleTimer("CombatStop",4)
						return
						--break
					end
				end
				if wipe then 
					--print("UnitIsDeadOrGhost IsEncounterInProgress")
					self:StopEncounter() 
					return
				end
			else
			--	print("stopped")
				self:StopEncounter()
				self:WipeEncounter()
			end
		end
	end
	
	-- PLAYER_REGEN_DISABLED
	function addon:CombatStart(bypass)
		if CE.onactivate.encounterid ~= nil and not bypass then return end

		--if CE.onactivate.delayrecombat then
		if killtime and GetTime() - killtime < (CE.onactivate.delayrecombat or 10) then return end
		--end
		local key = self:Scan()
		--print("started:",key)
		if key then
			started = GetTime()
			self:StartEncounter()
		elseif not key then
			self:GROUP_ROSTER_UPDATE()
			self:ScheduleTimer("CombatStart", 0.5)
		elseif UnitAffectingCombat("player") then
			self:GROUP_ROSTER_UPDATE()
			self:ScheduleTimer("CombatStart", 0.5)
		end
	end
end

---------------------------------------------
-- SHARED EVENTS
---------------------------------------------

function addon:COMBAT_LOG_EVENT_UNFILTERED(_, _,eventtype, _, ...)
	if eventtype ~= "UNIT_DIED" then return end

	local dstGUID = select(5, ...)
	local npcid = NID[dstGUID]

	if not npcid then return end
	
	-- Update HWs
	self:HWDead(npcid)
	
	if not DEFEAT_NID then return end
	if DEFEAT_NID == npcid then
		addon:TriggerDefeat()
	elseif DEFEAT_NIDS and DEFEAT_NIDS[npcid] == false then
		DEFEAT_NIDS[npcid] = true
		local flag = true
		for k,v in pairs(DEFEAT_NIDS) do
			if not v then flag = false; break end
		end
		if flag then addon:TriggerDefeat() end
	end
end

function addon:CHAT_MSG_MONSTER_YELL(_,msg,...)
	if self:IsRunning() then return end
	--[===[@debug@
	debug("CHAT_MSG_MONSTER_YELL",msg,...)
	--@end-debug@]===]
	for fragment,key in pairs(TRGS_YELL) do
		if find(msg,fragment) then
			self:SetActiveEncounter(key)
			self:StopEncounter()
			self:StartEncounter(msg)
		end
	end
end
function addon:CHAT_MSG_RAID_BOSS_EMOTE(_,msg,...)
	if self:IsRunning() then return end
	--[===[@debug@
	debug("CHAT_MSG_RAID_BOSS_EMOTE",msg,...)
	--@end-debug@]===]
	for fragment,key in pairs(TRGS_EMOTE) do
		if find(msg,fragment) then
			self:SetActiveEncounter(key)
			self:StopEncounter()
			self:StartEncounter(msg)
		end
	end
end
function addon:RAID_BOSS_WHISPER(_,msg,...)
	-- better way to sync thanks to bigwigs
	if IsInGroup() then
		local len = msg:len()
		if len < 230 then -- Safety
			SendAddonMessage("Transcriptor", msg, IsInGroup(2) and "INSTANCE_CHAT" or "RAID")		
		end
	end
end
---------------------------------------------
-- SLASH COMMANDS
---------------------------------------------

function addon:SetupSlashCommands()
	DXE_SLASH_HANDLER = function(msg)
		local cmd = msg:match("[^ ]*"):lower()
		if cmd == L["enable"]:lower() then
			addon.db.profile.Enabled = true
			addon:Enable()
			local ACR = LibStub("AceConfigRegistry-3.0",true)
			if ACR then ACR:NotifyChange("DXE") end
		elseif cmd == L["disable"]:lower() then
			addon.db.profile.Enabled = false
			addon:Disable()
			local ACR = LibStub("AceConfigRegistry-3.0",true)
			if ACR then ACR:NotifyChange("DXE") end
		elseif cmd == L["config"]:lower() then
			addon:ToggleConfig()
		elseif cmd == L["version"]:lower() then
			addon:VersionCheck()
		elseif cmd == L["proximity"]:lower() then
			addon:ShowProximity()
		elseif cmd == L["pn"]:lower() then
			local x, y, _, map = UnitPosition("player")
			SetMapToCurrentZone()
			local mapID = GetCurrentMapAreaID()
			local mapx, mapy = GetPlayerMapPosition("player")
			print(("Location Information\nYou are at zone %u (%s): x=%f, y=%f.\nLocal Map ID %u (%s): x=%f, y=%f"):format(map, GetRealZoneText(map), x, y, mapID, GetZoneText(), mapx, mapy))
		else
			addon:ToggleConfig()
			--[[ChatFrame1:AddMessage("|cff99ff33"..L["DXE Slash Commands"].."|r: |cffffff00/dxe|r |cffffd200<"..L["option"]..">|r")
			ChatFrame1:AddMessage(" |cffffd200"..L["enable"].."|r - "..L["Enable addon"])
			ChatFrame1:AddMessage(" |cffffd200"..L["disable"].."|r - "..L["Disable addon"])
			ChatFrame1:AddMessage(" |cffffd200"..L["config"].."|r - "..L["Toggles configuration"])
			ChatFrame1:AddMessage(" |cffffd200"..L["version"].."|r - "..L["Show version check window"])
			ChatFrame1:AddMessage(" |cffffd200"..L["proximity"].."|r - "..L["Show proximity window"])--]]
		end
	end
	self.SetupSlashCommands = nil
end
------------------------------------------------
--- Role Filter/Exclude
------------------------------------------------
local gladStance = GetSpellInfo(156291)
local class 
function addon:IsTank(unit)
	if not unit then class = select(2, UnitClass("player"))
	else class = select(2, UnitClass(unit)) end
	return (class == "WARRIOR" and (GetSpecialization() == 3)and not UnitBuff("player", gladStance))
	or (class == "DEATHKNIGHT" and (GetSpecialization() == 1))
	or (class == "PALADIN" and (GetSpecialization() == 2))
	or (class == "DRUID" and (GetSpecialization() == 3))
	or (class == "MONK" and (GetSpecialization() == 1))
	--else
	--	return GetPartyAssignment("MAINTANK", unit) or UnitGroupRolesAssigned(unit) == "TANK"
	--end
end

function addon:IsHealer(unit)
	if not unit then class = select(2, UnitClass("player"))
	else class = select(2, UnitClass(unit)) end
	return (class == "PALADIN" and (GetSpecialization() == 1))
	or (class == "SHAMAN" and (GetSpecialization() == 3))
	or (class == "DRUID" and (GetSpecialization() == 4))
	or (class == "PRIEST" and (GetSpecialization() ~= 3))
	or (class == "MONK" and (GetSpecialization() == 2))
	--else
	--	return UnitGroupRolesAssigned(unit) == "HEALER"
	--end
end
function addon:IsDps(unit)
	if not unit then class = select(2, UnitClass("player"))
	else class = select(2, UnitClass(unit)) end
	return class == "WARLOCK"
	or class == "MAGE"
	or class == "HUNTER"
	or class == "ROGUE"
	or (class == "WARRIOR" and (GetSpecialization() ~= 3) or UnitBuff("player", gladStance))
	or (class == "DEATHKNIGHT" and (GetSpecialization() ~= 1))
	or (class == "PALADIN" and (GetSpecialization() == 3))
	or (class == "DRUID" and (GetSpecialization() == 1 or GetSpecialization() == 2))
	or (class == "SHAMAN" and (GetSpecialization() ~= 3))
	or (class == "PRIEST" and (GetSpecialization() == 3))
	or (class == "MONK" and (GetSpecialization() == 3))
	--else
	--	print("dps",unit,UnitGroupRolesAssigned(unit))
	--	return UnitGroupRolesAssigned(unit) == "DAMAGER"
	--end
end
function addon:IsRanged(unit)
	if not unit then class = select(2, UnitClass("player"))
	else class = select(2, UnitClass(unit)) end
	return class == "MAGE"
	or class == "HUNTER"
	or class == "WARLOCK"
	or class == "PRIEST"
	or (class == "PALADIN" and (GetSpecialization() == 1))
    or (class == "SHAMAN" and (GetSpecialization() ~= 2))
	or (class == "DRUID" and (GetSpecialization() == 1 or GetSpecialization() == 4))
	or (class == "MONK" and (GetSpecialization() == 2))
end
function addon:IsMelee(unit)
	if not unit then class = select(2, UnitClass("player"))
	else class = select(2, UnitClass(unit)) end
	return class == "ROGUE"
	or class == "WARRIOR"
	or class == "DEATHKNIGHT"
	or class == "MONK"
	or (class == "PALADIN" and (GetSpecialization() ~= 1))
    or (class == "SHAMAN" and (GetSpecialization() == 2))
	or (class == "DRUID" and (GetSpecialization() == 2 or GetSpecialization() == 3))
end
function addon:HasRaidCooldown()
	return class == "WARRIOR"--Rallying Cry/Demoralizing Banner
	or class == "PALADIN"--Aura Mastery
	or class == "ROGUE"--Smoke Bomb
	or (class == "PRIEST" and (GetSpecialization() == 1))--Power Word: Barrier
	or (class == "SHAMAN" and (GetSpecialization() == 3))--Spirit Link Totem
end
-- credits to bigwigs
function addon:IsCaster()
	local power = UnitPowerType("player")
	if power ~= 0 then return end
	if addon:IsHealer() then return true end
	return false
end
function addon:Dispell(dispelType)
	if dispelType == "magic" then
		if IsSpellKnown(527) or IsSpellKnown(77130) or (IsSpellKnown(115450) and IsSpellKnown(115451)) or (IsSpellKnown(4987) and IsSpellKnown(53551)) or IsSpellKnown(88423) then
			-- Purify (Priest), Purify Spirit (Shaman), Detox (Monk-Modifier), Cleanse (Paladin-Modifier), Nature's Cure (Resto Druid)
			return true
		end
	elseif dispelType == "disease" then
		if IsSpellKnown(527) or IsSpellKnown(115450) or IsSpellKnown(4987) then
			-- Purify (Priest), Detox (Monk), Cleanse (Paladin)
			return true
		end
	elseif dispelType == "poison" then
		if IsSpellKnown(88423) or IsSpellKnown(115450) or IsSpellKnown(4987) or IsSpellKnown(2782) then
			-- Nature's Cure (Resto Druid), Detox (Monk), Cleanse (Paladin), Remove Corruption (Druid)
			return true
		end
	elseif dispelType == "curse" then
		if IsSpellKnown(88423) or IsSpellKnown(2782) or IsSpellKnown(77130) or IsSpellKnown(475) then
			-- Nature's Cure (Resto Druid), Remove Corruption (Druid), Purify Spirit (Shaman), Remove Curse (Mage)
			return true
		end
	end
	return false
end

function addon:CanRemoveEnrage()
	local _, class = UnitClass("player")
	return class == "HUNTER" or class == "ROGUE" or class == "DRUID"
end
function addon:IsMagicDispeller()
	if IsSpellKnown(19801) or IsSpellKnown(32375) or IsSpellKnown(528) or IsSpellKnown(370) or IsSpellKnown(30449) then
		-- Tranq (Hunter), Mass Dispel (Priest), Dispel Magic (Priest), Purge (Shaman), Spellsteal (Mage)
		return true
	end
	for i = 2, NUM_GLYPH_SLOTS, 2 do -- 2/4/6 = major glyphs
		local _, _, _, spellId = GetGlyphSocketInfo(i)
		if spellId == 58375 or spellId == 58631 then
			-- Glyph of Shield Slam (Warrior), Glyph of Icy Touch (Death Knight)
			return true
		end
	end

	return false
end
function addon:CanInterrupt(guid)
	-- 6552 Warrior, 47528 DK, 57994 Shaman, 1766 Rogue, 2139 Mage, 34490 hunter, 80965 druid cat, 96231 Paladin, 102060 Warrior
	-- 15487 priest silence, 78675 Druid Solar Beam
	if IsSpellKnown(6552) or IsSpellKnown(47528) or IsSpellKnown(57994) or IsSpellKnown(1766) or IsSpellKnown(2139) or IsSpellKnown(34490) 
	or IsSpellKnown(80965) or IsSpellKnown(96231) or IsSpellKnown(102060) or IsSpellKnown(15487) or IsSpellKnown(78675) then 
		if guid then
			if UnitGUID("target") == guid or UnitGUID("focus") == guid then
				return true
			end
		else
			return true
		end
	end
	return false
end
function addon:TankDistance(boss,distance)
	
end
function addon:IsTargetTank(oname, boss)
	if not oname then return false end

	local runit
	if oname == "player" then
		runit = UnitName("player")
	else
		for i=1, GetNumGroupMembers() do
			local unit = ("raid%d"):format(i)
			local name, server = UnitName(unit)
			if server then name = name.."-"..server end
			if name == oname then
				runit = unit
			end
		end
	end

	if not UnitIsPlayer(runit) then return false end
	if GetPartyAssignment("MAINTANK", runit, 1) then
		return true
	end
	if UnitGroupRolesAssigned(runit) == "TANK" then
		return true
	end

	if boss then
		local istanking, status = UnitDetailedThreatSituation(runit, boss)
		if istanking or (status == 3) then
			return true
		end
	else
		for i = 1, 5 do
			if UnitExists("boss"..i) then
				local istanking, status = UnitDetailedThreatSituation(runit, "boss"..i)
				if istanking or (status == 3) then
					return true
				end
			end
		end
	end
	return false
end

function addon:UnitIsPet(unit)
	return UnitPlayerControlled(unit) and not UnitIsPlayer(unit)
end
function addon:UnitIsPlayer(oname)
	local runit
	for i=1, GetNumGroupMembers() do
		local unit = ("raid%d"):format(i)
		local name, server = UnitName(unit)
		if server then name = name.."-"..server end
		if name == oname then
			runit = unit
		end
	end

	if UnitIsPlayer(runit) then 
		return true
	else
		return false
	end
end

function addon:Throttle(unit,delay)
	-- Initialize to 0 if non-existant
	if not unit then return true end
	Throttle[unit] = Throttle[unit] or 0
	-- Check throttle
	local t = GetTime()
	if t - Throttle[unit] > delay then
		Throttle[unit] = t
		return false
	else
		-- Failed throttle, exit out
		return true
	end
end

function addon:EncDebug(text1,text2,text3,text4,text5)
	--print("DXE Encounter Debug:",text1,text2,text3,text4,text5,text6)
end
--[[
local function asdasdsad(msg)
--local fruits={"apple","orange","banana","kiwi"}
local fruits={}
fruits[#fruits+1] = "teste"
fruits[#fruits+1] = UnitName("player")
fruits[#fruits+1] = "Mäev"
fruits[#fruits+1] = "Hola"
fruits[#fruits+1] = "teste2"
--table.sort(fruits)
	local s ="" 
	local sa = 0 
	for i,v in ipairs(fruits) do
		print("asdasdads1",v)
	    s = s..v.." " 
		sa = sa + 1 
	end
	gsub(s,"%s$","") 
	--s ="" 
	for i = 1, #fruits do
		local name = fruits[i]
	--	s = s..name.." "
	end
	print("asdasdads",s,sa)
	--addon.Alerts:QuashByPattern(id)
	--addon.Alerts:Dropdown("alerttestcd", "Dropdown", 25, 15, "DXE ALERT2", "MIDBLUE", "ORANGE", nil, addon.ST[64813])
    --print("asdasadasdasdasd",addon.Alerts:GetTimeleft("alerttestcd"))
	--addon.Alerts:Pausebar("alerttestcd",20)
end
local function asdasdsad2(msg)
	--local msg = "Melt on Me"
	--local highlightColor = "FF0000"; -- color Chat will be using when highlighting your name
	--local omsg = msg:gsub(" Me", " "..UnitName("player"))
	--pStart, pEnd, capt = find(lower(msg), "(%s+)" .. lower(L.alert["Me"]));
	--if pStart then
	--	local omsg = format("%s%s%s%s", sub(msg, 0, pStart - 1), capt, UnitName("player"), sub(msg, pEnd + 1));		
	--	print("asdasdasd",omsg)
	--end
	addon:StopEncounter()
	addon:SetActiveEncounter("hellfiretrash")
	--addon:StopEncounter()
	addon:StartEncounter()
end
local function asdasdsad1(msg)
	-- 5575.7001953125 4584.3002929688 0 133
	-- 0.42905873060226 0.5092541575431
	local y1, x1, _, map = UnitPosition("player")
		SetMapToCurrentZone()
		local x2,y2 = GetPlayerMapPosition("player")
	print("dasd",x1,y1,x2,y2)
	local y = 0.507899
	local x = 0.422916
	--local y = 5575.7001953125
	--local x = 4584.3002929688

	addon.Arrows:AddTarget("player",20,"TOWARD","teste1","teste2",nil,true,x,y,1,17,19,nil)

end
--local function asdasdsad2(msg)
--	addon.Alerts:Resumebar("alerttestcd",0.00345345345345345)
--end
local function asdasdsad3(msg)
	addon.Alerts:Pausebar("alerttestcd",20.5345345345345345345)
end
local function asdasdsad4(msg)
	local players = "teste1 teste2 teste3 teste4 teste5"
	local idTable = {strsplit(" ", players)}
	for i = 1, #idTable do
		print("sssss",idTable[i])
	end	
	--local pl = {strsplit(" ", players or "")}
end

	SlashCmdList.DXEALERTTESTE = asdasdsad
	SlashCmdList.DXEALERTTESTE2 = asdasdsad2
	SlashCmdList.DXEALERTTESTE3 = asdasdsad3
	SlashCmdList.DXEALERTTESTE4 = asdasdsad4


	SLASH_DXEALERTTESTE1 = "/teste"
	SLASH_DXEALERTTESTE21 = "/teste2"
	SLASH_DXEALERTTESTE31 = "/teste3"
	SLASH_DXEALERTTESTE41 = "/teste4"

--do
	-- self, spellID, texturePath, location, scale, r, g, b, info.vFlip, info.hFlip
	--	SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame, _, "TEXTURES\\SPELLACTIVATIONOVERLAYS\\GENERICARC_02.BLP", "LEFT", 1, 255, 255, 255, false, false)
	--	SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame, _, "TEXTURES\\SPELLACTIVATIONOVERLAYS\\GENERICARC_02.BLP", "RIGHT", 1, 255, 255, 255, false, true)
--print("testeststst",addon:IsHealer(),addon.IsTank(),addon.IsDps(),"-",addon:Dispell("poison"))
--end
--]]
--[[
do

	-- this displays how to use recursive functions to traverse an encounter
	local function traverse(id,off)
	  off=off or ""
	  while id do
		local nex,ch,_,li=select(6,EJ_GetSectionInfo(id))
		local name, description, headerType, abilityIcon, displayInfo, siblingID, nextSectionID, fileredByDifficulty, sectionLink, startsOpen, flag1, flag2, flag3, flag4 = EJ_GetSectionInfo(id)

		print(displayInfo, siblingID, nextSectionID,off..li)
		if ch then
		  traverse(ch,off.."  ")
		end
		id=nex
	  end
	end

	--traverse((select(4,EJ_GetEncounterInfo(1426))))
	


	--/dump ({EJ_GetInstanceInfo()})[7]
	--/dump EJ_GetCreatureInfo(1)
	

	local iid=1392

	for i=1,100 do
		local name, description, encounterID, rootSectionID, link = EJ_GetEncounterInfoByIndex(i, iid)
	--	print("ssss",name, description, encounterID, rootSectionID, link)
		if not encounterID then break end
		local msg = encounterID .. " , " ..  name .. ", ".. rootSectionID.. ", "..link
		DEFAULT_CHAT_FRAME:AddMessage(msg, 1,0.7,0.5)
	end


	eid = 1392

	name, description, encounterID, rootSectionID, link = EJ_GetEncounterInfo(eid)


	function recurseSection(sid)
	   
		local title, description, headerType, abilityIcon, displayInfo, siblingID, nextSectionID, filteredByDifficulty, link, startsOpen, flag1 = EJ_GetSectionInfo(sid)
	   
		print("s", sid.."  "..title.." , ".. (siblingID or "nil").." , "..(nextSectionID or "nil"))
	   
		if nextSectionID then
			recurseSection(nextSectionID)
		end
		if siblingID then
			recurseSection(siblingID)
		end
	end

	--recurseSection(rootSectionID)
		local sDB = DXEDB
		if not sDB["Hellfire Citadel"] then sDB["Hellfire Citadel"] = {} end
		if not sDB["Hellfire Citadel"][1786] then sDB["Hellfire Citadel"][1786] = {} end
		sDB = sDB["Hellfire Citadel"][1786]
		if not sDB[15] then sDB[15] = {} end
		print("ASD",SecondsToTime(sDB[15].best))
	--print("asdasd",GetSpellInfo(165578))
	--print("ASDA",EJ_GetInstanceInfo(731))
	--/dump EJ_GetInstanceByIndex(3, false)
end--]]
