local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1161)

do
	local data = {
		version = 9,
		key = "Gruul",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Gruul"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Gruul.BLP:35:35",
		respawntime = 29.5,
		triggers = {
			scan = {76877}, 
			encounterid = 1720,
			ejid = 1161,
		},
		onactivate = {
			tracing = {
				76877,
				powers={true},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 76877,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 360,
			timeflex = 480,
			timeheroic = 360,
			timemythic = 360,
		},
		raidicons = {
			PetrifyingSlammark = {
				varname = SN[155326],
				type = "MULTIFRIENDLY",
				persist = 120,
				unit = "#5#",
				icon = 1,
				total = 8,
				reset = 10,
				desc = 155326,
				icon2 = ST[155326],
				enabled = false,
			},			
		},
		timers = {
			timerPetrifyingSlam = {
				{
					"message","mPetrifyingSlam",
				},
			},
			timerOpenPetrifyingSlam = {
				{
					"openwindow",{"8","&list|PetrifyingSlamunists2&",true,155323},
					"scheduletimer",{"timerClosePetrifyingSlam",9},
				},
			},
			timerClosePetrifyingSlam = {
				{
					"closewindow"
				},
			},
			timerInfernoSlice = {
				{
					"expect",{"<targets>","<","4"},
					"alert",{"InfernoSliceCD", time = 5},
				},
				{
					"expect",{"<targets>",">","3"},
					"alert",{"InfernoSliceCD", time = 6},
				},				
			},			
		},			
		userdata = {
			smashCount = 0,
			slamCount = 0,
			sliceCount = 1,
			first = 0,
			ramping = 0,
			targets = 0,
			PetrifyingSlamunists = {type = "container", wipein = 3},
			PetrifyingSlamunists2 = {type = "container", wipein = 3},
		},		
		messages = {
			mPetrifyingSlam = {
				varname = format(L.alert["%s %s %s"],SN[155323],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|PetrifyingSlamunists&"],SN[155323],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 155323,
				icon = ST[155323],
			},	
			mDestructiveRampage = {
				varname = format(L.alert["%s!"],SN[155539]),
				type = "message",
				text = format(L.alert["%s!"],SN[155539]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 155539,
				icon = ST[155539],
			},	
			mInfernoSlice = {
				varname = format(L.alert["%s (2)"],SN[155080]),
				type = "message",
				text = format(L.alert["%s (<sliceCount>)"],SN[155080]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 155080,
				icon = ST[155080],
				counter2 = true,
			},	
			mOverwhelmingBlows = {
				varname = format(L.alert["%s %s %s (3)"],SN[155078],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (#11#)"],SN[155078],L.alert["on"]),
				color1 = "YELLOW",
				icon = ST[155078],
				desc = 155078,
				sound = "ALERT13",
				--exhealer = true,
				exdps = true,
				throttle = 2,
				counter2 = true,
			},			
		},
		onstart = {
			{
				"expect",{"&mythic&","==","true"},
				"alert",{"InfernoSliceCD", time = 2},
			},
			{
				"expect",{"&mythic&","==","false"},
				"alert","InfernoSliceCD",
			},
			{
				"batchalert",{"RampageCD","OverheadSmashCD","PetrifyingSlamCD"},
			},
		},
		alerts = {
			InfernoSliceCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[155080]),
				type = "dropdown",
				text = "(<sliceCount>) "..format(L.alert["%s Cooldown"],SN[155080]),
				time = 14.5,
				time2 = 9.5,
				time3 = 17,
				time4 = 15,
				time5 = 5,
				time6 = 10,
				time7 = 13,
				color1 = "ORANGE",
				icon = ST[155080],
				desc = 155080,	
				counter = true,
			},
			PetrifyingSlamCD = {
				varname = format(L.alert["%s Cooldown"],SN[155326]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155326]),
				time = 21,
				time2 = 15,
				time3 = 61,
				time4 = 25,
				color1 = "GLOBAL",
				icon = ST[155326],
				desc = 155326,		
				--counter = true,
			},
			OverheadSmashCD = {
				varname = format(L.alert["%s Cooldown"],SN[155301]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155301]),
				time = 21,
				time2 = 31,
				color1 = "GLOBAL",
				icon = ST[155301],
				desc = 155301,
				--counter = true,
			},		
			RampageCD = {
				varname = format(L.alert["%s Cooldown"],SN[155539]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155539]),
				time = 105,
				time2 = 30,
				time3 = 113,
				color1 = "GLOBAL",
				icon = ST[155539],
				desc = 155539,		
			},		
			-- Warning
			wOverheadSmash = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[155301]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[155301]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155301],
				sound = "ALERT10",
				desc = 155301,
			},	
			wPetrifyingSlam = {
				varname = format(L.alert["%s!"],SN[155323]),
				type = "simple",
				text = format(L.alert["%s!"],SN[155323]),
				time = 2,
				color1 = "RED",
				icon = ST[155323],
				sound = "ALERT10",
				desc = 155323,
			},	
			wDestructiveRampageEnded = {
				varname = format(L.alert["%s %s!"],SN[155539],L.alert["Over"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[155539],L.alert["Over"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[155539],
				sound = "ALERT13",
				desc = 155539,
			},					
			-- Inform
			iPetrifyingSlam = {
				varname = format(L.alert["%s %s %s!"],SN[155323],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[155323],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[155323],
				sound = "ALERT10",
				desc = 155323,
				flashscreen = true,
			},
			iCaveInDamage = {
				varname = format(L.alert["%s %s, %s!"],SN[173192],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[173192],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[173192],
				sound = "ALERT12",
				desc = 173192,
				flashscreen = true,
				throttle = 2,
			},			
			-- Casts
			RampageActive = {
				varname = format(L.alert["%s Active"],SN[155539]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[155539]),
				time = 30,
				color1 = "YELLOW",
				icon = ST[155326],
				desc = 155539,
			},			
			ShatterActive = {
				varname = format(L.alert["%s Active"],SN[155530]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[155530]),
				time = 9,
				color1 = "GLOBAL",
				icon = ST[155326],
				desc = 155530,
			},
			PetrifyingSlamActive = {
				varname = format(L.alert["%s Active"],SN[155506]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[155506]),
				time = 7,
				color1 = "RED",
				icon = ST[155326],
				desc = 155506,
			},	
			-- Debuff
			OverwhelmingBlowsDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155078]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155078]),
				text2 = format(L.alert["#5# (1): %s"],SN[155078]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155078]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155078]),
				time = 15,
				color1 = "PURPLE",
				desc = 155078,
				icon = ST[155078],
				tag = "#5#",
				exdps = true,				
			},			
		},
		events = {
			-- InfernoSlice
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155080},
				execute = {
					{
						"quash","InfernoSliceCD",
						"message","mInfernoSlice",
						"set",{sliceCount = "INCR|1"},
						"set",{targets = "0"},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {155080},
				execute = {
					{
						"expect",{"&mythic&","==","false"},
						"alert",{"InfernoSliceCD", time = 4},
					},
					{
						"expect",{"&mythic&","==","true"},
						"scheduletimer",{"timerInfernoSlice",0.2},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155080},
				execute = {
					{
						"set",{targets = "INCR|1"},
					},		
				},
			},			
			-- OverwhelmingBlows
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155078},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","OverwhelmingBlowsDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"OverwhelmingBlowsDebuff", text = 2},
							},
						},
					},
				},
			},			
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155078},
				execute = {
					{
						"expect",{"&istargettank|#5#&","==","true"},
						"invoke",{				
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"OverwhelmingBlowsDebuff", text = 3},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"OverwhelmingBlowsDebuff", text = 4},
							},
							{
								"expect",{"#11#",">=","5"},
								"message","mOverwhelmingBlows",
							},
							--{
							--	"expect",{"&checkperc|#11#|2&","==","0"},
							--	"message","mOverwhelmingBlows",
							--},
						},
					},
				},
			},				
			-- OverheadSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155301},
				execute = {
					{
						"expect",{"<ramping>","==","0"},
						"invoke",{
							{
								"set",{smashCount = "INCR|1"},
								"alert","wOverheadSmash",
							},
							{
								"expect",{"<smashCount>","<","4"},
								"alert","OverheadSmashCD",
							},
							{
								"expect",{"<first>","==","0"}, 
								"alert",{"PetrifyingSlamCD", time = 2},
								"set",{first = "1"},
							},							
						},
					},
				},
			},
			-- PetrifyingSlam
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155323},
				execute = {
					{
						"insert",{"PetrifyingSlamunists","#5#"},
						"insert",{"PetrifyingSlamunists2","#5#",true},
					},
					{
						"expect",{"&count|PetrifyingSlamunists2&","==","1"},
						"set",{slamCount = "INCR|1"},
						"alert","wPetrifyingSlam",
					},
					{
						"expect",{"&mythic&","==","false"},
						"canceltimer","timerPetrifyingSlam",
						"scheduletimer",{"timerPetrifyingSlam",0.5},
						"raidicon","PetrifyingSlammark",
					},	
					{
						"expect",{"<slamCount>","<","3"},
						"alert",{"PetrifyingSlamCD", time = 3},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iPetrifyingSlam",
						"alert","PetrifyingSlamActive",
						"openwindow",{"8",nil,false,155323},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"scheduletimer",{"timerOpenPetrifyingSlam",0.2},
						"alert","ShatterActive",
					},					
					{
						"expect",{"<first>","==","0"},
						"alert","OverheadSmashCD",
						"set",{first = "1"},
					},	
				},
			},	
			-- DestructiveRampage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155539},
				execute = {
					{
						"message","mDestructiveRampage",
						"alert","RampageActive",
						"set",{ramping = "1"},
						"batchquash",{"InfernoSliceCD","PetrifyingSlamCD","OverheadSmashCD"},
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {155539},
				execute = {
					{
						"alert",{"RampageCD", time = 3},
						"set",{ramping = "0"},
						"set",{smashCount = "0"},
						"set",{slamCount = "0"},
						"set",{sliceCount = "1"},
						"alert",{"PetrifyingSlamCD", time = 4},
						"alert",{"OverheadSmashCD", time = 2},
						"alert","wDestructiveRampageEnded",
					},
					{
						"expect",{"&mythic&","==","false"},
						"alert",{"InfernoSliceCD", time = 3}, -- 17
					},
					{
						"expect",{"&mythic&","==","true"},
						"alert",{"InfernoSliceCD", time = 7}, -- 13
					},					
				},
			},	
			-- CaveInDamage
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {173192},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iCaveInDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {173192},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iCaveInDamage",
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end