local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1147)
local Train = GetSpellInfo(174806)
--[[if posX > 577.8 then
	playerLane = 1
elseif posX > 553.8 then
	playerLane = 2
elseif posX > 529.6 then
	playerLane = 3
else 
	< 529.7
	playerLane = 4
end--]]
do
	local data = {
		version = 12,
		key = "Thogar",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Operator Thogar"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Operator Thogar.BLP:35:35",
		respawntime = 29.5,
		triggers = {
			scan = {76906, 80791}, 
			encounterid = 1692,
			ejid = 1147,
		},
		onactivate = {
			tracing = {76906, 80791},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2"},
			defeat = 76906,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 600,
		},
		raidicons = {
			DelayedSiegeBombmark = {
				varname = SN[159481],
				type = "FRIENDLY",
				persist = 60,
				unit = "&upvalue&", 
				icon = 6,
				desc = 159481,
				icon2 = ST[159481],
			},
			GromkarManatArmsmark = {
				varname = SN["ej9549"],
				type = "ENEMY",
				persist = 120,
				unit = "<ManatArms>",
				icon = 8,
				--ability = 9549,
				icon2 = EJST[9549],
			},	
			GromkarFiremendermark = {
				varname = SN["ej9543"],
				type = "ENEMY",
				persist = 120,
				unit = "<Firemender>",
				icon = 7,
				--ability = 9543,
				icon2 = EJST[9543],
			},				
		},
		arrows = {
			lane4arrow = {
				varname = format(L.alert["%s 4"],L.chat_BlackrockFoundry["Lane"]),
				unit = "player",
				persist = 5,
				action = "TOWARD",
				msg = L.alert["MOVE THERE"],
				spell = format(L.alert["%s 4"],L.chat_BlackrockFoundry["Lane"]),
				fixed = true,
				xpos = 0.459286,
				ypos = 0.357740,
			},
			lane3arrow = {
				varname = format(L.alert["%s 3"],L.chat_BlackrockFoundry["Lane"]),
				unit = "player",
				persist = 5,
				action = "TOWARD",
				msg = L.alert["MOVE THERE"],
				spell = format(L.alert["%s 3"],L.chat_BlackrockFoundry["Lane"]),
				fixed = true,
				xpos = 0.457863,
				ypos = 0.307858,
			},
			lane2arrow = {
				varname = format(L.alert["%s 2"],L.chat_BlackrockFoundry["Lane"]),
				unit = "player",
				persist = 5,
				action = "TOWARD",
				msg = L.alert["MOVE THERE"],
				spell = format(L.alert["%s 2"],L.chat_BlackrockFoundry["Lane"]),
				fixed = true,
				xpos = 0.459602,
				ypos = 0.254992,
			},
			lane1arrow = {
				varname = format(L.alert["%s 1"],L.chat_BlackrockFoundry["Lane"]),
				unit = "player",
				persist = 5,
				action = "TOWARD",
				msg = L.alert["MOVE THERE"],
				spell = format(L.alert["%s 1"],L.chat_BlackrockFoundry["Lane"]),
				fixed = true,
				xpos = 0.458838,
				ypos = 0.202749,
			},
			Grenadearrow = {
				varname = SN[155864],
				unit = "<Grenadetarget>",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[155864],
				range1 = 2,
				range2 = 7,
				range3 = 10,
				desc = 155864,
				icon = ST[155864],
				sound = "ALERT12",
			},
		},
		timers = {	
			timeSplit = {
				{
					"message","mIncomingSplit",
				},
			},	
			timerLaneLFR = {
				{
					"set",{position = "&unitposition|player&"},
					--"set",{position2 = "&unitpositionold|player&"},
					--"debug",{"<position>","<lanecount>","<position2>"},
				},
				{
					"expect",{"<lanecount>","==","1"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","2"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","3"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","4"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","5"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","6"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},	
				{
					"expect",{"<lanecount>","==","7"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","8"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","9"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",				
				},
				{
					"expect",{"<lanecount>","==","10"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","11"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","12"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","13"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","14"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","15"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","16"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","17"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane3arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},	
				{
					"expect",{"<lanecount>","==","18"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","19"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","20"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane3arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","21"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","22"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
					--"scheduletimer",{"timerLane",30},
					"scheduletimer",{"timeSplit",23},
					--"set",{lanecount = "INCR|1"},
				},	
				{
					"expect",{"<lanecount>","==","23"}, --- NOT SPLIT
					"arrow","lane1arrow",
					--"alert","wSplit",
					--[["invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane1arrow",
						},						
					},--]]
				},	
				{
					"expect",{"<lanecount>","==","24"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","25"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","26"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","27"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","28"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","29"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","30"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","31"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","32"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane4arrow",
				},	
				{
					"expect",{"<lanecount>","==","33"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","34"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},					
			},			
			timerLane = {
				{
					"set",{position = "&unitposition|player&"},
					--"set",{position2 = "&unitpositionold|player&"},
					--"debug",{"<position>","<lanecount>","<position2>"},
				},
				{
					"expect",{"<lanecount>","==","1"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","2"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","3"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","4"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","5"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","6"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},	
				{
					"expect",{"<lanecount>","==","7"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","8"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				--	"scheduletimer",{"timerLane",15},
					"scheduletimer",{"timeSplit",8},
				--	"set",{lanecount = "INCR|1"},
				},
				{
					"expect",{"<lanecount>","==","9"}, --split
					"alert","wSplit",
					--[["invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},--]]
				},
				{
					"expect",{"<lanecount>","==","10"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","11"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","12"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","13"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","14"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","15"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","16"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","17"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane3arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},	
				{
					"expect",{"<lanecount>","==","18"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","19"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","20"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane3arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","21"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},
				{
					"expect",{"<lanecount>","==","22"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
					--"scheduletimer",{"timerLane",30},
					"scheduletimer",{"timeSplit",23},
					--"set",{lanecount = "INCR|1"},
				},	
				{
					"expect",{"<lanecount>","==","23"}, -- split
					"alert","wSplit",
					--[["invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},--]]
				},
				{
					"expect",{"<lanecount>","==","24"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane3arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","25"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","26"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","27"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},	
				{
					"expect",{"<lanecount>","==","28"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","29"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","30"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","31"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},			
			},
			timerLaneMythic = {
				{
					"set",{position = "&unitposition|player&"},
					--"debug",{"<position>","<lanecount>","<position2>"},
				},
				{
					"expect",{"<lanecount>","==","1"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","2"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","3"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},
				{
					"expect",{"<lanecount>","==","4"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","5"},
				--	"expect",{"<position>","<","529.7"}, -- lane 4
				--	"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","6"},
				--	"expect",{"<position>",">","553.8"}, -- lane 2
				--	"arrow","lane1arrow",
				},	
				{
					"expect",{"<lanecount>","==","7"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","8"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},
				{
					"expect",{"<lanecount>","==","9"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane4arrow",
					--"scheduletimer",{"timerLaneMythic",35},
					"scheduletimer",{"timeSplit",28},
					--"set",{lanecount = "INCR|1"},
				},
				{
					"expect",{"<lanecount>","==","10"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","11"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","12"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","13"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","14"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane4arrow",
				},
				{
					"expect",{"<lanecount>","==","15"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","16"},
				--	"expect",{"<position>",">","577.8"}, -- lane 1
				--	"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","17"},
				--
				},	
				{
					"expect",{"<lanecount>","==","18"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},	
				{
					"expect",{"<lanecount>","==","19"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane4arrow",
						},
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane4arrow",
						},								
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","20"},
					--"scheduletimer",{"timerLaneMythic",15},
					"scheduletimer",{"timeSplit",8},
					--"set",{lanecount = "INCR|1"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},					
					},
				},
				{
					"expect",{"<lanecount>","==","21"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","22"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane2arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane3arrow",
						},						
					},
				},	
				{
					"expect",{"<lanecount>","==","23"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},
				},	
				{
					"expect",{"<lanecount>","==","24"},
				--	"expect",{"<position>","<","529.7"}, -- lane 4
				--	"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","25"},
				--	"expect",{"<position>",">","577.8"}, -- lane 1
				--	"arrow","lane2arrow",
				},
				{
					"expect",{"<lanecount>","==","26"},
					"expect",{"<position>","<","529.7"}, -- lane 4
					"arrow","lane3arrow",
				},
				{
					"expect",{"<lanecount>","==","27"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","28"},
					"invoke",{
						{
							"expect",{"<position>",">","553.8"}, -- lane 2
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>",">","529.6"}, -- lane 3
							"arrow","lane4arrow",
						},						
					},
				},	
				{
					"expect",{"<lanecount>","==","29"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane4arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","30"},
					"invoke",{
						{
							"expect",{"<position>",">","577.8"}, -- lane 1
							"arrow","lane1arrow",
						},
						{
							"expect",{"<position>","<","529.7"}, -- lane 4
							"arrow","lane4arrow",
						},						
					},
				},
				{
					"expect",{"<lanecount>","==","31"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane1arrow",
				},
				{
					"expect",{"<lanecount>","==","32"},
					"expect",{"<position>",">","529.6"}, -- lane 3
					"arrow","lane4arrow",
				},	
				{
					"expect",{"<lanecount>","==","33"},
					"expect",{"<position>",">","553.8"}, -- lane 2
					"arrow","lane3arrow",
				},	
				{
					"expect",{"<lanecount>","==","34"},
					"expect",{"<position>",">","577.8"}, -- lane 1
					"arrow","lane2arrow",
				},	
				{
					"expect",{"<lanecount>","==","35"},
				--	"expect",{"<position>",">","577.8"}, -- lane 1
				--	"arrow","lane2arrow",
				},	
				--{
				--	"expect",{"<lanecount>","==","36"},
				-- berserk	
				--},					
			},			
			timerLane1= {
				{
					"set",{lane1count = "INCR|1"},
					--"set",{position = "&unitposition|player&"},
				},
				{
					"expect",{"<lane1count>","==","1"},
					"alert",{"Lane1CD", text = 2}, -- Adds
					"scheduletimer",{"timerLane1",32},
				},
				{
					"expect",{"<lane1count>","==","2"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",75},
				},
				{
					"expect",{"<lane1count>","==","3"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",55},
				},
				{
					"expect",{"<lane1count>","==","4"},
					"alert",{"Lane1CD", text = 3}, -- Cannon
					"scheduletimer",{"timerLane1",10},
				},
				{
					"expect",{"<lane1count>","==","5"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",65},
				},
				{
					"expect",{"<lane1count>","==","6"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",35},
				},
				{
					"expect",{"<lane1count>","==","7"},
					"alert",{"Lane1CD", text = 3}, -- Cannon
					"scheduletimer",{"timerLane1",35},
				},
				{
					"expect",{"<lane1count>","==","8"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",100},
				},
				{
					"expect",{"<lane1count>","==","9"},
					"alert",{"Lane1CD", text = 3}, -- Cannon
					"scheduletimer",{"timerLane1",10},
				},
				{
					"expect",{"<lane1count>","==","10"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",50},
				},	
				{
					"expect",{"<lane1count>","==","11"},
					"alert","Lane1CD",
					"scheduletimer",{"timerLane1",28},
				},							
			},
			timerLane1Mythic= {
				{
					"set",{lane1count = "INCR|1"},
				},
				{
					"expect",{"<lane1count>","==","1"},
					"alert",{"Lane1CD", time = 2, text = 5},
					"scheduletimer",{"timerLane1Mythic",17},
				},
				{
					"expect",{"<lane1count>","==","2"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",40},
				},
				{
					"expect",{"<lane1count>","==","3"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",15},
				},
				{
					"expect",{"<lane1count>","==","4"},
					"alert",{"Lane1CD", time = 2, text = 3},
					"scheduletimer",{"timerLane1Mythic",10},
				},
				{
					"expect",{"<lane1count>","==","5"},
					"alert",{"Lane1CD", time = 2},
					"scheduletimer",{"timerLane1Mythic",90},
				},		
				{
					"expect",{"<lane1count>","==","6"},
					"alert",{"Lane1CD", time = 2, text = 5},
					"scheduletimer",{"timerLane1Mythic",5},
				},	
				{
					"expect",{"<lane1count>","==","7"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",40},
				},	
				{
					"expect",{"<lane1count>","==","8"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",15},
				},	
				{
					"expect",{"<lane1count>","==","9"},
					"alert",{"Lane1CD", time = 2, text = 6},
					"scheduletimer",{"timerLane1Mythic",14},
				},	
				{
					"expect",{"<lane1count>","==","10"},
					"alert",{"Lane1CD", time = 2, text = 5},
					"scheduletimer",{"timerLane1Mythic",16},
				},	
				{
					"expect",{"<lane1count>","==","11"},
					"alert",{"Lane1CD", time = 2},
					"scheduletimer",{"timerLane1Mythic",60},
				},	
				{
					"expect",{"<lane1count>","==","12"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",25},
				},	
				{
					"expect",{"<lane1count>","==","13"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",16},
				},	
				{
					"expect",{"<lane1count>","==","14"},
					"alert",{"Lane1CD", time = 2, text = 3},
					"scheduletimer",{"timerLane1Mythic",7},
				},	
				{
					"expect",{"<lane1count>","==","15"},
					"alert",{"Lane1CD", time = 2},
					"scheduletimer",{"timerLane1Mythic",42},
				},	
				{
					"expect",{"<lane1count>","==","16"},
					"alert",{"Lane1CD", time = 2, text = 2},
					"scheduletimer",{"timerLane1Mythic",15},
				},	
				{
					"expect",{"<lane1count>","==","17"},
					"alert",{"Lane1CD", time = 2, text = 6},
					"scheduletimer",{"timerLane1Mythic",40},
				},	
				{
					"expect",{"<lane1count>","==","18"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",10},
				},					{
					"expect",{"<lane1count>","==","19"},
					"alert",{"Lane1CD", time = 2, text = 4},
					"scheduletimer",{"timerLane1Mythic",14},
				},				
			},
			timerLane2 = {
				{
					"set",{lane2count = "INCR|1"},
					--"alert","Lane2CD",
				},
				{
					"expect",{"<lane2count>","==","1"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",27},
				},
				{
					"expect",{"<lane2count>","==","2"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",50},
				},
				{
					"expect",{"<lane2count>","==","3"},
					"alert",{"Lane2CD", text = 2},
					"scheduletimer",{"timerLane2",45},
				},
				{
					"expect",{"<lane2count>","==","4"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",65},
				},
				{
					"expect",{"<lane2count>","==","5"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",40},
				},
				{
					"expect",{"<lane2count>","==","6"},
					"alert",{"Lane2CD", text = 3},
					"scheduletimer",{"timerLane2",25},
				},
				{
					"expect",{"<lane2count>","==","7"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",65},
				},
				{
					"expect",{"<lane2count>","==","8"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",25},
				},
				{
					"expect",{"<lane2count>","==","9"},
					"alert",{"Lane2CD", text = 2},
					"scheduletimer",{"timerLane2",30},
				},
				{
					"expect",{"<lane2count>","==","10"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",61},
				},	
				{
					"expect",{"<lane2count>","==","11"},
					"alert","Lane2CD",
					"scheduletimer",{"timerLane2",57},
				},						
			},
			timerLane2lfr = {
				{
					"set",{lane2count = "INCR|1"},
					--"alert","Lane2CD",
				},
				{
					"expect",{"<lane2count>","==","1"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",27},
				},
				{
					"expect",{"<lane2count>","==","2"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",50},
				},
				{
					"expect",{"<lane2count>","==","3"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",100},
				},
				{
					"expect",{"<lane2count>","==","4"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",40},
				},
				{
					"expect",{"<lane2count>","==","5"},
					"alert",{"Lane2CD", text = 3, time = 3},
					"scheduletimer",{"timerLane2",25},
				},
				{
					"expect",{"<lane2count>","==","6"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",65},
				},
				{
					"expect",{"<lane2count>","==","7"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",25},
				},
				{
					"expect",{"<lane2count>","==","8"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",91},
				},
				{
					"expect",{"<lane2count>","==","9"},
					"alert",{"Lane2CD", time = 3},
					"scheduletimer",{"timerLane2",57},
				},						
			},			
			timerLane2Mythic= {
				{
					"set",{lane2count = "INCR|1"},
					--"alert",{"Lane2CD", time = 2},
				},
				{
					"expect",{"<lane2count>","==","1"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",23},
				},
				{
					"expect",{"<lane2count>","==","2"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",34},
				},
				{
					"expect",{"<lane2count>","==","3"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",15},
				},
				{
					"expect",{"<lane2count>","==","4"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",25},
				},
				{
					"expect",{"<lane2count>","==","5"},
					"alert",{"Lane2CD", time = 2, text = 2},
					"scheduletimer",{"timerLane2Mythic",49},
				},		
				{
					"expect",{"<lane2count>","==","6"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",53},
				},
				{
					"expect",{"<lane2count>","==","7"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",18},
				},
				{
					"expect",{"<lane2count>","==","8"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",15},
				},
				{
					"expect",{"<lane2count>","==","9"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",35},
				},
				{
					"expect",{"<lane2count>","==","10"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",21},
				},
				{
					"expect",{"<lane2count>","==","11"},
					"alert",{"Lane2CD", time = 2, text = 2},
					"scheduletimer",{"timerLane2Mythic",15},
				},		
				{
					"expect",{"<lane2count>","==","12"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",31},
				},
				{
					"expect",{"<lane2count>","==","13"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",14},
				},	
				{
					"expect",{"<lane2count>","==","14"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",16},
				},
				{
					"expect",{"<lane2count>","==","15"},
					"alert",{"Lane2CD", time = 2, text = 5},
					"scheduletimer",{"timerLane2Mythic",30},
				},
				{
					"expect",{"<lane2count>","==","16"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",34},
				},
				{
					"expect",{"<lane2count>","==","17"},
					"alert",{"Lane2CD", time = 2},
					"scheduletimer",{"timerLane2Mythic",25},
				},		
				{
					"expect",{"<lane2count>","==","18"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",25},
				},
				{
					"expect",{"<lane2count>","==","19"},
					"alert",{"Lane2CD", time = 2, text = 4},
					"scheduletimer",{"timerLane2Mythic",14},
				},		
			},
			timerLane3= {
				{
					"set",{lane3count = "INCR|1"},
					--"alert","Lane3CD",
				},
				{
					"expect",{"<lane3count>","==","1"},
					"alert","Lane3CD",
					"scheduletimer",{"timerLane3",46},
				},
				{
					"expect",{"<lane3count>","==","2"},
					"alert",{"Lane3CD", text = 3},
					"scheduletimer",{"timerLane3",34},
				},
				{
					"expect",{"<lane3count>","==","3"},
					"alert",{"Lane3CD", text = 2},
					"scheduletimer",{"timerLane3",39},
				},
				{
					"expect",{"<lane3count>","==","4"},
					"alert","Lane3CD",
					"scheduletimer",{"timerLane3",94},
				},
				{
					"expect",{"<lane3count>","==","5"},
					"alert","Lane3CD",
					"scheduletimer",{"timerLane3",59},
				},
				{
					"expect",{"<lane3count>","==","6"},
					"alert",{"Lane3CD", text = 3},
					"scheduletimer",{"timerLane3",94},
				},
				{
					"expect",{"<lane3count>","==","7"},
					"alert","Lane3CD",
					"scheduletimer",{"timerLane3",69},
				},
				{
					"expect",{"<lane3count>","==","8"},
					"alert",{"Lane3CD", text = 2},
					"scheduletimer",{"timerLane3",19},
				},
				{
					"expect",{"<lane3count>","==","9"},
					"alert",{"Lane3CD", text = 2},
					"scheduletimer",{"timerLane3",27},
				},			
			},
			timerLane3Mythic= {
				{
					"set",{lane3count = "INCR|1"},
					--"alert",{"Lane3CD", time = 2},
				},
				{
					"expect",{"<lane3count>","==","1"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",37},
				},
				{
					"expect",{"<lane3count>","==","2"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",20},
				},
				{
					"expect",{"<lane3count>","==","3"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",15},
				},
				{
					"expect",{"<lane3count>","==","4"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",40},
				},
				{
					"expect",{"<lane3count>","==","5"},
					"alert",{"Lane3CD", time = 2, text = 2},
					"scheduletimer",{"timerLane3Mythic",34},
				},		
				{
					"expect",{"<lane3count>","==","6"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",41},
				},
				{
					"expect",{"<lane3count>","==","7"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",12},
				},		
				{
					"expect",{"<lane3count>","==","8"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",18},
				},
				{
					"expect",{"<lane3count>","==","9"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",15},
				},		
				{
					"expect",{"<lane3count>","==","10"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",35},
				},		
				{
					"expect",{"<lane3count>","==","11"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",21},
				},		
				{
					"expect",{"<lane3count>","==","12"},
					"alert",{"Lane3CD", time = 2, text = 3},
					"scheduletimer",{"timerLane3Mythic",14},
				},
				{
					"expect",{"<lane3count>","==","13"},
					"alert",{"Lane3CD", time = 2},
					"scheduletimer",{"timerLane3Mythic",31},
				},		
				{
					"expect",{"<lane3count>","==","14"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",14},
				},
				{
					"expect",{"<lane3count>","==","15"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",16},
				},		
				{
					"expect",{"<lane3count>","==","16"},
					"alert",{"Lane3CD", time = 2, text = 5},
					"scheduletimer",{"timerLane3Mythic",30},
				},	
				{
					"expect",{"<lane3count>","==","17"},
					"alert",{"Lane3CD", time = 2, text = 5},
					"scheduletimer",{"timerLane3Mythic",49},
				},		
				{
					"expect",{"<lane3count>","==","18"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",35},
				},
				{
					"expect",{"<lane3count>","==","19"},
					"alert",{"Lane3CD", time = 2, text = 4},
					"scheduletimer",{"timerLane3Mythic",14},
				},				
			},
			timerLane4= {
				{
					"set",{lane4count = "INCR|1"},
					--"alert","Lane4CD",
				},
				{
					"expect",{"<lane4count>","==","1"},
					"alert","Lane4CD",
					"scheduletimer",{"timerLane4",16},
				},
				{
					"expect",{"<lane4count>","==","2"},
					"alert",{"Lane4CD", text = 3},
					"scheduletimer",{"timerLane4",34},
				},
				{
					"expect",{"<lane4count>","==","3"},
					"alert","Lane4CD",
					"scheduletimer",{"timerLane4",109},
				},
				{
					"expect",{"<lane4count>","==","4"},
					"alert",{"Lane4CD", text = 2},
					"scheduletimer",{"timerLane4",34},
				},
				{
					"expect",{"<lane4count>","==","5"},
					"alert",{"Lane4CD", text = 3},
					"scheduletimer",{"timerLane4",54},
				},
				{
					"expect",{"<lane4count>","==","6"},
					"alert",{"Lane4CD", text = 3},
					"scheduletimer",{"timerLane4",54},
				},
				{
					"expect",{"<lane4count>","==","7"},
					"alert","Lane4CD",
					"scheduletimer",{"timerLane4",79},
				},
				{
					"expect",{"<lane4count>","==","8"},
					"alert",{"Lane4CD", text = 2},
					"scheduletimer",{"timerLane4",29},
				},
				{
					"expect",{"<lane4count>","==","9"},
					"alert","Lane4CD",
					"scheduletimer",{"timerLane4",49},
				},						
			},
			timerLane4Mythic= {
				{
					"set",{lane4count = "INCR|1"},
					--"alert",{"Lane4CD", time = 2},
				},
				{
					"expect",{"<lane4count>","==","1"},
					"alert",{"Lane4CD", time = 2, text = 5},
					"scheduletimer",{"timerLane4Mythic",12},
				},
				{
					"expect",{"<lane4count>","==","2"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",45},
				},
				{
					"expect",{"<lane4count>","==","3"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",15},
				},
				{
					"expect",{"<lane4count>","==","4"},
					"alert",{"Lane4CD", time = 2, text = 3},
					"scheduletimer",{"timerLane4Mythic",12},
				},
				{
					"expect",{"<lane4count>","==","5"},
					"alert",{"Lane4CD", time = 2},
					"scheduletimer",{"timerLane4Mythic",88},
				},		
				{
					"expect",{"<lane4count>","==","6"},
					"alert",{"Lane4CD", time = 2, text = 6},
					"scheduletimer",{"timerLane4Mythic",5},
				},
				{
					"expect",{"<lane4count>","==","7"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",40},
				},		
				{
					"expect",{"<lane4count>","==","8"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",15},
				},			
				{
					"expect",{"<lane4count>","==","9"},
					"alert",{"Lane4CD", time = 2, text = 3},
					"scheduletimer",{"timerLane4Mythic",14},
				},		
				{
					"expect",{"<lane4count>","==","10"},
					"alert",{"Lane4CD", time = 2},
					"scheduletimer",{"timerLane4Mythic",76},
				},			
				{
					"expect",{"<lane4count>","==","11"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",25},
				},		
				{
					"expect",{"<lane4count>","==","12"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",16},
				},			
				{
					"expect",{"<lane4count>","==","13"},
					"alert",{"Lane4CD", time = 2, text = 2},
					"scheduletimer",{"timerLane4Mythic",7},
				},		
				{
					"expect",{"<lane4count>","==","14"},
					"alert",{"Lane4CD", time = 2},
					"scheduletimer",{"timerLane4Mythic",42},
				},			
				{
					"expect",{"<lane4count>","==","15"},
					"alert",{"Lane4CD", time = 2, text = 6},
					"scheduletimer",{"timerLane4Mythic",15},
				},		
				{
					"expect",{"<lane4count>","==","16"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",50},
				},			
				{
					"expect",{"<lane4count>","==","17"},
					"alert",{"Lane4CD", time = 2, text = 4},
					"scheduletimer",{"timerLane4Mythic",15},
				},								
			},		
			timerCheckYell = {
				{
					"message","mTrain",
					"invoke",{
						{
							"expect",{"&mythic&","==","true"},
							"set",{lanemythicount = "INCR|1"},
							"scheduletimer",{"timerLaneMythic",0.1},
							"invoke",{
								{
									"expect",{"<lanemythicount>","==","2"},
									"scheduletimer",{"timerCheckYell",11.5},
								},
								{
									"expect",{"<lanemythicount>","==","3"},
									"scheduletimer",{"timerCheckYell",6.5},
								},
								{
									"expect",{"<lanemythicount>","==","4"},
									"scheduletimer",{"timerCheckYell",16.5},
								},		
								{
									"expect",{"<lanemythicount>","==","5"},
									"scheduletimer",{"timerCheckYell",6.5},
								},		
								{
									"expect",{"<lanemythicount>","==","6"},
									"scheduletimer",{"timerCheckYell",26.5},
								},		
								{
									"expect",{"<lanemythicount>","==","7"},
									"scheduletimer",{"timerCheckYell",6.5},
								},		
								{
									"expect",{"<lanemythicount>","==","8"},
									"scheduletimer",{"timerCheckYell",26.5},
								},		
								{
									"expect",{"<lanemythicount>","==","9"},
									"scheduletimer",{"timerCheckYell",16.5},
								},		
								{
									"expect",{"<lanemythicount>","==","10"},
									"scheduletimer",{"timerCheckYell",41.5},
								},		
								{
									"expect",{"<lanemythicount>","==","11"},
									"scheduletimer",{"timerCheckYell",11.5},
								},		
								{
									"expect",{"<lanemythicount>","==","12"},
									"scheduletimer",{"timerCheckYell",16.5},
								},		
								{
									"expect",{"<lanemythicount>","==","13"},
									"scheduletimer",{"timerCheckYell",11.5},
								},		
								{
									"expect",{"<lanemythicount>","==","14"},
									"scheduletimer",{"timerCheckYell",21.5},
								},
								{
									"expect",{"<lanemythicount>","==","15"},
									"scheduletimer",{"timerCheckYell",11.5},
								},	
								{
									"expect",{"<lanemythicount>","==","16"},
									"scheduletimer",{"timerCheckYell",11.5},
								},	
								{
									"expect",{"<lanemythicount>","==","17"},
									"scheduletimer",{"timerCheckYell",16.5},
								},	
								{
									"expect",{"<lanemythicount>","==","18"},
									"scheduletimer",{"timerCheckYell",21.5},
								},	
								{
									"expect",{"<lanemythicount>","==","19"},
									"scheduletimer",{"timerCheckYell",6.5},
								},	
								{
									"expect",{"<lanemythicount>","==","20"},
									"scheduletimer",{"timerCheckYell",31.5},
								},	
								{
									"expect",{"<lanemythicount>","==","21"},
									"scheduletimer",{"timerCheckYell",11.5},
								},											{
									"expect",{"<lanemythicount>","==","22"},
									"scheduletimer",{"timerCheckYell",26.5},
								},	
								{
									"expect",{"<lanemythicount>","==","23"},
									"scheduletimer",{"timerCheckYell",31.5},
								},	
								{
									"expect",{"<lanemythicount>","==","24"},
									"scheduletimer",{"timerCheckYell",16.5},
								},	
								{
									"expect",{"<lanemythicount>","==","25"},
									"scheduletimer",{"timerCheckYell",21.5},
								},		
								{
									"expect",{"<lanemythicount>","==","26"},
									"scheduletimer",{"timerCheckYell",11.5},
								},		
								{
									"expect",{"<lanemythicount>","==","27"},
									"scheduletimer",{"timerCheckYell",16.5},
								},		
								{
									"expect",{"<lanemythicount>","==","28"},
									"scheduletimer",{"timerCheckYell",11.5},
								},		
								{
									"expect",{"<lanemythicount>","==","29"},
									"scheduletimer",{"timerCheckYell",21.5},
								},		
								{
									"expect",{"<lanemythicount>","==","30"},
									"scheduletimer",{"timerCheckYell",6.5},
								},		
								{
									"expect",{"<lanemythicount>","==","31"},
									"scheduletimer",{"timerCheckYell",16.5},
								},
							},
						},
						{
							"expect",{"&mythic&","==","false"},
							"invoke",{
								{
									"expect",{"&lfr&","==","false"},
									"set",{lanecount = "INCR|1"},
									"scheduletimer",{"timerLane",0.1},
								},
								{
									"expect",{"&lfr&","==","true"},
									"set",{lanecount = "INCR|1"},
									"scheduletimer",{"timerLaneLFR",0.1},
								},
								{
									"expect",{"<lanecount>","==","1"},
									"scheduletimer",{"timerCheckYell",10},
								},
								{
									"expect",{"<lanecount>","==","2"},
									"scheduletimer",{"timerCheckYell",5},
								},
								{
									"expect",{"<lanecount>","==","3"},
									"scheduletimer",{"timerCheckYell",15},
								},		
								{
									"expect",{"<lanecount>","==","4"},
									"scheduletimer",{"timerCheckYell",5},
								},		
								{
									"expect",{"<lanecount>","==","5"},
									"scheduletimer",{"timerCheckYell",25},
								},		
								{
									"expect",{"<lanecount>","==","6"},
									"scheduletimer",{"timerCheckYell",5},
								},		
								{
									"expect",{"<lanecount>","==","7"},
									"scheduletimer",{"timerCheckYell",25},
								},		
								{
									"expect",{"<lanecount>","==","8"},
									"scheduletimer",{"timerCheckYell",15},
								},		
								{
									"expect",{"<lanecount>","==","9"},
									"scheduletimer",{"timerCheckYell",40},
								},		
								{
									"expect",{"<lanecount>","==","10"},
									"scheduletimer",{"timerCheckYell",10},
								},		
								{
									"expect",{"<lanecount>","==","11"},
									"scheduletimer",{"timerCheckYell",11},
								},		
								{
									"expect",{"<lanecount>","==","12"},
									"scheduletimer",{"timerCheckYell",10},
								},		
								{
									"expect",{"<lanecount>","==","13"},
									"scheduletimer",{"timerCheckYell",20},
								},
								{
									"expect",{"<lanecount>","==","14"},
									"scheduletimer",{"timerCheckYell",10},
								},	
								{
									"expect",{"<lanecount>","==","15"},
									"scheduletimer",{"timerCheckYell",10},
								},	
								{
									"expect",{"<lanecount>","==","16"},
									"scheduletimer",{"timerCheckYell",15},
								},	
								{
									"expect",{"<lanecount>","==","17"},
									"scheduletimer",{"timerCheckYell",20},
								},	
								{
									"expect",{"<lanecount>","==","18"},
									"scheduletimer",{"timerCheckYell",5},
								},	
								{
									"expect",{"<lanecount>","==","19"},
									"scheduletimer",{"timerCheckYell",30},
								},	
								{
									"expect",{"<lanecount>","==","20"},
									"scheduletimer",{"timerCheckYell",10},
								},											{
									"expect",{"<lanecount>","==","21"},
									"scheduletimer",{"timerCheckYell",25},
								},	
								{
									"expect",{"<lanecount>","==","22"},
									"scheduletimer",{"timerCheckYell",30},
								},	
								{
									"expect",{"<lanecount>","==","23"},
									"scheduletimer",{"timerCheckYell",15},
								},	
								{
									"expect",{"<lanecount>","==","24"},
									"scheduletimer",{"timerCheckYell",20},
								},		
								{
									"expect",{"<lanecount>","==","25"},
									"scheduletimer",{"timerCheckYell",10},
								},		
								{
									"expect",{"<lanecount>","==","26"},
									"scheduletimer",{"timerCheckYell",15},
								},		
								{
									"expect",{"<lanecount>","==","27"},
									"scheduletimer",{"timerCheckYell",10},
								},		
								{
									"expect",{"<lanecount>","==","28"},
									"scheduletimer",{"timerCheckYell",20},
								},		
								{
									"expect",{"<lanecount>","==","29"},
									"scheduletimer",{"timerCheckYell",5},
								},		
								{
									"expect",{"<lanecount>","==","30"},
									"scheduletimer",{"timerCheckYell",15},
								},											
							},
						},	
					},
				},
			},
		},
		announces = { 
			DelayedSiegeBombsay = {
				varname = format(L.alert["%s %s %s!"],SN[159481],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[159481],L.alert["on"],L.alert["Me"]),
				desc = 159481,
				icon = ST[159481],
				flashcolor = "RED",
				flashscreen = true,
			},
			Grenadesay = {
				varname = format(L.alert["%s %s %s!"],SN[155864],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[155864],L.alert["on"],L.alert["Me"]),
				desc = 155864,
				icon = ST[155864],
				exlfr = true,
			},				
		},		
		userdata = {
			position = 0,
			position2 = 0,
			engageTime = 0,
			lane1 = {32,75,55,10,65,35,35,100,10,50,28, loop = false, type = "series"},
			lane1mythic = {17,40,15,10,90,5,40,15,14,16,60,25,16,7,42,15,40,10,14, loop = false, type = "series"},
			lane2 = {27,50,45,65,40,25,65,25,30,61,57, loop = false, type = "series"},
			lane2mythic = {23,34,15,25,49,53,18,15,35,21,15,31,14,16,30,34,25,25,14, loop = false, type = "series"},
			lane2lfr = {27,50,100,40,25,65,25,30,61,57, loop = false, type = "series"},
			lane3 = {47,35,40,95,60,95,70,20,25, loop = false, type = "series"},
			lane3mythic = {37,20,15,40,34,41,12,18,15,35,21,14,31,14,16,30,49,35,14, loop = false, type = "series"},
			lane4 = {17,35,110,35,55,55,80,30,50, loop = false, type = "series"},
			lane4mythic = {12,45,15,12,88,5,40,15,14,76,25,16,7,42,15,50,15, loop = false, type = "series"},
			lane1count = 0,
			lane2count = 0,
			lane3count = 0,
			lane4count = 0,
			lanecount = 0,
			lanemythicount = 0,
			ManatArms = "",
			ManatArmsunit = {type = "container"},
			Firemender = "",
			Firemenderunit = {type = "container"},			
			Grenadetarget = "";
		},		
		messages = {
			mIncomingSplit = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],L.chat_BlackrockFoundry["Split"]),
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],L.chat_BlackrockFoundry["Split"]),
				color1 = "YELLOW",
				icon = ST[176312],
				sound = "ALERT13",
			},
			mEnkindle = {
				varname = format(L.alert["%s %s %s (3)"],SN[155921],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[155921],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[155921],L.alert["on"]),
				color1 = "ORANGE",
				icon = ST[155921],
				desc = 155921,
				sound = "ALERT13",
				exdps = true,
				--exhealer = true,
				counter2 = true,
			},
			mDelayedSiegeBomb = {
				varname = format(L.alert["%s %s %s"],SN[159481],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[159481],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 159481,
				icon = ST[159481],
			},
			mCauterizingBolt = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[160140]),
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[160140]),
				color1 = "RED",
				icon = ST[160140],
				sound = "ALERT13",
				desc = 160140,
			},
			mIronBellow = {
				varname = format(L.alert["%s!"],SN[163753]),
				type = "message",
				text = format(L.alert["%s!"],SN[163753]),
				color1 = "BROWN",
				icon = ST[163753],
				sound = "ALERT13",
				desc = 163753,
			},					
			mTrain = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],Train),
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],Train),
				color1 = "ORANGE",
				icon = ST[160140],
				sound = "ALERT14",
				desc = 160140,
				throttle = 2,
			},	
			mGrenade = {
				varname = format(L.alert["%s %s %s"],SN[155864],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &targetname|<Grenadetarget>&"],SN[155864],L.alert["on"]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 155864,
				icon = ST[155864],
			},			
		},
		onstart = {
			{
				--"set",{engageTime = "&gettime&"},
				"alert",{"PulseGrenadeCD", time = 2},
				"alert",{"EnkindleCD", time = 2},
				--"scheduletimer",{"timerLane",0.1},
			},
			{
				"expect",{"&mythic&","==","false"},
				"scheduletimer",{"timerCheckYell",12}, 
				"invoke",{
					{
						"expect",{"&lfr&","==","false"},
						"scheduletimer",{"timerLane1",0.1},
						"scheduletimer",{"timerLane2",0.1},
						"scheduletimer",{"timerLane3",0.1},
						"scheduletimer",{"timerLane4",0.1},
					},
					{
						"expect",{"&lfr&","==","true"},
						"scheduletimer",{"timerLane1",0.1},
						"scheduletimer",{"timerLane2lfr",0.1},
						"scheduletimer",{"timerLane3",0.1},
						"scheduletimer",{"timerLane4",0.1},
					},
				},
			},
			{
				"expect",{"&mythic&","==","true"},
				"scheduletimer",{"timerLane1Mythic",0.1},
				"scheduletimer",{"timerLane2Mythic",0.1},
				"scheduletimer",{"timerLane3Mythic",0.1},
				"scheduletimer",{"timerLane4Mythic",0.1},
				--"scheduletimer",{"timeSplit",130},
				--"scheduletimer",{"timeSplit",286},
			},			
		},
		alerts = {
			Lane1CD = {
				varname = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				type = "dropdown",
				text = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				text2 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Adds train"]),
				text3 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Cannon train"]),
				text4 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Random trains"]),
				text5 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],SN["ej10329"]),	
				text6 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Big add train"]),	
				time = "<lane1>",
				time2 = "<lane1mythic>",
				color1 = "WHITE",
				icon = ST[176312],
				--desc = 174806,
				--counter = true,
			},
			Lane2CD = {
				varname = format(L.alert["%s 2: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				type = "dropdown",
				text = format(L.alert["%s 2: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				text2 = format(L.alert["%s 2: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Adds train"]),
				text3 = format(L.alert["%s 2: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Big add train"]),	
				text4 = format(L.alert["%s 2: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Random trains"]),				
				text5 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],SN["ej10329"]),	
				time = "<lane2>",
				time2 = "<lane2mythic>",
				time3 = "<lane2lfr>",
				color1 = "BLUE",
				icon = ST[176312],
				--desc = ,
				--counter = true,
			},	
			Lane3CD = {
				varname = format(L.alert["%s 3: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				type = "dropdown",
				text = format(L.alert["%s 3: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				text2 = format(L.alert["%s 3: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Adds train"]),
				text3 = format(L.alert["%s 3: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Big add train"]),	
				text4 = format(L.alert["%s 3: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Random trains"]),				
				text5 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],SN["ej10329"]),	
				time = "<lane3>",
				time2 = "<lane3mythic>",
				color1 = "RED",
				icon = ST[176312],
				--desc = ,
				--counter = true,
			},	
			Lane4CD = {
				varname = format(L.alert["%s 4: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				type = "dropdown",
				text = format(L.alert["%s 4: %s"],L.chat_BlackrockFoundry["Lane"],Train),
				text2 = format(L.alert["%s 4: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Adds train"]),
				text3 = format(L.alert["%s 4: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Cannon train"]),	
				text4 = format(L.alert["%s 4: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Random trains"]),	
				text5 = format(L.alert["%s 4: %s"],L.chat_BlackrockFoundry["Lane"],L.chat_BlackrockFoundry["Big add train"]),	
				text6 = format(L.alert["%s 1: %s"],L.chat_BlackrockFoundry["Lane"],SN["ej10329"]),	
				time = "<lane4>",
				time2 = "<lane4mythic>",
				color1 = "GREEN",
				icon = ST[176312],
				--desc = ,
				--counter = true,
			},				
			EnkindleCD = {
				varname = format(L.alert["%s Cooldown"],SN[155921]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155921]),
				time = 12,
				time2 = 6,
				color1 = "GLOBAL",
				icon = ST[155921],
				desc = 155921,
				--exhealer = true,
				exdps = true,
			},
			PulseGrenadeCD = {
				varname = format(L.alert["%s Cooldown"],SN[135592]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[135592]),
				time = 12,
				time2 = 7,
				color1 = "GLOBAL",
				icon = ST[155864],
				desc = 155864,
				throttle = 2,
			},
			IronbellowCD = {
				varname = format(L.alert["%s Cooldown"],SN[163753]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163753]),
				time = 12,
				color1 = "GLOBAL",
				icon = ST[163753],
				desc = 163753,
			},
			-- Warning
			wPulseGrenade = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[135592]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[135592]),
				time = 2,
				color1 = "RED",
				icon = ST[155864],
				sound = "ALERT13",
				desc = 155864,
				throttle = 2,
			},	
			wSplit = {
				varname = format(L.alert["%s!"],L.chat_BlackrockFoundry["Split"]),
				type = "simple",
				text = format(L.alert["%s!"],L.chat_BlackrockFoundry["Split"]),
				time = 2,
				color1 = "RED",
				icon = ST[176312],
				sound = "ALERT18",
				--desc = 155864,
				throttle = 2,
			},				
			-- Inform
			iPulseGrenade = {
				varname = format(L.alert["%s %s, %s!"],SN[135592],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[135592],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[155864],
				sound = "ALERT12",
				desc = 155864,
				flashscreen = true,
			},		
			-- Casts
			DelayedSiegeBombCast = {
				varname = format(L.alert["%s Active"],SN[159481]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[159481]),
				time = 4.9,
				color1 = "RED",
				icon = ST[159481],
				desc = 159481,
			},
			-- Debuff
			RendAndTearDebuff = {
				varname = format(L.alert["%s Debuff"],SN[155921]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[155921]),
				text2 = format(L.alert["#5# (1): %s"],SN[155921]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[155921]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[155921]),
				time = 25,
				color1 = "ORANGE",
				desc = 155921,
				icon = ST[155921],
				tag = "#5#",
				exdps = true,				
			},
			DelayedSiegeBombDebuff = {
				varname = format(L.alert["%s Debuff"],SN[159481]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[159481]),
				text2 = format(L.alert["&upvalue&: %s"],SN[159481]),
				time = 4.9,
				time2 = 11,
				color1 = "ORANGE",
				desc = 159481,
				icon = ST[159481],
				tag = "#5#",
				exdps = true,				
			},				
		},
		events = {		
			-- Enkindle
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {155921},
				execute = {
					{
						"message","Enkindle",
						"alert","EnkindleCD",
					},		
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","RendAndTearDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"RendAndTearDebuff", text = 2},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {155921},
				execute = {
					{
						"message",{"Enkindle", text = 2},
						"alert","EnkindleCD",
					},		
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"RendAndTearDebuff", text = 3},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"RendAndTearDebuff", text = 4},
					},							
				},
			},	
			-- PulseGrenade
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS", --SPELL_CAST_START
				spellid = {155864},
				execute = {
					{
						"batchalert",{"PulseGrenadeCD","wPulseGrenade"},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {165195},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iPulseGrenade",
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {165195},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iPulseGrenade",
					},									
				},
			},
			{
				type = "event",
				event = "UNIT_TARGET",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"set",{Grenadetarget = "&bosstarget|boss1&"},
						"expect",{"&bosstarget|boss1&","~=","false"},
						"message","mGrenade",
						"invoke",{
							{
								"expect",{"<Grenadetarget>","==","&playername&"},
								"announce","Grenadesay",
							},
							{
								"expect",{"<Grenadetarget>","~=","&playername&"},
								"arrow","Grenadearrow",
							},							
						},
					},												
				},
			},
			-- IronBellow
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163753},
				execute = {
					{
						"alert","IronbellowCD",
						"message","mIronBellow",
					},			
				},
			},
			-- CauterizingBolt
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {160140},
				execute = {
					{
						"message","mCauterizingBolt",
					},			
				},
			},	
			-- DelayedSiegeBomb
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {159481},
				execute = {
					{
						"target",{
							source = "#1#",
							wait = 0.05,
							schedule = 25,
							--arrow = "",
							raidicon = "DelayedSiegeBombmark",
							announce = "DelayedSiegeBombsay",
							message = "mDelayedSiegeBomb",
							alerts = {
								--self = "DelayedSiegeBombDebuff",
								batchself = {"DelayedSiegeBombCast","DelayedSiegeBombDebuff"},
								other = {"DelayedSiegeBombDebuff", text = 2, time = 2},
							},
						},	
					},
				},
			},	
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {159481},
				execute = {
					{
						--"message","mDelayedSiegeBomb",
						"raidicon","DelayedSiegeBombmark",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
					--	"announce","DelayedSiegeBombsay",
						"alert","DelayedSiegeBombCast",
						"alert","DelayedSiegeBombDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"DelayedSiegeBombDebuff", text = 2},
					},					
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {159481},
				execute = {
					{
						"removeraidicon","#5#",
						"quash","DelayedSiegeBombDebuff",
						"quash","DelayedSiegeBombCast",
					},			
				},
			},	
			-----------------------
			--[[{
				type = "event",
				event = "YELL", 
				execute = {
					{
						"expect",{"#5#","==",Train},
						"canceltimer","timerCheckYell",
						"message","mTrain",
						"invoke",{
							{
								"expect",{"&mythic&","==","true"},
								"set",{lanemythicount = "INCR|1"},
								"scheduletimer",{"timerLaneMythic",0.1},
							},
							{
								"expect",{"&mythic&","==","false"},
								"invoke",{
									{
										"expect",{"&lfr&","==","false"},
										"set",{lanecount = "INCR|1"},
										"scheduletimer",{"timerLane",0.1},
									},
									{
										"expect",{"&lfr&","==","true"},
										"set",{lanecount = "INCR|1"},
										"scheduletimer",{"timerLaneLFR",0.1},
									},
								},
							},	
						},
					},
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","80791"}, --Iron Bellow
						"quash","IronbellowCD",
					},
				},
			},
			--[[{
				type = "event",
				event = "UPDATE_MOUSEOVER_UNIT",
				execute = {
					{
						"expect",{"&bossid|mouseover&","==","80791"}, -- Grom'kar Man-at-Arms
						"set",{ShardofTectus = "&bossid|mouseover|true&"},
						"expect",{"&tabread|ShardofTectusunit|<ShardofTectus>&","~=","true"},
						"raidicon","ShardofTectusmark",
						"tabinsert",{"ShardofTectusunit","<ShardofTectus>","true"},
					},				
				},
			},--]]
			{
				type = "event",
				event = "UNIT_TARGET",
				execute = {
					{
						"expect",{"#1#","~=","0"},
						"invoke",{
							{
								"expect",{"&unittarget|#1#&","==","80791"}, -- Grom'kar Man-at-Arms
								"set",{ManatArms = "&unittarget|#1#|true&"},
								--"tabinsert",{"ManatArmsunit","<ManatArms>","true"},
								--"debug",{"&unittarget|#1#&","<ManatArms>","&tabread|ManatArmsunit|<ManatArms>&"},
								"expect",{"&tabread|ManatArmsunit|<ManatArms>&","~=","true"},
								--"debug",{"lalalalala","#1#","&tabread|ManatArmsunit|<ManatArms>&"},
								"raidicon","GromkarManatArmsmark",
								"tabinsert",{"ManatArmsunit","<ManatArms>","true"},
							},
							{
								"expect",{"&unittarget|#1#&","==","77487"}, -- Grom'kar Firemender
								"set",{Firemender = "&unittarget|#1#|true&"},
								--"tabinsert",{"Firemenderunit","<Firemender>","true"},
								--"debug",{"&unittarget|#1#&","<Firemender>","&tabread|Firemenderunit|<Firemender>&"},
								"expect",{"&tabread|Firemenderunit|<Firemender>&","~=","true"},
								--"debug",{"lalalalala","#1#","&tabread|Firemenderunit|<Firemender>&"},
								"raidicon","GromkarFiremendermark",
								"tabinsert",{"Firemenderunit","<Firemender>","true"},
							},								
						},
					},					
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end