local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1391)
do
	local data = {
		version = 9,
		key = "FelLordZakuun",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-FelLordZakuun.BLP:35:35",
		respawntime = 30,
		triggers = {
			scan = {89890},
			encounterid = 1777,
			ejid = {1391},
		},
		onactivate = {
			tracing = {
				89890,
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 89890,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 600,
		},
		userdata = {
			Befouledunits = {type = "container", wipein = 3},
			SeedOfDestructionunits = {type = "container", wipein = 3},
			Rumbling = 0,
			Cavitation = 0,
			SoulCleave = 1,
			enraged = 0,
			phaseEnd = 0,
			cleaveCount = 1,
		},
		raidicons = {
			SeedOfDestructionmark = {
				varname = SN[181508],
				type = "MULTIFRIENDLY",
				persist = 60,
				unit = "#5#", 
				icon = 1,
				total = 8,
				reset = 10,				
				desc = 181508,
				icon2 = ST[181508],
			},			
		},			
		timers = {
			timerBefouled = {
				{
					"message","mBefouled",
				},
			},
			timerSeedOfDestruction = {
				{
					"message","mSeedOfDestruction",
				},
			},			
		},	
		announces = { 
			Befouledsay = {
				varname = format(L.alert["%s %s %s!"],SN[179711],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[179711],L.alert["on"],L.alert["Me"]),
				desc = 179711,
				icon = ST[179711],
				--flashcolor = "RED",
				--flashscreen = true,
			},
			SeedOfDestructionsay = {
				varname = format(L.alert["%s %s %s!"],SN[181508],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[181508],L.alert["on"],L.alert["Me"]),
				desc = 181508,
				icon = ST[181508],
			},			
		},
		messages = {
			mBefouled = {
				varname = format(L.alert["%s %s %s"],SN[179711],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|Befouledunits&"],SN[179711],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 179711,
				icon = ST[179711],
				exdps = true,
				extank = true,
			},
			mSeedOfDestruction = {
				varname = format(L.alert["%s %s %s"],SN[181515],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|SeedOfDestructionunits&"],SN[181515],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181515,
				icon = ST[181515],
			},			
			--[[mHeavilyArmed = {
				varname = format(L.alert["%s %s %s"],SN[179711],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[179711],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 179711,
				icon = ST[179711],
				exdps = true,
			},--]]
			mDisembodied = {
				varname = format(L.alert["%s %s %s"],SN[179407],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[179407],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 179407,
				icon = ST[179407],
			},		
			mSoulCleave = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[179406]),
				type = "message",
				text = format(L.alert["%s %s (<cleaveCount>)"],L.alert["Incoming"],SN[179406]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 179406,
				icon = ST[179406],
				counter2 = true,
			},				
		},
		onstart = {
			{
				"batchalert",{"CavitationCD","FoulCD","SoulCleaveCD"},
				"alert",{"RumblingFissuresCD", time = 2},
				"alert",{"DisarmedCD", time = 2},
				"set",{phaseEnd = "&gettime|87&"},
			},		
		},
		alerts = {
			PhaseOneCD = {
				varname = format(L.alert["%s Cooldown"],format(L.alert["Phase %s"],"1")),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],format(L.alert["Phase %s"],"1")),
				time = 34,
				color1 = "GLOBAL",
				icon = ST[179670],
				--desc = 179709,
			},
			PhaseTwoCD = {
				varname = format(L.alert["%s Cooldown"],format(L.alert["Phase %s"],"2")),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],format(L.alert["Phase %s"],"2")),
				time = 34,
				color1 = "GLOBAL",
				icon = ST[179667],
				--desc = 179709,
			},						
			CavitationCD = {
				varname = format(L.alert["%s Cooldown"],SN[189009]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[189009]),
				time = 36.5,
				time2 = 40,
				time3 = "<Cavitation>",
				time4 = 33,
				color1 = "GLOBAL",
				icon = ST[189009],
				desc = 189009,
			},
			FoulCD = {
				varname = format(L.alert["%s Cooldown"],SN[179709]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[179709]),
				time = 16,
				color1 = "GLOBAL",
				icon = ST[179709],
				desc = 179709,
			},	
			SoulCleaveCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[179406]),
				type = "dropdown",
				text = "(<cleaveCount>) "..format(L.alert["%s Cooldown"],SN[179406]),
				time = 25.5,
				time2 = "<SoulCleave>",
				time3 = 40,
				time4 = 24,
				color1 = "GLOBAL",
				icon = ST[179406],
				desc = 179406,
				counter = true,
			},				
			BefouledCD = {
				varname = format(L.alert["%s Cooldown"],SN[179711]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[179711]),
				time = 40,
				time2 = 16,
				time3 = 17,
				color1 = "GLOBAL",
				icon = ST[179711],
				desc = 179711,
			},		
			SeedOfDestructionCD = {
				varname = format(L.alert["%s Cooldown"],SN[181508]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181508]),
				time = 14.5,
				time2 = 9,
				time3 = 40,
				time4 = 27,
				color1 = "GLOBAL",
				icon = ST[181508],
				desc = 181508,
			},
			RumblingFissuresCD = {
				varname = format(L.alert["%s Cooldown"],SN[179583]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[179583]),
				time = 40,
				time2 = 7,
				time3 = "<Rumbling>",
				time4 = 4,
				time5 = 5,
				color1 = "GLOBAL",
				icon = ST[179583],
				desc = 179583,
			},	
			DisarmedCD = {
				varname = format(L.alert["%s Cooldown"],SN[179667]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[179667]),
				time = 33.5,
				time2 = 87,
				time3 = 85,
				color1 = "GLOBAL",
				icon = ST[179667],
				desc = 179667,
			},			
			-- Warning
			wRumblingFissure = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[179583]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[179583]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[179681],
				sound = "ALERT10",
				desc = 179681,
			},			
			wEnrage = {
				varname = format(L.alert["%s!"],SN[179681]),
				type = "simple",
				text = format(L.alert["%s!"],SN[179681]),
				time = 2,
				color1 = "RED",
				icon = ST[179681],
				sound = "ALERT10",
				desc = 179681,
				--flashscreen = true, 
			},
			wDisarmed = {
				varname = format(L.alert["%s!"],SN[179667]),
				type = "simple",
				text = format(L.alert["%s!"],SN[179667]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[179667],
				sound = "ALERT10",
				desc = 179667,
				--flashscreen = true, 
			},
			wDisarmedOver = {
				varname = format(L.alert["%s %s!"],SN[179667],L.alert["Over"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[179667],L.alert["Over"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[179667],
				sound = "ALERT14",
				desc = 179667,
				--flashscreen = true, 
			},
			wCavitation = {
				varname = format(L.alert["%s!"],SN[189009]),
				type = "simple",
				text = format(L.alert["%s!"],SN[189009]),
				time = 2,
				color1 = "RED",
				icon = ST[189009],
				sound = "ALERT11",
				desc = 189009,
				--flashscreen = true, 
			},									
			-- Inform
			iBefouledOver = {
				varname = format(L.alert["%s %s!"],SN[179711],L.alert["Over"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[179711],L.alert["Over"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[179711],
				sound = "ALERT14",
				desc = 179711,
				--flashscreen = true, 
			},	
			iSeedOfDestruction = {
				varname = format(L.alert["%s %s %s!"],SN[181508],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[181508],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[181508],
				sound = "ALERT12",
				desc = 181508,
				flashscreen = true,
			},	
			iFelCrystalDamage = {
				varname = format(L.alert["%s %s %s, %s!"],SN[179620],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[179620],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[179620],
				sound = "ALERT12",
				desc = 179620,
				flashscreen = true,
				throttle = 1.5,
			},	
			-- Casts
			SeedOfDestructionAct = {
				varname = format(L.alert["%s Active"],SN[181508]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[181508]),
				time = 5,
				color1 = "RED",
				icon = ST[84474],
				desc = 181508,
			},
			DisembodiedAct = {
				varname = format(L.alert["%s Active"],SN[179407]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[179407]),
				time = 15,
				color1 = "CYAN",
				icon = ST[179407],
				desc = 179407,
			},			
			-- Debuff
			DisembodiedDebuff = {
				varname = format(L.alert["%s Debuff"],SN[179407]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[179407]),
				text2 = format(L.alert["#5#: %s"],SN[179407]),
				time = 15,
				color1 = "RED",
				desc = 179407,
				icon = ST[179407],
				tag = "#5#",
				exdps = true,				
			},
			-- Absorbs
			--[[BefouledAbsorb = {
				varname = format(L.alert["%s Absorbs"],SN[189030]),
				text = format(L.alert["#5#: %s"],SN[189030]),
				textformat = format("%s => %%s/%%s - %%d%%%%",L.alert["Absorb"]),
				type = "unitabsorb",
				time = 600,
				flashtime = 5,
				color1 = "YELLOW",
				color2 = "INDIGO",
				--sound = "ALERT4",
				icon = ST[189030],
				unit = "#5#",
				spellid = SN[189030],
				desc = 189030,
			},--]]
		},
		events = {
			-- SoulCleave
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {179406},
				execute = {
					{
						"message","mSoulCleave",
						"set",{cleaveCount = "INCR|1"},
					},
					{
						"expect",{"&getprev|<phaseEnd>&",">","40"},
						"alert",{"SoulCleaveCD", time = 3},
					},
				},
			},
			-- Foul
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {179709},
				execute = {
					{
						"alert","FoulCD",
					},
				},
			},--]]
			-- Befouled
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {189030},
				execute = {
					{
						"insert",{"Befouledunits","#5#"},
						"canceltimer","timerBefouled",
						"scheduletimer",{"timerBefouled",0.3},
						--"alert","BefouledAbsorb",
					},
					{
						"expect",{"&count|Befouledunits&","==","1"},
						"invoke",{
							{
								"expect",{"&getprev|<phaseEnd>&",">","40"},
								"alert","BefouledCD",
							},	
						},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","Befouledsay",
						"openwindow",{"6",nil,false,179711},
					},
				},
			},
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_REFRESH",
				spellid = {189030, 189031, 189032},
				--dstisplayerunit = true,
				execute = {
					{
						--"alert","BefouledAbsorb",
					},
				},
			},--]]
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {189032},
				--dstisplayerunit = true,
				execute = {
					--{
						--"quash","BefouledAbsorb",
					--},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iBefouledOver",
						"closewindow",{true},
					},
				},
			},			
			-- HeavilyArmed
			--[[{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {179671},
				execute = {
					{
						"message","mHeavilyArmed",
					},
				},
			},--]]
			-- Disembodied
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {179407},
				execute = {
					{
						"expect",{"&istank|#5#&","==","true"},
						"message","mDisembodied",
					},
					{
						"expect",{"&mythic&","==","true"},
						"alert","DisembodiedAct",
					},				
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","DisembodiedDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"DisembodiedDebuff", text = 2},
					},					
				},
			},
			-- RumblingFissures
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {179583},
				execute = {	
					{
						"alert","RumblingFissuresCD",
						"alert","wRumblingFissure",
					},			
				},
			},	
			-- SeedOfDestruction
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {181508, 181515},
				execute = {
					{
						"insert",{"SeedOfDestructionunits","#5#"},
						"canceltimer","timerSeedOfDestruction",
						"scheduletimer",{"timerSeedOfDestruction",0.3},
						"raidicon","SeedOfDestructionmark",
					},
					{
						"expect",{"&count|SeedOfDestructionunits&","==","1"},
						"invoke",{
							{
								"expect",{"<enraged>","==","1"},
								"alert",{"SeedOfDestructionCD", time = 3},
							},
							{
								"expect",{"<enraged>","~=","1"},
								"alert","SeedOfDestructionCD",
							},							
						},
						"alert","SeedOfDestructionAct",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","SeedOfDestructionsay",
						"alert","iSeedOfDestruction",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {181508, 181515},
				execute = {
					{
						"removeraidicon","#5#",
					},
				},
			},
			-- Enrage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {179681},
				execute = {
					{
						"set",{enraged = 1},
						"set",{phaseEnd = "MATHHUGE"},
						"batchquash",{"DisarmedCD","SoulCleaveCD","PhaseOneCD"},
						"alert","wEnrage",
						"alert",{"RumblingFissuresCD", time = 5},
						"alert",{"BefouledCD", time = 3},
						"alert",{"SeedOfDestructionCD", time = 4},
						"alert","CavitationCD",
					},
				},
			},
			-- Cavitation
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {189009},
				execute = {	
					{
						"alert","wCavitation",
					},	
					{
						"expect",{"&getprev|<phaseEnd>&",">","40"},
						"alert",{"CavitationCD", time = 2},
					},					
				},
			},	
			-- Disarmed
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {179667},
				execute = {
					{
						"batchquash",{"SoulCleaveCD","CavitationCD","RumblingFissuresCD","BefouledCD"},
						"set",{phaseEnd = "&gettime|34&"},
						"batchalert",{"PhaseOneCD","wDisarmed"},
						"alert",{"SeedOfDestructionCD", time = 2},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {179667},
				execute = {
					{
						"expect",{"<enraged>","==","0"},
						"batchquash",{"PhaseOneCD","SeedOfDestructionCD"},
						"set",{cleaveCount = 1},
						"set",{phaseEnd = "&gettime|85&"},
						"batchalert",{"wDisarmedOver","PhaseTwoCD"},
						"alert",{"RumblingFissuresCD", time = 4},
						"alert",{"BefouledCD", time = 2},
						"alert",{"SoulCleaveCD", time = 4},
						"alert",{"CavitationCD", time = 4},
					},
				},
			},
			-- FelCrystalDamage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {181653},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelCrystalDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {181653},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelCrystalDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {181653},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelCrystalDamage",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end