local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1392)
do
	local data = {
		version = 12,
		key = "Kormrok",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Kormok.BLP:35:35",
		respawntime = 14,
		triggers = {
			scan = {90435}, 
			encounterid = 1787,
			ejid = 1392,
		},
		onactivate = {
			tracing = {
				90435,
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 90435,
		},
		windows = {
			proxwindow = true,
		},
		raidicons = {
			ExplosiveBurstmark = {
				varname = SN[181306],
				type = "FRIENDLY",
				persist = 60,
				unit = "#5#",
				icon = 1,
				desc = 181306,
				icon2 = ST[181306],
			},			
		},
		enrage = {

		},
		arrows = {
			ExplosiveBurstArrow = {
				varname = SN[181306],
				unit = "#5#",
				persist = 10,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[181306],
				range1 = 5,
				range2 = 15,
				range3 = 30,
				desc = 181306,
				icon = ST[181306],
			},
		},		
		userdata = {
			poundCount = 1,
			tankDebuffCount = 1,
			phaseAbilityCount = 0,
			isPounding = 0,
			mod = 1,
			tmpmod = 1,
			FoulCrushunits = {type = "container", wipein = 3},
			empCounts = {type = "container"},
		},
		timers = {
			timerGraspingHands = {
				{
					"closewindow",{true},
				},
				{
					"expect",{"&isranged&","==","true"},  
					"openwindow",{"4"}, 
				},				
			},
		},	
		announces = { 
			ExplosiveBurstsay = {
				varname = format(L.alert["%s %s %s!"],SN[181306],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[181306],L.alert["on"],L.alert["Me"]),
				desc = 181306,
				icon = ST[181306],
				flashcolor = "RED",
				flashscreen = true,
				sound = "ALERT12",
			},
		},			
		messages = {
			mFoulCrush = {
				varname = format(L.alert["%s %s %s"],SN[181307],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[181307],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181307,
				icon = ST[181307],
			},
			mExplosiveBurst = {
				varname = format(L.alert["%s %s %s"],SN[181306],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[181306],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181306,
				icon = ST[181306],
			},
			mFelOutpouring = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[181292]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[181292]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181292,
				icon = ST[181292],
			},
			mEmpFelOutpouring = {
				varname = format(L.alert["%s!"],SN[181293]),
				type = "message",
				text = format(L.alert["%s!"],SN[181293]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181293,
				icon = ST[181293],
			},			
			mPoundInc = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[180244]),
				type = "message",
				text = format(L.alert["%s %s (<poundCount>)"],L.alert["Incoming"],SN[180244]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 180244,
				icon = ST[180244],
				counter2 = true,
			},
			mPound = {
				varname = format(L.alert["%s (2)"],SN[180244]),
				type = "message",
				text = format(L.alert["%s (<poundCount>)"],SN[180244]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 180244,
				icon = ST[180244],
				counter2 = true,
			},		
			mShadowEnergy = {
				varname = format(L.alert["%s!"],SN[180115]),
				type = "message",
				text = format(L.alert["%s!"],SN[180115]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 180115,
				icon = ST[180115],
			},	
			mExplosiveEnergy = {
				varname = format(L.alert["%s!"],SN[180116]),
				type = "message",
				text = format(L.alert["%s!"],SN[180116]),
				color1 = "CYAN",
				sound = "ALERT13",
				desc = 180116,
				icon = ST[180116],
			},	
			mFoulEnergy = {
				varname = format(L.alert["%s!"],SN[180117]),
				type = "message",
				text = format(L.alert["%s!"],SN[180117]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 180117,
				icon = ST[180117],
			},
			mFoulCrush = {
				varname = format(L.alert["%s"],SN[181307]),
				type = "message",
				text = format(L.alert["%s"],SN[181307]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181307,
				icon = ST[181307],
				exdps = true,
			},
			mSwat = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[181305]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[181305]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181305,
				icon = ST[181305],
			},				
		},
		onstart = {
			{
				"tabinsert",{"empCounts","hiddenPound","1"},
				"tabinsert",{"empCounts","shadow","0"},
				"tabinsert",{"empCounts","foul","0"},
				"tabinsert",{"empCounts","shadow","0"},
				"tabinsert",{"empCounts","phase","0"},
				"tabinsert",{"empCounts","explosive","0"},
				"alert",{"StagesCD", time = 3},
			},
			{
				"expect",{"&mythic&","==","true"},
				"set",{mod = 0.84},
			},	
			{
				"expect",{"&isranged&","==","true"},
				"openwindow",{"4"},
			},			
		},
		alerts = {
			PoundCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[180244]),
				type = "dropdown",
				text = "(<poundCount>) "..format(L.alert["%s Cooldown"],SN[180244]),
				time = 39,
				time2 = 42,
				time3 = 52,
				time4 = 40,
				time5 = 62,
				time6 = "<tmpmod>",
				time7 = 30,
				time8 = 35,
				time9 = 25,
				color1 = "GLOBAL",
				icon = ST[180244],
				desc = 180244,
				counter = true,
			},
			ExplosiveBurstCD = {
				varname = format(L.alert["%s Cooldown"],SN[181306]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181306]),
				time = 32,
				time2 = 50,
				time3 = 40,
				time4 = "<tmpmod>",
				time5 = 20,
				color1 = "GLOBAL",
				icon = ST[181306],
				desc = 181306,
			},
			FoulCrushCD = {
				varname = format(L.alert["%s Cooldown"],SN[181307]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181307]),
				time = 42,
				time2 = 32,
				time3 = 40,
				time4 = "<tmpmod>",
				time5 = 20,
				time6 = 50,
				color1 = "GLOBAL",
				icon = ST[181307],
				desc = 181307,
			},			
			ExplosiveRunesCD = {
				varname = format(L.alert["%s Cooldown"],SN[181296]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181296]),
				time = 48,
				time2 = "<tmpmod>",
				time3 = 13,
				time4 = 10,
				time5 = 35,
				color1 = "GLOBAL",
				icon = ST[181296],
				desc = 181296,
			},
			EmpExplosiveRunesCD = {
				varname = format(L.alert["%s Cooldown"],SN[181297]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181297]),
				time = "<tmpmod>",
				color1 = "GLOBAL",
				icon = ST[181297],
				desc = 181297,
			},			
			FelOutpouringCD = {
				varname = format(L.alert["%s Cooldown"],SN[181292]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181292]),
				time = 90,
				time2 = 82,
				time3 = 66,
				time4 = 14,
				time5 = "<tmpmod>",
				time6 = 10,
				time7 = 45,
				color1 = "GLOBAL",
				icon = ST[181292],
				desc = 181292,
			},
			EmpFelOutpouringCD = {
				varname = format(L.alert["%s Cooldown"],SN[181293]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181293]),
				time = "<tmpmod>",
				color1 = "GLOBAL",
				icon = ST[181293],
				desc = 181293,
			},			
			GraspingHandsCD = {
				varname = format(L.alert["%s Cooldown"],SN[181299]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181299]),
				time = 90,
				time2 = 65,
				time3 = 82,
				time4 = 54,
				time5 = "<tmpmod>",
				time6 = 43,
				time7 = 13,
				time8 = 121,
				time9 = 70,
				time10 = 56,
				time11 = 10,
				time12 = 35,
				color1 = "GLOBAL",
				icon = ST[181299],
				desc = 181299,
			},
			DraggingHandsCD = {
				varname = format(L.alert["%s Cooldown"],SN[181300]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181300]),
				time = "<tmpmod>",
				color1 = "GLOBAL",
				icon = ST[181300],
				desc = 181300,
			},			
			SwatCD = {
				varname = format(L.alert["%s Cooldown"],SN[181305]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181305]),
				time = "<tmpmod>",
				time2 = 30,
				time3 = 60,
				color1 = "GLOBAL",
				icon = ST[181305],
				desc = 181305,
			},	
			StagesCD = { -- Leap
				varname = format(L.alert["Next %s"],SN[180068]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[180068]),
				time = "<tmpmod>",
				time2 = 114,
				time3 = 10,
				time4 = 92,
				time5 = 122,
				color1 = "GLOBAL",
				icon = ST[180068],
				desc = 180068,
			},				
			-- Warning
			wExplosiveRunes = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181296]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181296]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[181296],
				sound = "ALERT11",
				desc = 181296,
				--flashscreen = true,
			},
			wEmpExplosiveRunes = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181297]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181297]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[181297],
				sound = "ALERT11",
				desc = 181297,
				--flashscreen = true,
			},			
			wGraspingHands = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181299]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181299]),
				time = 2,
				color1 = "RED",
				icon = ST[181299],
				sound = "ALERT10",
				desc = 181299,
				--flashscreen = true,
			},
			wDraggingHands = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181300]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181300]),
				time = 2,
				color1 = "RED",
				icon = ST[181300],
				sound = "ALERT10",
				desc = 181300,
				--flashscreen = true,
			},			
			wEnrage = {
				varname = format(L.alert["%s!"],SN[186882]),
				type = "simple",
				text = format(L.alert["%s!"],SN[186882]),
				time = 2,
				color1 = "RED",
				icon = ST[186882],
				sound = "ALERT10",
				desc = 186882,
			},			
			-- Inform
		
			-- Casts
			ExplosiveRunesInc = {
				varname = format(L.alert["%s Incoming"],SN[181296]),
				type = "centerpopup",
				text = format(L.alert["%s Incoming"],SN[181296]),
				time = 4,
				color1 = "RED",
				icon = ST[181296],
				desc = 181296,
			},
			EmpExplosiveRunesInc = {
				varname = format(L.alert["%s Incoming"],SN[181297]),
				type = "centerpopup",
				text = format(L.alert["%s Incoming"],SN[181297]),
				time = 4,
				color1 = "RED",
				icon = ST[181297],
				desc = 181297,
			},			
			PoundInc = {
				varname = "(2) "..format(L.alert["%s Incoming"],SN[180244]),
				type = "centerpopup",
				text = "(<poundCount>) "..format(L.alert["%s Incoming"],SN[180244]),
				time = 5,
				color1 = "ORANGE",
				icon = ST[180244],
				desc = 180244,
				counter = true,
			},				
			-- Debuff
			ExplosiveBurstDebuff = {
				varname = format(L.alert["%s Debuff"],SN[181306]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[181306]),
				text2 = format(L.alert["#5#: %s"],SN[181306]),
				time = 10,
				color1 = "ORANGE",
				desc = 181306,
				icon = ST[181306],
				tag = "#5#",
				exdps = true,				
			},
		},
		events = {
			-- ExplosiveBurst
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181306},
				execute = {
					{
						"message","mExplosiveBurst",
						"raidicon","ExplosiveBurstmark",
						"set",{tankDebuffCount = "INCR|1"},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","ExplosiveBurstsay", 
						"alert","ExplosiveBurstDebuff",
						"openwindow",{"30",nil,false,181306},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"ExplosiveBurstDebuff", text = 2},
						"arrow","ExplosiveBurstArrow",
						"openwindow",{"30","#5#",false,181306},
					},
					{
						"expect",{"&lfr& <tankDebuffCount>","==","true 2"},
						"alert",{"ExplosiveBurstCD", time = 2},
					},
					{
						"expect",{"&lfr&","==","false"},
						"expect",{"<tankDebuffCount>","<","4"},
						"invoke",{
							{
								"expect",{"<tankDebuffCount>","==","2"},
								"set",{tmpmod = 38},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveBurstCD", time = 4},
							},
							{
								"expect",{"<tankDebuffCount>","~=","2"},
								"set",{tmpmod = 50},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveBurstCD", time = 4},
							},					
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {181306},
				execute = {
					{
						"removeraidicon","#5#",
						"closewindow",{true},
					},
					{
						"expect",{"<isPounding> &isranged&","==","1 true"},  
						"openwindow",{"5"}, 
					},
				},
			},
			-- FoulCrush
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181307},
				execute = {
					{
						"set",{tankDebuffCount = "INCR|1"},
						"message","mFoulCrush",
					},
					{
						"expect",{"&lfr& <tankDebuffCount>","==","true 2"},
						"alert",{"FoulCrushCD", time = 6},
					},
					{
						"expect",{"&lfr&","==","false"},
						"expect",{"<tankDebuffCount>","<","4"},
						"invoke",{					
							{
								"expect",{"<tankDebuffCount>","==","2"},
								"set",{tmpmod = 50},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FoulCrushCD", time = 4},
							},
							{
								"expect",{"<tankDebuffCount>","~=","2"},
								"set",{tmpmod = 38},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FoulCrushCD", time = 4},
							},					
						},
					},
				},
			},	
			-- FelOutpouring
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181292},
				execute = {
					{
						--"expect",{"&tabread|empCounts|isfirst&","==","true"},
						"tabupdate",{"empCounts","shadow","INCR|1"},
						"set",{phaseAbilityCount = "INCR|1"},
				--		"alert","FelOutpouringCD",
						"message","mFelOutpouring",
					},
					{
						"expect",{"&lfr&","==","true"},
						"expect",{"&tabread|empCounts|shadow&",">","0"},
						"alert",{"FelOutpouringCD", time = 7},
					},
					{
						"expect",{"&lfr& &tabread|empCounts|phase& <phaseAbilityCount>","==","false 3 1"},
						"invoke",{
							{
								"expect",{"&tabread|empCounts|shadow&","<","1"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FelOutpouringCD", time = 4},
							},					
							{
								"expect",{"&tabread|empCounts|shadow&",">","0"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpFelOutpouringCD",
							},
						},
					},
				},
			}, -- Empowered FelOutpouring
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181293},
				execute = {
					{
					--	"expect",{"&tabread|empCounts|isfirst&","==","true"},
						"tabupdate",{"empCounts","shadow","INCR|1"},
						"set",{phaseAbilityCount = "INCR|1"},
					--	"alert","FelOutpouringCD",
						"message","mEmpFelOutpouring",
					},
					{
						"expect",{"&lfr&","==","true"},
						"expect",{"&tabread|empCounts|shadow&",">","0"},
						"alert",{"FelOutpouringCD", time = 7},
					},
					{
						"expect",{"&lfr& &tabread|empCounts|phase& <phaseAbilityCount>","==","false 3 1"},
						"invoke",{				
							{
								"expect",{"&tabread|empCounts|shadow&","<","1"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FelOutpouringCD", time = 4},
							},					
							{
								"expect",{"&tabread|empCounts|shadow&",">","0"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpFelOutpouringCD",
							},
						},
					},
				},
			},				
			-- ExplosiveRunes
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181296},
				execute = {
					{
						"batchalert",{"ExplosiveRunesInc","wExplosiveRunes"},
						"tabupdate",{"empCounts","explosive","INCR|1"},
						"set",{phaseAbilityCount = "INCR|1"},
					},
					{
						"expect",{"&lfr&","==","true"},
						"expect",{"&tabread|empCounts|explosive&",">","0"},
						"alert",{"ExplosiveRunesCD", time = 5},
					},
					{
						"expect",{"&lfr& &tabread|empCounts|phase& <phaseAbilityCount>","==","false 1 1"},
						"invoke",{						
							{
								"expect",{"&tabread|empCounts|explosive&","<","1"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveRunesCD", time = 2},
							},					
							{
								"expect",{"&tabread|empCounts|explosive&",">","0"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpExplosiveRunesCD",
							},	
						},
					},
				},
			},
			-- EmpExplosiveRunes
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181297},
				execute = {
					{
						"batchalert",{"EmpExplosiveRunesInc","wEmpExplosiveRunes"},
						"tabupdate",{"empCounts","explosive","INCR|1"},
						"set",{phaseAbilityCount = "INCR|1"},
					},
					{
						"expect",{"&lfr&","==","true"},
						"expect",{"&tabread|empCounts|explosive&",">","0"},
						"alert",{"ExplosiveRunesCD", time = 5},
					},
					{
						"expect",{"&lfr& &tabread|empCounts|phase& <phaseAbilityCount>","==","false 1 1"},
						"invoke",{						
							{
								"expect",{"&tabread|empCounts|explosive&","<","1"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveRunesCD", time = 2},
							},					
							{
								"expect",{"&tabread|empCounts|explosive&",">","0"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpExplosiveRunesCD",
							},
						},
					},
				},
			},			
			-- GraspingHands
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181299},
				execute = {	
					{
						"alert","wGraspingHands",
						"canceltimer","timerGraspingHands",
						"scheduletimer",{"timerGraspingHands",6},
						"tabupdate",{"empCounts","foul","INCR|1"},
						"set",{phaseAbilityCount = "INCR|1"},
						"openwindow",{"4",nil,false,181299},
					},
					{
						"expect",{"&lfr&","==","true"},
						"expect",{"&tabread|empCounts|foul&",">","0"},
						"alert",{"GraspingHandsCD", time = 12},
					},
					{
						"expect",{"&lfr& &tabread|empCounts|phase& <phaseAbilityCount>","==","false 2 1"},
						"invoke",{						
							{
								"expect",{"&tabread|empCounts|foul&","<","1"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"GraspingHandsCD", time = 5},
							},					
							{
								"expect",{"&tabread|empCounts|foul&",">","0"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","DraggingHandsCD",
							},
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181300},
				execute = {	
					{
						"alert","wDraggingHands",
						"canceltimer","timerGraspingHands",
						"scheduletimer",{"timerGraspingHands",6},
						"tabupdate",{"empCounts","foul","INCR|1"},
						"set",{phaseAbilityCount = "INCR|1"},
						"openwindow",{"4",nil,false,181299},
					},
					{
						"expect",{"&lfr&","==","true"},
						"expect",{"&tabread|empCounts|foul&",">","0"},
						"alert",{"GraspingHandsCD", time = 12},
					},
					{
						"expect",{"&lfr& &tabread|empCounts|phase& <phaseAbilityCount>","==","false 2 1"},
						"invoke",{						
							{
								"expect",{"&tabread|empCounts|foul&","<","1"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"GraspingHandsCD", time = 5},
							},					
							{
								"expect",{"&tabread|empCounts|foul&",">","0"},
								"set",{tmpmod = 108},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","DraggingHandsCD",
							},
						},
					},
				},
			},				
			-- Pound
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {180244},
				execute = {	
					{
						"set",{poundCount = "INCR|1"},
						"set",{isPounding = 1},
						"alert","PoundInc",
						"message","mPoundInc",
						"openwindow",{"5",nil,false,180244},
					},
					{
						"expect",{"&checkperc|<poundCount>|2&","==","0"},
						"invoke",{
							{
								"expect",{"&lfr&","==","true"},
								"invoke",{						
									{
										"expect",{"&tabread|empCounts|phase&","==","3"},			
										"alert",{"PoundCD", time = 8},
									},
									{
										"expect",{"&tabread|empCounts|phase&","~=","3"},				
										"alert",{"PoundCD", time = 9},
									},	
								},
							},
							{
								"expect",{"&lfr&","==","false"},
								"invoke",{						
									{
										"expect",{"&tabread|empCounts|phase&","==","3"},
										"set",{tmpmod = 50},
										"set",{tmpmod = "MULT|<mod>"},						
										"alert",{"PoundCD", time = 6},
									},
									{
										"expect",{"&tabread|empCounts|phase&","~=","3"},
										"set",{tmpmod = 62},
										"set",{tmpmod = "MULT|<mod>"},						
										"alert",{"PoundCD", time = 6},
									},	
								},
							},
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {180244},
				execute = {
					{
						"set",{isPounding = 0},
						"closewindow",{true},
					},
					{
						"expect",{"&isranged&","==","true"},  
						"openwindow",{"4"}, 
					},					
				},
			},
			-- Swat
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181305},
				execute = {	
					{
						"message","mSwat",
						"set",{tankDebuffCount = "INCR|1"},
					},
					{
						"expect",{"&lfr&","==","true"},
						"invoke",{
							{
								"expect",{"<tankDebuffCount>","==","2"},
								"alert",{"SwatCD", time = 3},
							},
						},
					},
					{
						"expect",{"&lfr&","==","false"},
						"invoke",{
							{
								"expect",{"<tankDebuffCount>","<","4"},
								"set",{tmpmod = 38},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","SwatCD"
							},
						},
					},							
				},
			},	
			-- EnergyBuffs
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {180115, 186879, 189197}, -- Shadow Energy
				execute = {
					{
						"quashall",
						"tabupdate",{"empCounts","phase","3"},
						"tabupdate",{"empCounts","isFirst","true"},
						"tabupdate",{"empCounts","hiddenPound","1"},
						"set",{tankDebuffCount = 1},
						"set",{phaseAbilityCount = 0},
					},
					{
						"expect",{"&lfr&","==","true"},
						"tabupdate",{"empCounts","shadow","3"},
						"alert",{"FelOutpouringCD", time = 6},
						"alert",{"SwatCD", time = 2},
						"alert",{"PoundCD", time = 4},
						"alert",{"StagesCD", time = 5},
					},					
					{
						"expect",{"&flex&","==","true"},
						"tabupdate",{"empCounts","shadow","2"},
					},
					{
						"expect",{"&heroic&","==","true"},
						"tabupdate",{"empCounts","shadow","3"},
					},
					{
						"expect",{"&mythic&","==","true"},
						"tabupdate",{"empCounts","shadow","4"},
					},
					{
						"expect",{"&lfr&","==","false"},
						"invoke",{
							{
								"message","mShadowEnergy",
								"set",{tmpmod = 13},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpFelOutpouringCD",
								"set",{tmpmod = 45},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"PoundCD", time = 6},
								"set",{tmpmod = 37},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","SwatCD",
								"set",{tmpmod = 145},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","StagesCD",
							},
							{
								"expect",{"&tabread|empCounts|explosive&",">","0"},
								"set",{tmpmod = 63},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpExplosiveRunesCD",
							},
							{
								"expect",{"&tabread|empCounts|explosive&","<","1"},
								"set",{tmpmod = 63},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveRunesCD", time = 2},
							},					
							{
								"expect",{"&tabread|empCounts|foul&",">","0"},
								"set",{tmpmod = 83},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"GraspingHandsCD", time = 5},
							},	
							{
								"expect",{"&tabread|empCounts|foul&","<","1"},
								"set",{tmpmod = 83},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","DraggingHandsCD",
							},
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {180116, 186880, 189198}, -- Explosive Energy
				execute = {
					{
						"quashall",
						"tabupdate",{"empCounts","phase","1"},
						"tabupdate",{"empCounts","hiddenPound","1"},
						"tabupdate",{"empCounts","isFirst","true"},
						"set",{tankDebuffCount = 1},
						"set",{phaseAbilityCount = 0},
					},
					{
						"expect",{"&lfr&","==","true"},
						"tabupdate",{"empCounts","explosive","3"},
						"alert",{"ExplosiveRunesCD", time = 4},
						"alert",{"ExplosiveBurstCD", time = 5},
						"alert",{"PoundCD", time = 7},
						"alert",{"StagesCD", time = 4},
					},		
					{
						"expect",{"&flex&","==","true"},
						"tabupdate",{"empCounts","explosive","2"},
					},
					{
						"expect",{"&heroic&","==","true"},
						"tabupdate",{"empCounts","explosive","3"},
					},
					{
						"expect",{"&mythic&","==","true"},
						"tabupdate",{"empCounts","explosive","4"},
					},
					{
						"expect",{"&lfr&","==","false"},
						"invoke",{
							{
								"message","mExplosiveEnergy",
								"set",{tmpmod = 13},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpExplosiveRunesCD",
								"set",{tmpmod = 25},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveBurstCD", time = 4},
								"set",{tmpmod = 33},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"PoundCD", time = 6},
								"set",{tmpmod = 133},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","StagesCD",
							},		
							{
								"expect",{"&tabread|empCounts|shadow&",">","0"},
								"set",{tmpmod = 71},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpFelOutpouringCD",
							},
							{
								"expect",{"&tabread|empCounts|shadow&","<","1"},
								"set",{tmpmod = 71},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FelOutpouringCD", time = 5},
							},					
							{
								"expect",{"&tabread|empCounts|foul&",">","0"},
								"set",{tmpmod = 51},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","DraggingHandsCD",
							},
							{
								"expect",{"&tabread|empCounts|foul&","<","1"},
								"set",{tmpmod = 51},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"GraspingHandsCD", time = 5},
							},
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {180117, 186881, 189199}, -- Foul Energy
				execute = {
					{
						"quashall",
						"tabupdate",{"empCounts","phase","2"},
						"tabupdate",{"empCounts","hiddenPound","1"},
						"tabupdate",{"empCounts","isFirst","true"},
						"set",{tankDebuffCount = 1},
						"set",{phaseAbilityCount = 0},
					},	
					{
						"expect",{"&lfr&","==","true"},
						"tabupdate",{"empCounts","foul","3"},
						"alert",{"GraspingHandsCD", time = 11},
						"alert",{"FoulCrushCD", time = 5},
						"alert",{"PoundCD", time = 7},
						"alert",{"StagesCD", time = 4},
					},							
					{
						"expect",{"&flex&","==","true"},
						"tabupdate",{"empCounts","foul","2"},
					},
					{
						"expect",{"&heroic&","==","true"},
						"tabupdate",{"empCounts","foul","3"},
					},
					{
						"expect",{"&mythic&","==","true"},
						"tabupdate",{"empCounts","foul","4"},
					},
					{
						"expect",{"&lfr&","==","false"},
						"invoke",{
							{
								"message","mFoulEnergy",
								"set",{tmpmod = 13},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","DraggingHandsCD",
								"set",{tmpmod = 25},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FoulCrushCD", time = 4},
								"set",{tmpmod = 33},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"PoundCD", time = 6},
								"set",{tmpmod = 133},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","StagesCD",
							},	
							{
								"expect",{"&tabread|empCounts|shadow&",">","0"},
								"set",{tmpmod = 51},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpFelOutpouringCD",
							},
							{
								"expect",{"&tabread|empCounts|shadow&","<","1"},
								"set",{tmpmod = 51},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"FelOutpouringCD", time = 5},
							},					
							{
								"expect",{"&tabread|empCounts|explosive&",">","0"},
								"set",{tmpmod = 83},
								"set",{tmpmod = "MULT|<mod>"},
								"alert","EmpExplosiveRunesCD",
							},
							{
								"expect",{"&tabread|empCounts|explosive&","<","1"},
								"set",{tmpmod = 83},
								"set",{tmpmod = "MULT|<mod>"},
								"alert",{"ExplosiveRunesCD", time = 2},
							},
						},
					},
				},
			},	
			-- Enrage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186882}, 
				execute = {
					{
						"alert","wEnrage",
					},
					{
						"expect",{"&mythic&","==","true"},
						"set",{mod = 0.62},
					},
					{
						"expect",{"&mythic&","==","false"},
						"set",{mod = 0.84},
					},					
				},
			},	
		},
	}

	DXE:RegisterEncounter(data)
end