local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1395)
do
	local data = {
		version = 8,
		key = "Mannoroth",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-MannorothWoD.BLP:35:35",
		triggers = {
			scan = {91305, 91409, 91369}, 
			encounterid = 1795,
			ejid = 1395,
		},
		onactivate = {
			tracing = {
				"boss1","boss2","boss3",--91305, 91409, 91369,
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1","boss2","boss3"},
			defeat = 91349,
		},
		windows = {
			proxwindow = true,
		},
		arrows = {
			MannorothsGazearrow = {
				varname = SN[181597],
				unit = "&closest|MannorothsGazeunits2&",
				persist = 10,
				action = "TOWARD",
				msg = L.alert["GO TO HIM!"],
				spell = SN[181597],
				range1 = 5,
				range2 = 6,
				range3 = 8,
				desc = 181597,
				icon = ST[181597],
			},
			DoomLordarrow = {
				varname = EJSN[11198],
				unit = "#5#",
				persist = 2,
				action = "TOWARD",
				msg = L.alert["KILL IT!"],
				spell = EJSN[11198],
				range1 = 5,
				range2 = 6,
				range3 = 8,
				ability = 11198,
				icon = EJST[11198],
			},
		},
		raidicons = {
			CurseOfTheLegionmark = {
				varname = SN[181275],
				type = "FRIENDLY",
				persist = 20,
				unit = "#5#", 
				icon = 1,
				desc = 181275,
				icon2 = ST[181275],
			},	
			MannorothsGazemark = {
				varname = SN[181597],
				type = "MULTIFRIENDLY",
				persist = 60,
				unit = "#5#", 
				icon = 2,
				total = 7,
				reset = 10,				
				desc = 181597,
				icon2 = ST[181597],
			},				
		},	
		enrage = {

		},
		userdata = {
			phase = 1,
			portalsClosed = 0,
			MarkOfDoomunits = {type = "container", wipein = 3},
			WrathOfGuldanunits = {type = "container", wipein = 3},
			MannorothsGazeunits = {type = "container", wipein = 3},
			MannorothsGazeunits2 = {type = "container", wipein = 3},
			CurseOfTheLegionsay = 5,
			curseCount = 1,
		},
		timers = {
			timerMarkOfDoom = {
				{
					"message","mMarkOfDoom",
				},
			},
			timerMannorothsGaze = {
				{
					"message","mMannorothsGaze",
				},
			},
			timerWrathOfGuldan = {
				{
					"message","mWrathOfGuldan",
				},
			},			
			--[[timerCurseOfTheLegion = {
				{
					"set",{CurseOfTheLegionsay = "DECR|1"},
				},
				{
					"expect",{"<CurseOfTheLegionsay>",">","1"},
					"announce","CurseOfTheLegioncountdown",
					"scheduletimer",{"timerCurseOfTheLegion",1},
				},
			},--]]			
		},	
		announces = { 
			MarkOfDoomsay = {
				varname = format(L.alert["%s %s %s!"],SN[181099],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[181099],L.alert["on"],L.alert["Me"]),
				desc = 181099,
				icon = ST[181099],
			},
			MannorothsGazesay = {
				varname = format(L.alert["%s %s %s!"],SN[181597],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[181597],L.alert["on"],L.alert["Me"]),
				desc = 181597,
				icon = ST[181597],
			},	
			WrathOfGuldansay = {
				varname = format(L.alert["%s %s %s!"],SN[186362],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[186362],L.alert["on"],L.alert["Me"]),
				desc = 186362,
				icon = ST[186362],
				flashcolor = "TAN",
				flashscreen = true,					
			},				
			CurseOfTheLegionsay = {
				varname = format(L.alert["%s %s %s!"],SN[181275],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[181275],L.alert["on"],L.alert["Me"]),
				desc = 181275,
				icon = ST[181275],
				flashcolor = "YELLOW",
				flashscreen = true,				
			},
			--[[CurseOfTheLegioncountdown = {
				varname = format(L.alert["%s %s 2"],EJSN[11198],L.alert["in"]),
				type = "SAY",
				msg = format(L.alert["%s %s <MoltenTorrentsay>"],EJSN[11198],L.alert["in"]),
				ability = 11198,
				icon = EJST[11198],			
			},--]]			
		},			
		messages = {
			mWrathOfGuldan = {
				varname = format(L.alert["%s %s %s"],SN[186362],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|WrathOfGuldanunits&"],SN[186362],L.alert["on"]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 186362,
				icon = ST[186362],
			},
			mMarkOfDoom = {
				varname = format(L.alert["%s %s %s"],SN[181099],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|MarkOfDoomunits&"],SN[181099],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181099,
				icon = ST[181099],
			},
			mMannorothsGaze = {
				varname = format(L.alert["%s %s %s"],SN[181597],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|MannorothsGazeunits&"],SN[181597],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181597,
				icon = ST[181597],
			},			
			mMannorothsGazeCast = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181597]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[181597]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181597,
				icon = ST[181597],
			},	
			mDoomSpike = {
				varname = format(L.alert["%s %s %s (2)"],SN[181119],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (#11#)"],SN[181119],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181119,
				icon = ST[181119],
				exdps = true,
				exhealer = true,
				counter2 = true,
			},	
			mShadowBoltVolley = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[181126]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[181126]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 181126,
				icon = ST[181126],
			},
			mFelseeker30 = {
				varname = format(L.alert["%s %s 3 (30 %s)"],L.alert["Incoming"],SN[181738],L.alert["yards"]),
				type = "message",
				text = format(L.alert["%s %s 3 (30 %s)"],L.alert["Incoming"],SN[181738],L.alert["yards"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 181738,
				icon = ST[181738],
			},	
			mFelseeker20 = {
				varname = format(L.alert["%s %s 2 (20 %s)"],L.alert["Incoming"],SN[181792],L.alert["yards"]),
				type = "message",
				text = format(L.alert["%s %s 2 (20 %s)"],L.alert["Incoming"],SN[181792],L.alert["yards"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 181792,
				icon = ST[181792],
			},	
			mFelseeker10 = {
				varname = format(L.alert["%s %s 1 (10 %s)"],L.alert["Incoming"],SN[181793],L.alert["yards"]),
				type = "message",
				text = format(L.alert["%s %s 1 (10 %s)"],L.alert["Incoming"],SN[181793],L.alert["yards"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 181793,
				icon = ST[181793],
			},
			mEmpoweredFelseeker1 = {
				varname = format(L.alert["%s %s (1)"],L.alert["Incoming"],SN[182077]),
				type = "message",
				text = format(L.alert["%s %s (1)"],L.alert["Incoming"],SN[182077]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 182077,
				icon = ST[182077],
				counter2 = true,
			},
			mEmpoweredFelseeker2 = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[182076]),
				type = "message",
				text = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[182076]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 182076,
				icon = ST[182076],
				counter2 = true,
			},
			mEmpoweredFelseeker3 = {
				varname = format(L.alert["%s %s (3)"],L.alert["Incoming"],SN[182040]),
				type = "message",
				text = format(L.alert["%s %s (3)"],L.alert["Incoming"],SN[182040]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 182040,
				icon = ST[182040],
				counter2 = true,
			},	
			mGlaiveThrust = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[183377]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[183377]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 183377,
				icon = ST[183377],
				exdps = true,
				exhealer = true,
			},
			mMassiveBlast = {
				varname = format(L.alert["%s %s %s"],SN[181359],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[181359],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 181359,
				icon = ST[181359],
				exdps = true,
				exhealer = true,
			},	
			mDoomLordPortalClosed = {
				varname = format(L.alert["%s %s %s"],EJSN[11198],SN[162394],SN[103602]),
				type = "message",
				text = format(L.alert["%s %s %s"],EJSN[11198],SN[162394],SN[103602]),
				color1 = "GREEN",
				sound = "ALERT15",
				--desc = 181359,
				icon = EJST[11198],
			},	
			mImpPortalClosed = {
				varname = format(L.alert["%s %s %s"],EJSN[11230],SN[162394],SN[103602]),
				type = "message",
				text = format(L.alert["%s %s %s"],EJSN[11230],SN[162394],SN[103602]),
				color1 = "GREEN",
				sound = "ALERT15",
				--desc = 181359,
				icon = EJST[11230],
			},
			mInfernalPortalClosed = {
				varname = format(L.alert["%s %s %s"],EJSN[11208],SN[162394],SN[103602]),
				type = "message",
				text = format(L.alert["%s %s %s"],EJSN[11208],SN[162394],SN[103602]),
				color1 = "GREEN",
				sound = "ALERT15",
				--desc = 181359,
				icon = EJST[11208],
			},
			mCurseOfTheLegion = {
				varname = format(L.alert["%s %s %s (2)"],SN[181275],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (<curseCount>)"],SN[181275],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 181275,
				icon = ST[181275],
				counter2 = true,
			},				
		},
		onstart = {
			{
				"expect",{"&mythic&","==","true"},
				"batchalert",{"MannorothsFuryCD","FelseekerCD","GlaiveComboCD","FelHellstormCD"},
				"alert",{"CurseOfTheLegionCD", time = 2},
				"alert",{"ImpsCD", time = 3},
				"alert",{"InfernoCD", time = 4},
			},
		},
		alerts = {
			MannorothsGazeCD = {
				varname = format(L.alert["%s Cooldown"],SN[181597]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181597]),
				time = 47,
				time2 = 40,
				color1 = "GLOBAL",
				icon = ST[181597],
				desc = 181597,
			},
			EmpMannorothsGazeCD = {
				varname = format(L.alert["%s Cooldown"],SN[182006]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[182006]),
				time = 30,
				color1 = "GLOBAL",
				icon = ST[182006],
				desc = 182006,
			},				
			MannorothsFuryCD = {
				varname = format(L.alert["%s Cooldown"],SN[108508]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[108508]),
				time = 15.5,
				color1 = "GLOBAL",
				icon = ST[108508],
				desc = 108508,
			},
			FelseekerCD = {
				varname = format(L.alert["%s Cooldown"],SN[181735]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181735]),
				time = 57,
				time2 = 53,
				time3 = 50,
				time4 = 60,
				color1 = "GLOBAL",
				icon = ST[181735],
				desc = 181735,
			},
			EmpFelseekerCD = {
				varname = format(L.alert["%s Cooldown"],SN[182077]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[182077]),
				time = 60,
				time2 = 50,
				color1 = "GLOBAL",
				icon = ST[182077],
				desc = 182077,
			},			
			GlaiveComboCD = {
				varname = format(L.alert["%s Cooldown"],SN[181354]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181354]),
				time = 43,
				time2 = 36,
				time3 = 30.5,
				time4 = 45,
				color1 = "GLOBAL",
				icon = ST[181354],
				desc = 181354,
				exhealer = true,
				exdps = true,
			},
			EmpGlaiveComboCD = {
				varname = format(L.alert["%s Cooldown"],SN[187347]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[187347]),
				time = 23,
				time2 = 30.5,
				color1 = "GLOBAL",
				icon = ST[187347],
				desc = 187347,
				exhealer = true,
				exdps = true,
			},			
			FelHellstormCD = {
				varname = format(L.alert["%s Cooldown"],SN[181557]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181557]),
				time = 30,
				time2 = 36,
				time3 = 33,
				time4 = 24,
				color1 = "GLOBAL",
				icon = ST[181557],
				desc = 181557,
			},
			EmpFelHellstormCD = {
				varname = format(L.alert["%s Cooldown"],SN[181948]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181948]),
				time = 14,
				color1 = "GLOBAL",
				icon = ST[181948],
				desc = 181948,
			},			
			CurseOfTheLegionCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],SN[181275]),
				type = "dropdown",
				text = "(<curseCount>) "..format(L.alert["%s Cooldown"],SN[181275]),
				time = 65,
				time2 = 24,
				time3 = 45,
				color1 = "GLOBAL",
				icon = ST[181275],
				desc = 181275,
				counter = true,
			},
			MarkofDoomCD = {
				varname = format(L.alert["Next %s"],SN[181099]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[181099]),
				time = 12,
				color1 = "GLOBAL",
				icon = ST[181099],
				desc = 181099,
			},	
			ShadowforceCD = {
				varname = format(L.alert["Next %s"],SN[181799]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[181799]),
				time = 24,
				time2 = 52,
				time3 = 30,
				color1 = "GLOBAL",
				icon = ST[181799],
				desc = 181799,
			},
			EmpShadowforceCD = {
				varname = format(L.alert["Next %s"],SN[182084]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[182084]),
				time = 45,
				color1 = "GLOBAL",
				icon = ST[182084],
				desc = 182084,
			},			
			ImpsCD = {
				varname = format(L.alert["Next %s"],SN[181255]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[181255]),
				time = 30,
				time2 = 25,
				time3 = 46.5,
				time4 = 49,
				time5 = 19,
				color1 = "GLOBAL",
				icon = ST[181255],
				desc = 181255,
			},	
			InfernoCD = {
				varname = format(L.alert["Next %s"],SN[181180]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[181180]),
				time = 35,
				time2 = 48,
				time3 = 28,
				time4 = 70,
				time5 = 55,
				color1 = "GLOBAL",
				icon = ST[181180],
				desc = 181180,
			},			
			-- Warning
			wShadowforce = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[181799]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[181799]),
				time = 2,
				color1 = "RED",
				icon = ST[181799],
				sound = "ALERT11",
				desc = 181799,
				flashscreen = true,
			},	
			wDoomLord = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN["ej11198"]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN["ej11198"]),
				time = 2,
				color1 = "RED",
				icon = EJST[111198],
				sound = "ALERT10",
				ability = 11198,
			},	
			Phase2 = {
				varname = format(L.alert["Phase %s"],"2"),
				type = "simple",
				text = format(L.alert["Phase %s"],"2"),
				time = 2,
				color1 = "YELLOW",
				icon = ST[181597],
				sound = "ALERT13",
			},
			Phase3 = {
				varname = format(L.alert["Phase %s"],"3"),
				type = "simple",
				text = format(L.alert["Phase %s"],"3"),
				time = 2,
				color1 = "GREEN",
				icon = ST[182077],
				sound = "ALERT13",
			},
			Phase4 = {
				varname = format(L.alert["Phase %s"],"4"),
				type = "simple",
				text = format(L.alert["Phase %s"],"4"),
				time = 2,
				color1 = "RED",
				icon = ST[181255],
				sound = "ALERT13",
			},			
			-- Inform
			iMannorothsGaze = {
				varname = format(L.alert["%s %s %s!"],SN[181597],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[181597],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "GREEN",
				icon = ST[181597],
				sound = "ALERT9",
				desc = 181597,
			},			
			iMarkOfDoom = {
				varname = format(L.alert["%s %s %s!"],SN[181099],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[181099],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[181099],
				sound = "ALERT11",
				desc = 181099,
			},
			iFelHellstormDamage = {
				varname = format(L.alert["%s %s %s, %s!"],SN[181566],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[181566],L.alert["on"],L.alert["YOU"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[181566],
				sound = "ALERT12",
				desc = 181566,
				flashscreen = true,
				throttle = 2,
			},	
			-- Casts
			ShadowforceAct = {
				varname = format(L.alert["%s Active"],SN[181799]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[181799]),
				time = 8,
				color1 = "RED",
				icon = ST[181799],
				desc = 181799,
			},
			NextWrath = {
				varname = format(L.alert["Next %s"],SN[186362]),
				type = "centerpopup",
				text = format(L.alert["Next %s"],SN[186362]),
				time = 5,
				color1 = "RED",
				icon = ST[186362],
				desc = 186362,
			},				
			-- Debuff
			MarkOfDoomDebuff = {
				varname = format(L.alert["%s Debuff"],SN[181099]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[181099]),
				text2 = format(L.alert["#5#: %s"],SN[181099]),
				time = 15,
				color1 = "RED",
				desc = 181099,
				icon = ST[181099],
				tag = "#5#",
				exdps = true,				
			},				
			CurseOfTheLegionDebuff = {
				varname = format(L.alert["%s Debuff"],SN[181275]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[181275]),
				text2 = format(L.alert["#5#: %s"],SN[181275]),
				time = 20,
				color1 = "YELLOW",
				desc = 181275,
				icon = ST[181275],
				tag = "#5#",
				exdps = true,				
			},				
		}, 
		events = {
			-- Imps
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellid = {181255},
				execute = {
					{ 
						"expect",{"<phase>",">","1"},
						"invoke",{
							{
								"expect",{"&mythic&","==","true"},
								"alert",{"ImpsCD", time = 4},
							},
							{
								"expect",{"&mythic&","==","false"},
								"alert","ImpsCD",
							},
						},
					},
				},
			},	
			-- Inferno
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellid = {181180},
				execute = {
					{ 
						"expect",{"<phase>",">","1"},
						"invoke",{
							{
								"expect",{"&mythic&","==","true"},
								"alert",{"InfernoCD", time = 5},
							},
							{
								"expect",{"&mythic&","==","false"},
								"alert","InfernoCD",
							},
						},
					},
				},
			},
			-- WrathOfGuldan
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {186362},
				execute = {
					{
						"insert",{"WrathOfGuldanunits","#5#"},
						"canceltimer","timerWrathOfGuldan",
						"scheduletimer",{"timerWrathOfGuldan",1},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","WrathOfGuldansay",
					},
				},
			},			
			-- MarkOfDoom
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {181099},
				execute = {
					{ -- arrow here?
						"insert",{"MarkOfDoomunits","#5#"},
						"canceltimer","timerMarkOfDoom",
						"scheduletimer",{"timerMarkOfDoom",1},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","MarkOfDoomDebuff",
						"announce","MarkOfDoomsay",
						"alert","iMarkOfDoom",
						"openwindow",{"20",nil,false,181099},
					},	
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"MarkOfDoomDebuff", text = 2},
					},							
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {181099},
				dstisplayerunit = true,
				execute = {
					{ 
						"quash","MarkOfDoomDebuff",
						"closewindow",{true},
					},
				},
			},	
			-- MannorothsGaze 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181597, 182006},
				execute = {	
					{
						"message","mMannorothsGazeCast",
						"alert","MannorothsGazeCD",
					},		
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {181597, 182006},
				execute = {
					{
						-- debuff tracking?
						"insert",{"MannorothsGazeunits","#5#"},
						"insert",{"MannorothsGazeunits2","#5#",true},
						"canceltimer","timerMannorothsGaze",
						"scheduletimer",{"timerMannorothsGaze",0.4},
						"raidicon","MannorothsGazemark",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","MannorothsGazesay",
						"alert","iMannorothsGaze",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"arrow","MannorothsGazearrow",
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {181597, 182006},
				execute = {
					{
						"removeraidicon","#5#",
					},					
				},
			},			
			-- Shadowforce 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181799, 182084},
				execute = {	
					{
						"batchalert",{"ShadowforceAct","wShadowforce"},
						"alert",{"ShadowforceCD", time = 2},
					},		
				},
			},
			-- CurseOfTheLegion
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {181275},
				execute = {
					{
						"raidicon","CurseOfTheLegionmark",
						"message","mCurseOfTheLegion",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","CurseOfTheLegionsay",
						"alert","CurseOfTheLegionDebuff",
					--	"set",{CurseOfTheLegionsay = 6},
				--		"canceltimer","timerCurseOfTheLegion",
				--		"scheduletimer",{"timerCurseOfTheLegion",1},
					},	
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"CurseOfTheLegionDebuff", text = 2},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {181275},
				execute = {
					{ 
						"quash","CurseOfTheLegionDebuff",
						"removeraidicon","#5#",
						"alert","wDoomLord",
						"arrow","DoomLordarrow",
						"alert","MarkofDoomCD",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181275},
				execute = {
					{
						"set",{curseCount = "INCR|1"},
						"alert","CurseOfTheLegionCD",
					},
				},
			},			
			-- DoomSpike
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {181119},
				execute = {
					{
						"expect",{"&checkperc|#11#|3&","==","0"},
						"message","mDoomSpike",
					},	
				},
			},	
			-- ShadowBoltVolley 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181126},
				execute = {	
					{
						"message","mShadowBoltVolley",
					},		
				},
			},
			-- Felseeker 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181793},
				execute = {	
					{
						"message","mFelseeker10",
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181792},
				execute = {	
					{
						"message","mFelseeker20",
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181738},
				execute = {	
					{
						"message","mFelseeker30",
					},		
				},
			},
			-- EmpoweredFelseeker 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182077},
				execute = {	
					{
						"message","mEmpoweredFelseeker1",
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182076},
				execute = {	
					{
						"message","mEmpoweredFelseeker2",
					},		
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182040},
				execute = {	
					{
						"message","mEmpoweredFelseeker3",
					},		
				},
			},
			-- GlaiveThrust 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {183377, 185831},
				execute = {	
					{
						"message","mGlaiveThrust",
					},		
				},
			},
			-- MassiveBlast
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {181359, 185821},
				execute = {
					{
						"message","mMassiveBlast",
					},		
				},
			},	
			-- FelHellstormDamage
			{
				type = "combatevent",
				eventtype = "SPELL_DAMAGE",
				spellid = {181566},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelHellstormDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_MISSED",
				spellid = {181566},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelHellstormDamage",
					},
				},
			},	
			-- P1PortalClosed
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {185147}, -- Doom Lords
				execute = {
					{ 
						"set",{portalsClosed = "INCR|1"},
						"message","mDoomLordPortalClosed",
					},
					{
						"expect",{"<portalsClosed>","==","3"},
						"schedulealert",{"Phase2",1},
						"set",{phase = 2},
						"tracing",{"boss1"},
						"invoke",{
							{
								"expect",{"&mythic&","==","false"},
								"alert",{"FelHellstormCD", time = 3},
								"alert",{"MannorothsGazeCD", time = 2},
								"alert",{"GlaiveComboCD", time = 4},
								"alert",{"FelseekerCD", time = 4},
							},
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {185175}, -- Imps
				execute = {
					{ 
						"set",{portalsClosed = "INCR|1"},
						"message","mImpPortalClosed",
					},
					{
						"expect",{"<portalsClosed>","==","3"},
						"schedulealert",{"Phase2",1},
						"set",{phase = 2},
						"tracing",{"boss1"},
						"invoke",{
							{
								"expect",{"&mythic&","==","false"},
								"alert",{"FelHellstormCD", time = 3},
								"alert",{"MannorothsGazeCD", time = 2},
								"alert",{"GlaiveComboCD", time = 4},
								"alert",{"FelseekerCD", time = 4},
							},
						},
					},					
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {182212}, -- Infernals
				execute = {
					{ 
						"set",{portalsClosed = "INCR|1"},
						"message","mInfernalPortalClosed",
					},
					{
						"expect",{"<portalsClosed>","==","3"},
						"schedulealert",{"Phase2",1},
						"set",{phase = 2},
						"tracing",{"boss1"},
						"invoke",{
							{
								"expect",{"&mythic&","==","false"},
								"alert",{"FelHellstormCD", time = 3},
								"alert",{"MannorothsGazeCD", time = 2},
								"alert",{"GlaiveComboCD", time = 4},
								"alert",{"FelseekerCD", time = 4},
							},
						},
					},					
				},
			},	
			-- FelHellstorm 
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {181557},
				execute = {	
					{
						"alert",{"FelHellstormCD", time = 2},
					},		
				},
			},
			------------------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED", 
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","182263"}, -- Phase 3
								"invoke",{
									{
										"batchalert",{"Phase3","ShadowforceCD"},
										"alert",{"FelseekerCD", time = 2},
										"alert",{"GlaiveComboCD", time = 2},
										--"batchquash",{"ImpsCD","InfernoCD"},
										"set",{phase = 3},
										"alert",{"FelHellstormCD", time = 4},
										"alert",{"ShadowforceCD", time = 3},
										"alert",{"GlaiveComboCD", time = 2},
										"alert",{"MannorothsGazeCD", time = 2},
										"alert",{"FelseekerCD", time = 4},
									},
									{
										"expect",{"&mythic&","==","true"},
										"alert","NextWrath",
									},
								},
							},
							{
								"expect",{"#5#","==","185690"}, -- Phase 4
								"invoke",{
									{								
										"alert","Phase4",
										"batchquash",{"FelHellstormCD","ShadowforceCD","GlaiveComboCD","MannorothsGazeCD","FelseekerCD"},
										"set",{phase = 4},
										"batchalert",{"EmpFelHellstormCD","EmpGlaiveComboCD","EmpMannorothsGazeCD","EmpShadowforceCD","EmpFelseekerCD"},
									},
									{
										"expect",{"&mythic&","==","true"},
										"alert","NextWrath",
										"alert",{"ImpsCD", time = 5},
									},
								},
							},
							{
								"expect",{"#5#","==","181735"}, -- Felseeker
								"invoke",{
									{
										"expect",{"<phase>","~=","4"},
										"alert",{"FelseekerCD", time = 3},
									},
									{
										"expect",{"<phase>","==","4"},
										"alert",{"EmpFelseekerCD", time = 2},
									},									
								},
							},
							{
								"expect",{"#5#","==","181735"}, -- GlaiveCombo
								"invoke",{
									{
										"expect",{"<phase>","~=","4"},
										"alert",{"GlaiveComboCD", time = 3},
									},
									{
										"expect",{"<phase>","==","4"},
										"alert",{"EmpGlaiveComboCD", time = 2},
									},									
								},								
							},	
							{
								"expect",{"#5#","==","181301"}, -- Summon Adds Phase 2
								"invoke",{
									{								
										"alert",{"ImpsCD", time = 2},
									},
									{
										"expect",{"&mythic&","==","true"},
										"alert",{"CurseOfTheLegionCD", time = 4},
										"set",{curseCount = "INCR|1"},
									},
									{
										"expect",{"&mythic&","==","false"},
										"alert",{"InfernoCD", time = 2},
									},										
								},
							},
							{
								"expect",{"#5#","==","182262"}, -- Summon Adds Phase 3
								"quash","ImpsCD",
								"alert",{"InfernoCD", time = 3},
							},									
						},
					},					
				},
			},				
			
		},
	}

	DXE:RegisterEncounter(data)
end