local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1427)
do
	local data = {
		version = 11,
		key = "Socrethar",
		zone = L.zone["Hellfire Citadel"],
		category = L.zone["Hellfire Citadel"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-SoulboundConstruct.BLP:35:35",
		respawntime = 30,
		triggers = {
			scan = {90296, 92330}, 
			encounterid = 1794,
			ejid = 1427,
		},
		onactivate = {
			tracing = {
				90296, 92330,
				--markers1 = {35},
			},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 92330,
		},
		windows = {
			proxwindow = true,
		},
		raidicons = {
			FelblazeChargemark = {
				varname = SN[182051],
				type = "FRIENDLY",
				persist = 4,
				unit = "&upvalue&", 
				icon = 8,
				desc = 182051,
				icon2 = ST[182051],
			},
		},
		arrows = {
			VolatileFelOrbarrow = {
				varname = SN[189627],
				unit = "#5#",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[189627],
				range1 = 5,
				range2 = 8,
				range3 = 12,
				desc = 189627,
				icon = ST[189627],
			},
			FelblazeChargearrow = {
				varname = SN[182051],
				unit = "&upvalue&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[182051],
				range1 = 5,
				range2 = 8,
				range3 = 12,
				desc = 182051,
				icon = ST[182051],
			},
			GiftOfTheManariarrow = {
				varname = SN[184124],
				unit = "&closest|GiftOfTheManariunits2&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[184124],
				range1 = 5,
				range2 = 8,
				range3 = 12,
				desc = 184124,
				icon = ST[184124],
			},
			FelPrisonarrow = {
				varname = format(L.alert["Closest %s"],SN[181288]),
				unit = "#5#", -- make this a closest?
				persist = 60,
				action = "TOWARD",
				msg = L.alert["Free him!"],
				spell = format(L.alert["Closest %s"],SN[181288]),
				range1 = 3,
				range2 = 20,
				range3 = 30,
				desc = 181288,
				icon = ST[181288],
				extank = true,
				exhealer = true,
			},			
		},
		enrage = {
			timelfr = 641,
			timeflex = 641,
			timeheroic = 641,
			timemythic = 641,
		},
		userdata = {
			apocalypseCount = 0,
			addCount = 1,
			hostile = 1,
			dominatorCount = 0,
			dominanceCount = 0,
			prisonCount = 0,
			inBarrier = 0,
			Giftarrow = "-",
			GiftOfTheManariunits = {type = "container", wipein = 3},
			GiftOfTheManariunits2 = {type = "container"},
			ShatteredDefenseunits = {type = "container", wipein = 3},
			ghostGuid = {type = "container"},
		},
		timers = {
			timerGiftOfTheManari = {
				{
					"message","mGiftOfTheManari",
				},
			},
			timerGiftOfTheManariArrow = {
				{
					"arrow","GiftOfTheManariarrow",
				},
				{
					"expect",{"&count|GiftOfTheManariunits&","~=","0"},
					"scheduletimer",{"timerGiftOfTheManariArrow",1},	
				},
			},			
			timerShatteredDefense = {
				{
					"message","mShatteredDefense",
				},
			},			
		},	
		announces = { 
			VolatileFelOrbsay = {
				varname = format(L.alert["%s %s %s!"],SN[180221],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[180221],L.alert["on"],L.alert["Me"]),
				desc = 180221,
				icon = ST[180221],
				--flashcolor = "RED",
				--flashscreen = true,
			},
			FelblazeChargesay = {
				varname = format(L.alert["%s %s %s!"],SN[182051],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[182051],L.alert["on"],L.alert["Me"]),
				desc = 182051,
				icon = ST[182051],
			},	
			GiftOfTheManarisay = {
				varname = format(L.alert["%s %s %s!"],SN[184124],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[184124],L.alert["on"],L.alert["Me"]),
				desc = 184124,
				icon = ST[184124],
			},	
			GhastlyFixationsay = {
				varname = format(L.alert["%s %s %s!"],SN[182769],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[182769],L.alert["on"],L.alert["Me"]),
				desc = 182769,
				icon = ST[182769],
				enabled = false,
			},	
			EternalHungersay = {
				varname = format(L.alert["%s %s %s!"],SN[188666],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[188666],L.alert["on"],L.alert["Me"]),
				desc = 188666,
				icon = ST[188666],
			},				
		},			
		messages = {
			mShatteredDefense = {
				varname = format(L.alert["%s %s %s"],SN[182038],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|ShatteredDefenseunits&"],SN[182038],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 182038,
				icon = ST[182038],
			},			
			mGiftOfTheManari = {
				varname = format(L.alert["%s %s %s"],SN[184124],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|GiftOfTheManariunits&"],SN[184124],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 184124,
				icon = ST[184124],
			},			
			mVolatileFelOrb = {
				varname = format(L.alert["%s %s %s"],SN[180221],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[180221],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 180221,
				icon = ST[180221],
			},
			mFelblazeCharge = {
				varname = format(L.alert["%s %s %s"],SN[182051],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[182051],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 182051,
				icon = ST[182051],
			},				
			mUnstoppableTenacity = {
				varname = format(L.alert["%s!"],SN[188692]),
				type = "message",
				text = format(L.alert["%s!"],SN[188692]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 188692,
				icon = ST[188692],
			},
			mExertDominance = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[183331]),
				type = "message",
				text = format(L.alert["%s %s (<dominanceCount>)"],L.alert["Incoming"],SN[183331]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 183331,
				icon = ST[183331],
				counter2 = true,
			},	
			mDominator = {
				varname = format(L.alert["%s (2)"],EJSN[11688]),
				type = "message",
				text = format(L.alert["%s (<dominatorCount>)"],EJSN[11688]),
				color1 = "ORANGE",
				sound = "ALERT13",
				--ability = 11688,
				icon = "Interface\\Icons\\achievement_boss_kiljaedan",
				counter2 = true,
			},
			mEternalHunger = {
				varname = format(L.alert["%s %s %s"],SN[188666],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[188666],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 188666,
				icon = ST[188666],
			},			
			mReverberatingBlow = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[180008]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[180008]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 180008,
				icon = ST[180008],
			},	
			mSocretharsContingency = {
				varname = format(L.alert["%s (2)"],EJSN[11778]),
				type = "message",
				text = format(L.alert["%s <addCount>"],EJSN[11778]),
				color1 = "YELLOW",
				sound = "ALERT13",
				ability = 11778,
				icon = ST[11778],
				counter2 = true,
			},
			mShadowBoltVolley = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[182392]),
				type = "message",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[182392]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 182392,
				icon = ST[182392],
			},
			mPortals = {
				varname = format(L.alert["%s!"],SN[109400]),
				type = "message",
				text = format(L.alert["%s!"],SN[109400]),
				color1 = "YELLOW",
				sound = "ALERT13",
				--desc = 182392,
				icon = ST[109400],
			},
		},
		onstart = {
			{
				"batchalert",{"FelPrisonCD","ReverberatingBlowCD","VolatileFelOrbCD","FelblazeChargeCD"},
			},
			{
				"expect",{"&mythic&","==","true"},
				"alert","VoraciousSoulstalkerCD",
			},
		},
		alerts = {
			FelPrisonCD = {
				varname = format(L.alert["%s Cooldown"],SN[181288]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[181288]),
				time = 48,
				time2 = 46,
				time3 = 60,
				color1 = "GLOBAL",
				icon = ST[181288],
				desc = 181288,
			},
			ReverberatingBlowCD = {
				varname = format(L.alert["%s Cooldown"],SN[180008]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[180008]),
				time = 7,
				time2 = 17,
				color1 = "GLOBAL",
				icon = ST[180008],
				desc = 180008,
			},
			VolatileFelOrbCD = {
				varname = format(L.alert["%s Cooldown"],SN[180221]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[180221]),
				time = 13,
				time2 = 30,
				time3 = 8,
				color1 = "GLOBAL",
				icon = ST[180221],
				desc = 180221,
			},
			FelblazeChargeCD = {
				varname = format(L.alert["%s Cooldown"],SN[182051]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[182051]),
				time = 29,
				time2 = 30,
				time3 = 26,
				color1 = "GLOBAL",
				icon = ST[182051],
				desc = 182051,
			},
			VoraciousSoulstalkerCD = {
				varname = "(2) "..format(L.alert["%s Cooldown"],EJSN[11778]),
				type = "dropdown",
				text = "(<addCount>) "..format(L.alert["%s Cooldown"],EJSN[11778]),
				time = 20,
				time2 = 60,
				time3 = 16,
				color1 = "GLOBAL",
				icon = "Interface\\Icons\\spell_shadow_summonfelhunter",
				counter = true,
				--ability = 11778,
			},
			SargereiDominatorCD = {
				varname = format(L.alert["%s Cooldown"],EJSN[11456]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],EJSN[11456]),
				time = 170,
				time2 = 24,
				time3 = 130,
				time4 = 70,
				time5 = 60,
				color1 = "GLOBAL",
				icon = "Interface\\Icons\\achievement_boss_kiljaedan",
				--ability = 11456,
			},
			GhostCD = {
				varname = format(L.alert["%s Cooldown"],EJSN[11462]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],EJSN[11462]),
				time = 70,
				time2 = 30,
				color1 = "GLOBAL",
				icon = "Interface\\Icons\\achievement_halloween_ghost_01",
				--ability = 11462,
			},
			PortalsCD = {
				varname = format(L.alert["%s Cooldown"],SN[109400]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[109400]),
				time = 140,
				color1 = "GLOBAL",
				icon = ST[109400],
				--ability = 11462,
			},				
			--[[GiftOfTheManariCD = {
				varname = format(L.alert["%s Cooldown"],SN[184124]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[184124]),
				time = 5,
				color1 = "GLOBAL",
				icon = ST[184124],
				desc = 184124,
			},--]]
			ApocalypseCD = {
				varname = format(L.alert["%s Cooldown"],SN[183329]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[183329]),
				time = 52,
				color1 = "GLOBAL",
				icon = ST[183329],
				desc = 183329,
			},				
			-- Warning
			Phase1 = {
				varname = format(L.alert["Phase %s"],"1"),
				type = "simple",
				text = format(L.alert["Phase %s"],"1"),
				time = 2,
				color1 = "YELLOW",
				icon = ST[189627],
				sound = "ALERT13",
			},	
			Phase2 = {
				varname = format(L.alert["Phase %s"],"2"),
				type = "simple",
				text = format(L.alert["Phase %s"],"2"),
				time = 2,
				color1 = "ORANGE",
				icon = ST[183329],
				sound = "ALERT13",
			},			
			wApocalypse = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[183329]),
				type = "simple",
				text = format(L.alert["%s %s (<apocalypseCount>)"],L.alert["Incoming"],SN[183329]),
				time = 2,
				color1 = "RED",
				icon = ST[183329],
				sound = "ALERT11",
				desc = 183329,
				counter = true,
				--flashscreen = true,
			},
			wFelPrison = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[181288]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[181288]),
				time = 2,
				color1 = "RED",
				icon = ST[181288],
				sound = "ALERT11",
				desc = 181288,
			},			
			-- Inform
			iFelblazeResidueDamage = {
				varname = format(L.alert["%s %s, %s!"],SN[182218],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[182218],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[182218],
				sound = "ALERT12",
				desc = 182218,
				flashscreen = true,
				throttle = 1.5,
			},	
			iGiftOfTheManari = {
				varname = format(L.alert["%s %s %s!"],SN[184124],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[184124],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[184124],
				sound = "ALERT12",
				desc = 184124,
				flashscreen = true,
			},
			iGhastlyFixation = {
				varname = format(L.alert["%s %s %s!"],SN[182769],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[182769],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "PURPLE",
				icon = ST[182769],
				sound = "ALERT9",
				desc = 182769,
				--flashscreen = true,
			},	
			iVolatileFelOrb = {
				varname = format(L.alert["%s %s %s!"],SN[180221],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[180221],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[180221],
				sound = "ALERT12",
				desc = 180221,
			},
			iShadowBoltVolley = {
				varname = format(L.alert["%s: %s %s!"],SN[182392],L.alert["INTERRUPT"],L.alert["Boss"]),
				type = "inform",
				text = format(L.alert["%s: %s #2#!"],SN[182392],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[182392],
				exhealer = true,
				throttle = 2,
			},	
			iEternalHunger = {
				varname = format(L.alert["%s %s %s, %s!"],SN[188666],L.alert["on"],L.alert["YOU"],L.alert["RUN AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s %s, %s!"],SN[188666],L.alert["on"],L.alert["YOU"],L.alert["RUN AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[188666],
				sound = "ALERT12",
				desc = 188666,
			},	
			iShadowWordAgony = {
				varname = format(L.alert["%s: %s %s!"],SN[184239],L.alert["INTERRUPT"],L.alert["Boss"]),
				type = "inform",
				text = format(L.alert["%s: %s #2#!"],SN[184239],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "PURPLE",
				icon = ST[184239],
				sound = "ALERT11",
				desc = 184239,
				flashscreen = true,
				exhealer = true,
			},	
			iExertDominance = {
				varname = format(L.alert["%s: %s %s!"],SN[183331],L.alert["INTERRUPT"],L.alert["Boss"]),
				type = "inform",
				text = format(L.alert["%s: %s #2#!"],SN[183331],L.alert["INTERRUPT"]),
				time = 2,
				color1 = "CYAN",
				icon = ST[183331],
				sound = "ALERT11",
				desc = 183331,
				flashscreen = true,
				exhealer = true,
			},				
			-- Casts
			Construct = {
				varname = format(L.alert["%s"],SN[180258]),
				type = "centerpopup",
				text = format(L.alert["%s"],SN[180258]),
				time = 7,
				color1 = "GREEN",
				icon = "Interface\\Icons\\achievement_boss_kiljaedan",
				--desc = 180258,
			},	
			GiftOfTheManariNext = {
				varname = format(L.alert["Next %s"],SN[184124]),
				type = "centerpopup",
				text = format(L.alert["Next %s"],SN[184124]),
				time = 20,
				color1 = "BROWN",
				icon = ST[184124],
				desc = 184124,
			},			
			UnstoppableTenacityAct = {
				varname = format(L.alert["%s Active"],SN[188692]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[188692]),
				time = 20,
				color1 = "ORANGE",
				icon = ST[188692],
				desc = 188692,
			},
			ApocalypseAct = {
				varname = format(L.alert["%s Active"],SN[183329]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[183329]),
				time = 12,
				color1 = "RED",
				icon = ST[183329],
				desc = 183329,
			},	
			-- Debuff
			ShatteredDefenseDebuff = {
				varname = format(L.alert["%s Debuff"],SN[182038]),
				type = "debuff",
				text = format(L.alert["(1) %s: %s"],L.alert["YOU"],SN[182038]),
				text2 = format(L.alert["(1) #5#: %s"],SN[182038]),
				text3 = format(L.alert["(#11#) %s: %s"],L.alert["YOU"],SN[182038]),
				text4 = format(L.alert["(#11#) #5#: %s"],SN[182038]),
				time = 45,
				color1 = "ORANGE",
				desc = 182038,
				icon = ST[182038],
				tag = "#5#",
				exdps = true,				
			},	
			GiftOfTheManariDebuff = {
				varname = format(L.alert["%s Debuff"],SN[184124]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[184124]),
				text2 = format(L.alert["#5#: %s"],SN[184124]),
				time = 120,
				color1 = "GREEN",
				desc = 184124,
				icon = ST[184124],
				tag = "#5#",
				exdps = true,
				extank = true,
			},				
		},
		events = {
			-- Shadow Word: Agony
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {184239},
				execute = {	
					{
						"expect",{"&interrupt|#1#&","==","true"},
						"alert","iShadowWordAgony",
					},			
				},
			},		
			-- UnstoppableTenacity
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {188692},
				execute = {
					{
						"message","mUnstoppableTenacity",
						"alert","UnstoppableTenacityAct",
					},			
				},
			},	
			-- ShatteredDefense
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182038},
				execute = {
					{
						"expect",{"<hostile>","==","1"}, 
						"invoke",{
							{
								"insert",{"ShatteredDefenseunits","#5#"},
								"canceltimer","timerShatteredDefense",
								"scheduletimer",{"timerShatteredDefense",0.3},
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","ShatteredDefenseDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"ShatteredDefenseDebuff", text = 2},
							},
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {182038},
				execute = {
					{
						"expect",{"<hostile>","==","1"},
						"invoke",{
							{
								"insert",{"ShatteredDefenseunits","#5#"},
								"canceltimer","timerShatteredDefense",
								"scheduletimer",{"timerShatteredDefense",0.3},
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"ShatteredDefenseDebuff", text = 3},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"ShatteredDefenseDebuff", text = 4},
							},									
						},
					},			
				},
			},
			-- SocretharsContingency
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {190776},
				execute = {	
					{
						"message","mSocretharsContingency",
						"set",{addCount = "INCR|1"},
						"alert",{"VoraciousSoulstalkerCD", time = 2},
					},			
				},
			},
			-- ExertDominance
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {183331},
				execute = {	
					{
						"set",{dominanceCount = "INCR|1"}, 
						"message","mExertDominance",
					},
					{
						"expect",{"&interrupt|#1#&","==","true"},
						"alert","iExertDominance",
					},							
				},
			},
			-- Apocalypse
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {183329},
				execute = {	
					{
						"set",{apocalypseCount = "INCR|1"},
						"batchalert",{"ApocalypseAct","wApocalypse"},
					},			
				},
			},
			-- VolatileFelOrb
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {189627},
				execute = {	
					{
						"alert",{"VolatileFelOrbCD", time = 2},
						"message","mVolatileFelOrb",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","VolatileFelOrbsay",
						"alert","iVolatileFelOrb",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"arrow","VolatileFelOrbarrow",
					},					
				},
			},
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {189627},
				execute = {	
					{
						"target",{
							source = "#1#",
							wait = 0.2,
							schedule = 10,
							arrow = "VolatileFelOrbarrow",
							announce = "VolatileFelOrbsay",							
							message = "mVolatileFelOrb",
						},
					},		
				},
			},--]]
			-- FelblazeCharge
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182051},
				execute = {	
					{
						"target",{
							source = "#1#",
							wait = 0.2,
							schedule = 10,
							arrow = "FelblazeChargearrow",
							raidicon = "FelblazeChargemark",
							announce = "FelblazeChargesay",							
							message = "mFelblazeCharge",
						},
						"alert",{"FelblazeChargeCD", time = 2},
					},		
				},
			},	
			-- FelBarrier
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {184053},
				execute = {
					{
						"set",{dominatorCount = "INCR|1"},
						"set",{inBarrier = 1},
						"message","mDominator",
						"alert","GiftOfTheManariNext",
					},
					{
						"expect",{"&mythic&","==","true"},
						"alert",{"SargereiDominatorCD", time = 3},
					},
					{
						"expect",{"&mythic&","==","false"},
						"invoke",{
							{
								"expect",{"&checkperc|<dominatorCount>|2&","==","0"},
								"alert",{"SargereiDominatorCD", time = 4},
							},
							{
								"expect",{"&checkperc|<dominatorCount>|2&","~=","0"},
								"alert",{"SargereiDominatorCD", time = 5},
							},							
						},
					},					
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {184053},
				execute = {
					{
						"quash","GiftOfTheManariNext",
						"set",{inBarrier = 0},
					},			
				},
			},				
			-- GiftOfTheManari
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {184124},
				execute = {
					{
						"insert",{"GiftOfTheManariunits","#5#"},
						"insert",{"GiftOfTheManariunits2","#5#",true},
						"canceltimer","timerGiftOfTheManari",
						"scheduletimer",{"timerGiftOfTheManari",0.3},
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","GiftOfTheManarisay",
						"alert","iGiftOfTheManari",
						"alert","GiftOfTheManariDebuff",
						"openwindow",{"10",nil,false,184124},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"GiftOfTheManariDebuff", text = 2},
						"canceltimer","timerGiftOfTheManariArrow",
						"scheduletimer",{"timerGiftOfTheManariArrow",0.3},						
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {184124},
				execute = {
					{
						"delete",{"GiftOfTheManariunits2","#5#"},
						"quash","GiftOfTheManariDebuff",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"closewindow",{true},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"canceltimer","timerGiftOfTheManariArrow",				
					},								
				},
			},	
			-- ShadowBoltVolley
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {182392},
				execute = {
					{
						"message","mShadowBoltVolley",
					},
					{
						"expect",{"&interrupt|#1#&","==","true"},
						"alert","iShadowBoltVolley",
					},
				},
			},			
			-- GhastlyFixation
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182769},
				execute = {
					{
						"expect",{"&tabread|ghostGuid|#4#&","~=","true"},
						"tabinsert",{"ghostGuid","#4#","true"},
						"alert","GhostCD",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iGhastlyFixation",
						"announce","GhastlyFixationsay",
					},
				},
			},	
			-- FelPrison
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {181288},
				execute = {	
					{
						"alert","wFelPrison",
						"alert",{"FelPrisonCD", time = 2},
					},		
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {183017},
				dstisplayertype = true,
				execute = {
					{
						"arrow","FelPrisonarrow",
						--"set",{prisonCount = "INCR|1"},
						--"alert",{"FelPrisonCD", time = 3},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {183017},
				dstisplayertype = true,
				execute = {
					{
						"removearrow","#5#",
					},
				},
			},					
			-- ReverberatingBlow
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {180008},
				execute = {	
					{
						"alert",{"ReverberatingBlowCD", time = 2},
						"message","mReverberatingBlow",
					},		
				},
			},	
			-- EternalHunger
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {188666},
				execute = {
					{
						"message","mEternalHunger",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iEternalHunger",
						"announce","EternalHungersay",
					},		
				},
			},			
			-- FelblazeResidueDamage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {182218},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelblazeResidueDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {182218},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelblazeResidueDamage",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {182218},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iFelblazeResidueDamage",
					},
				},
			},
			-- EjectSoul - Phase 2
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {183023},
				execute = {	
					{
						"set",{hostile = 0},
						"batchquash",{"ReverberatingBlowCD","VolatileFelOrbCD","FelblazeChargeCD","FelPrisonCD","VoraciousSoulstalkerCD"},
						"alert",{"SargereiDominatorCD", time = 2},
						"alert",{"GhostCD", time = 2},
						"batchalert",{"ApocalypseCD","PortalsCD","Phase2"},
						"schedulemessage",{"mPortals",140},	
						"set",{dominatorCount = 0},
						"set",{dominanceCount = 0},
						"set",{apocalypseCount = 0},
						"set",{prisonCount = 0},
					},
				},
			},
			-- IncompleteBindingRemoved - Phase 1
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {190466},
				execute = {	
					{
						"set",{hostile = 1},
						"batchquash",{"SargereiDominatorCD","GhostCD","ApocalypseCD","PortalsCD"},
						"cancelmessage",{"mPortals"},	
						"alert",{"FelPrisonCD", time = 2},
						"alert",{"VolatileFelOrbCD", time = 3},
						"alert",{"FelblazeChargeCD", time = 3},
						"alert","Phase1",
					},
					{
						"expect",{"&mythic&","==","false"},
						"alert",{"VoraciousSoulstalkerCD", time = 3},
					},	
				},
			},
			------------------------
			--[[{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED", 
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","180258"}, -- Construct is good
								"set",{hostile = 0},
							},
							{
								"expect",{"#5#","==","180257"}, -- Construct is Evil 
								"set",{hostile = 1},
								"batchquash",{"SargereiDominatorCD","GhostCD","ApocalypseCD","PortalsCD"},
								"cancelmessage",{"mPortals"},	
								"alert",{"FelPrisonCD", time = 2},
								"alert",{"VolatileFelOrbCD", time = 3},
								"alert",{"FelblazeChargeCD", time = 3},
								"alert","Phase1",
								"invoke",{
									{
										"expect",{"&mythic&","==","false"},
										"alert",{"VoraciousSoulstalkerCD", time = 3},
									},
								},
							},							
						},
					},
					{
						"expect",{"#1#","==","boss2"},
						"invoke",{
							{
								"expect",{"#5#","==","180258"}, -- Construct is good
								"set",{hostile = 0},
							},
							{
								"expect",{"#5#","==","180257"}, -- Construct is Evil 
								"set",{hostile = 1},
								"batchquash",{"SargereiDominatorCD","GhostCD","ApocalypseCD","PortalsCD"},
								"cancelmessage",{"mPortals"},	
								"alert",{"FelPrisonCD", time = 2},
								"alert",{"VolatileFelOrbCD", time = 3},
								"alert",{"FelblazeChargeCD", time = 3},
								"alert","Phase1",
								"invoke",{
									{
										"expect",{"&mythic&","==","false"},
										"alert",{"VoraciousSoulstalkerCD", time = 3},
									},
								},
							},							
						},
					},					
				},
			},	--]]
		},
	}

	DXE:RegisterEncounter(data)
end