local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(1148)

do
	local data = {
		version = 8,
		key = "TwinOgron",
		zone = L.zone["Highmaul"],
		category = L.zone["Highmaul"],
		--name = L.npc_Highmaul["Twin Ogron"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Twin Ogron.BLP:35:35",
		triggers = {
			scan = {78238, 78237},
			encounterid = {1719},
			ejid = {1148},
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {78238, 78237},
			unittracing = {"boss1","boss2"},
			defeat = {78238, 78237}
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			timelfr = 600,
			timeflex = 480,
			timeheroic = 480,
			timemythic = 420,
		},
		timers = {
			timerShieldCharge1 = {
				{
					"set",{furthest = "&HighestDistance|<tft>&"},
					"scheduletimer",{"timerShieldCharge2",0.5},
				},
			},
			timerShieldCharge2 = {
				{
					"alert","iPossibleChargeUnit",
				},
			},					
			timerArcaneVolatility = {
				{
					"message","mCrystallineBarrage",
				},
			},
			timerArcaneVolatilityRadar = {
				{
					--"openwindow",{"8","<ArcaneVolatility>"},
					"openwindow",{"8","&list|ArcaneVolatilityunists2&",true,163372},
				},
			},
			timerArcaneVolatilitySay = {
				{
					"set",{ArcaneVolatilitysay = "DECR|1"},
				},
				{
					"expect",{"<ArcaneVolatilitysay>",">","2"},
					"announce","ArcaneVolatilitysay",
					"scheduletimer",{"timerArcaneVolatilitySay",1},
				},
			},			
			timerRadar = {
				{
					"expect",{"&mythic&","==","true"},
					"invoke",{
						{
							"expect",{"<volatilityOnMe>","==","1"},
							"openwindow",{"8",nil,false,163372},
						},
						{
							"expect",{"&count|ArcaneVolatilityunists&",">","0"},
							"openwindow",{"8","&list|ArcaneVolatilityunists2&",true,163372},
						},
						{
							"expect",{"<volatilityOnMe>","~=","1"},
							"expect",{"&count|ArcaneVolatilityunists2&","<","1"},
							"closewindow"
						},
					},
				},
			},
		},		
		userdata = {
			EnfeebleCount = 0,
			QuakeCount = 0,
			WWCount = 0,
			PulverizeCount = 0,
			ArcaneVolatilityunists = {type = "container", wipein = 3},
			ArcaneVolatilityunists2 = {type = "container", wipein = 3},
			ArcaneVolatility = {type = "container"},
			PhemosEnergyRate = 33,
			polEnergyRate = 28,
			volatilityOnMe = 0,
			TempRate = 0,
			ArcaneVolatilitysay = 6,
			furthest = "nil",
			--LastQuake = 0,
		},
		raidicons = {
			ArcaneVolatilitymark = {
				varname = SN[163372],
				type = "MULTIFRIENDLY",
				persist = 12,
				unit = "#5#",
				icon = 1,
				total = 8,
				reset = 5,
				desc = 163372,
				icon2 = ST[163372],
			},
		},	
		announces = { 
			--[[ArcaneVolatilitysay = {
				varname = format(L.alert["%s %s %s!"],SN[163372],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[163372],L.alert["on"],L.alert["Me"]),
				desc = 163372,
				icon = ST[163372],
			},--]]
			ArcaneVolatilitysay = {
				varname = format(L.alert["%s %s 2"],SN[163372],L.alert["in"]),
				type = "SAY",
				msg = format(L.alert["%s %s <ArcaneVolatilitysay>"],SN[163372],L.alert["in"]),
				desc = 163372,
				icon = ST[163372],				
			},				
		},		
		messages = {
			mCrystallineBarrage = {
				varname = format(L.alert["%s %s %s"],SN[163372],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|ArcaneVolatilityunists&"],SN[163372],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 163372,
				icon = ST[163372],
			},	
			mArcaneWound = {
				varname = format(L.alert["%s %s %s (2)"],SN[167200],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[167200],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[167200],L.alert["on"]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 167200,
				icon = ST[167200],
				counter2 = true,
			},				
			mEnfeeblingroar = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[158057]),
				type = "message",
				text = format(L.alert["%s %s (<EnfeebleCount>)"],L.alert["Incoming"],SN[158057]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 158057,
				icon = ST[158057],
				counter2 = true,
			},
			mWhirlwind = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[157943]),
				type = "message",
				text = format(L.alert["%s %s (<WWCount>)"],L.alert["Incoming"],SN[157943]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 157943,
				icon = ST[157943],
				counter2 = true,
			},
			mQuake = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[158200]),
				type = "message",
				text = format(L.alert["%s %s (<QuakeCount>)"],L.alert["Incoming"],SN[158200]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 158200,
				icon = ST[158200],
				counter2 = true,
			},
			mPulverize = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[158385]),
				type = "message",
				text = format(L.alert["%s %s (<PulverizeCount>)"],L.alert["Incoming"],SN[158385]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 158385,
				icon = ST[158385],
				counter2 = true,
			},				
			mShieldCharge = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[158134]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[158134]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 158134,
				icon = ST[158134],
			},
			mInterruptingShout = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[158093]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[158093]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 158093,
				icon = ST[158093],
			},
			mArcaneTwisted = {
				varname = format(L.alert["%s %s %s"],SN[163297],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[163297],L.alert["on"]),
				color1 = "GREEN",
				sound = "ALERT13",
				desc = 163297,
				icon = ST[163297],
			},				
		},
		onstart = {
			{
				"expect",{"&mythic&","==","true"},
				"alert",{"ArcaneVolatilityCD", time = 2},
				"set",{PhemosEnergyRate = 28},
				"set",{polEnergyRate = 23},
			},
			{
				"expect",{"&heroic&","==","true"},
				"set",{PhemosEnergyRate = 31},
				"set",{polEnergyRate = 25},				
			},
			{
				"alert",{"QuakeCD", time = 2},
				"set",{TempRate = "<polEnergyRate>"},
				"set",{TempRate = "INCR|10"},
				"alert",{"ShieldChargeCD", time = 3},
				"set",{TempRate = "<PhemosEnergyRate>"},
				"set",{TempRate = "INCR|10"},
				"alert",{"WhirlwindCD", time = 2},				
			},
		},
		alerts = {
			EnfeeblingRoarCD = {
				varname = format(L.alert["%s Cooldown"],SN[158057]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158057]),
				time = "<PhemosEnergyRate>",
				color1 = "GLOBAL",
				icon = ST[158057],
				desc = 158057,
				audiocd = true,
				audiotime = 10,	
			},
			WhirlwindCD = {
				varname = format(L.alert["%s Cooldown"],SN[157943]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157943]),
				time = "<PhemosEnergyRate>",
				time2 = "<TempRate>",
				color1 = "GLOBAL",
				icon = ST[157943],
				desc = 157943,
			},	
			QuakeCD = {
				varname = format(L.alert["%s Cooldown"],SN[158200]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158200]),
				time = "<PhemosEnergyRate>",
				time2 = 11.5,
				color1 = "GLOBAL",
				icon = ST[158200],
				desc = 158200,				
			},
			ShieldChargeCD = {
				varname = format(L.alert["%s Cooldown"],SN[158134]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158134]),
				time = 28,
				time2 = "<polEnergyRate>",
				time3 = "<TempRate>",
				color1 = "GLOBAL",
				icon = ST[158134],
				desc = 158134,
				audiocd = true,
				audiotime = 5,	
			},	
			InterruptingShoutCD = {
				varname = format(L.alert["%s Cooldown"],SN[158093]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158093]),
				time = "<polEnergyRate>",
				color1 = "GLOBAL",
				icon = ST[158093],
				desc = 158093,			
			},	
			PulverizeCD = {
				varname = format(L.alert["%s Cooldown"],SN[158385]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[158385]),
				time = 29,
				color1 = "GLOBAL",
				icon = ST[158385],
				desc = 158385,
			},
			ArcaneTwistedCD = {
				varname = format(L.alert["%s Cooldown"],SN[163297]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163297]),
				time = 55,
				color1 = "GLOBAL",
				icon = ST[163297],
				desc = 163297,
			},			
			ArcaneVolatilityCD = {
				varname = format(L.alert["%s Cooldown"],SN[163372]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[163372]),
				time = 60,
				time2 = 65,
				color1 = "GLOBAL",
				icon = ST[163372],
				desc = 163372,
				throttle = 2,
			},
			-- Warning
			wCleave = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[156157]),
				type = "simple",
				text = format(L.alert["%s %s (<cleaveCount>)"],L.alert["Incoming"],SN[156157]),
				time = 2,
				color1 = "RED",
				icon = ST[156157],
				--sound = "ALERT10",
				desc = 156157,
				enabled = false,
				counter = true,
			},	
			wArcaneCharge = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[163336]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[163336]),
				time = 2,
				color1 = "RED",
				icon = ST[163336],
				sound = "ALERT11",
				desc = 163336,
			},
			-- Inform
			IncomingInterruptingShout = {
				varname = format(L.alert["%s!"],SN[158093]),
				type = "inform",
				text = format(L.alert["%s!"],SN[158093]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[158093],
				desc = 158093,
			},				
			iArcaneVolatility = {
				varname = format(L.alert["%s %s!"],SN[163372],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[163372],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[163372],
				flashscreen = true,
				desc = 163372,
			},	
			iPulverize = {
				varname = format(L.alert["%s!"],SN[158385]),
				type = "inform",
				text = format(L.alert["%s!"],SN[158385]),
				time = 2,
				color1 = "RED",
				sound = "ALERT13",
				icon = ST[158385],
				desc = 158385,
			},	
			iBlaze = {
				varname = format(L.alert["%s %s!"],SN[158241],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[158241],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				sound = "ALERT12",
				icon = ST[158241],
				flashscreen = true,
				desc = 158241,
				throttle = 3,				
			},	
			--[[iPossibleChargeUnit = {
				varname = format(L.alert["%s %s %s %s!"],L.alert["Possible"],SN[158134],L.alert["on"],L.alert["player"]),
				type = "inform",
				text = format(L.alert["%s %s %s <furthest>!"],L.alert["Possible"],SN[158134],L.alert["on"]),
				time = 2,
				color1 = "GREEN",
				--sound = "ALERT12",
				icon = ST[158134],
				desc = 158134,			
			},	--]]	
			-- Casts
			InterruptingShoutActive = {
				varname = format(L.alert["%s Active"],SN[158093]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[158093]),
				time = 3,
				color1 = "RED",
				icon = ST[158093],
				desc = 158093,
			},
			-- Debuff
			VolatilityDebuff = {
				varname = format(L.alert["%s Debuff"],SN[163372]),
				type = "debuff",
				text = format(L.alert["%s: %s"],L.alert["YOU"],SN[163372]),
				text2 = format(L.alert["#5#: %s"],SN[163372]),
				time = 6,
				color1 = "PURPLE",
				desc = 163372,
				icon = ST[163372],
				tag = "#5#",			
			},				
		},
		events = {
			-- Enfeeblingroar
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158057},
				execute = {
					{
						"set",{EnfeebleCount = "INCR|1"},
						"message","mEnfeeblingroar",
						"alert","QuakeCD",
						--"alert","IncomingPhemos",
					},
				},
			},
			-- Whirlwind
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157943},
				execute = {
					{
						"set",{WWCount = "INCR|1"},
						"message","mWhirlwind",
						"alert","EnfeeblingRoarCD",
						--"alert",{"IncomingPhemos", time = 2},
					},
				},
			},
			-- ShieldCharge
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158134},
				execute = {
					{
					--	"expect",{"&tft_unitexists&","==","true"},
					--  "set",{tft = "&tft_unitname&"},
					--	"set",{furthest = "&HighestDistance|<tft>&"},
					--	"scheduletimer",{"timerShieldCharge",0.7},
					},
					{
						--"set",{tft = "&gettarget|#1#&"},
						--"set",{furthest = "&HighestDistance|<tft>&"},
						--"scheduletimer",{"timerShieldCharge1",0.4},
						--"scheduletimer",{"timerShieldCharge2",0.8},
						"message","mShieldCharge",
						"alert","InterruptingShoutCD",
						--"alert","IncomingPol",
					},
				},
			},
			-- InterruptingShout
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158093},
				execute = {
					{
						"message","mInterruptingShout",
						"batchalert",{"IncomingInterruptingShout","InterruptingShoutActive","PulverizeCD"},
					},
				},
			},
			-- Quake
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158200},
				execute = {
					{
						"set",{QuakeCount = "INCR|1"},
						"message","mQuake",
						"alert","WhirlwindCD",
						--"alert",{"IncomingPhemos", time = 2},
					},
				},
			},
			-- Pulverize
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157952, 158415, 158419},
				execute = {
					{
						"set",{PulverizeCount = "INCR|1"},
						"message","mPulverize",
						"closewindow",{true},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {158385},
				execute = {
					{
						"set",{PulverizeCount = "0"},
						"batchalert",{"ShieldChargeCD","iPulverize"},
						--"alert",{"IncomingPol", time = 2},
					},
					{
						"expect",{"&playerdebuff|"..SN[163372].."&","==","false"},
						"openwindow",{"4",nil,false,158385},
					},
				},
			},
			-- ArcaneCharge
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {163336},
				execute = {
					{
						"alert","wArcaneCharge",
					},
				},
			},
			-- ArcaneVolatility
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163372},
				execute = {
					{
						"insert",{"ArcaneVolatilityunists","#5#"},
						"insert",{"ArcaneVolatilityunists2","#5#",true},
						"canceltimer","timerArcaneVolatility",
						"scheduletimer",{"timerArcaneVolatility",1},
						"alert","ArcaneVolatilityCD",
						"raidicon","ArcaneVolatilitymark",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iArcaneVolatility",
						"alert","VolatilityDebuff",
						--"announce","ArcaneVolatilitysay",
						"set",{ArcaneVolatilitysay = 6},
						"scheduletimer",{"timerArcaneVolatilitySay",1},
						"invoke",{
							{
								"expect",{"&playerdebuff|"..SN[163372].."&","==","true"},
								"openwindow",{"8",nil,false,163372},
							},
							{
								"expect",{"&playerdebuff|"..SN[163372].."&","==","false"},
								"openwindow",{"8","&list|ArcaneVolatilityunists2&",true,163372},
								--"canceltimer","timerArcaneVolatilityRadar",
								--"scheduletimer",{"timerArcaneVolatilityRadar",1.2},
								--"set",{ArcaneVolatility = "&RaidDebuff|"..SN[163372].."&"},
							},
						},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"VolatilityDebuff", text = 2},
						"invoke",{
							{
								"expect",{"&playerdebuff|"..SN[163372].."&","==","false"},
								"openwindow",{"8","&list|ArcaneVolatilityunists2&",true,163372},
								--"canceltimer","timerArcaneVolatilityRadar",
								--"scheduletimer",{"timerArcaneVolatilityRadar",1.2},
								--"set",{ArcaneVolatility = "&RaidDebuff|"..SN[163372].."&"},		
							},						
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REFRESH",
				spellid = {163372},
				execute = {
					{
						"insert",{"ArcaneVolatilityunists","#5#"},
						"insert",{"ArcaneVolatilityunists2","#5#",true},
						"canceltimer","timerArcaneVolatility",
						"scheduletimer",{"timerArcaneVolatility",1},
						"alert","ArcaneVolatilityCD",
						"raidicon","ArcaneVolatilitymark",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","iArcaneVolatility",
						"alert","VolatilityDebuff",
						--"announce","ArcaneVolatilitysay",
						"set",{ArcaneVolatilitysay = 6},
						"scheduletimer",{"timerArcaneVolatilitySay",1},
						"invoke",{
							{
								"expect",{"&playerdebuff|"..SN[163372].."&","==","true"},
								"openwindow",{"8",nil,false,163372},
							},
							{
								"expect",{"&playerdebuff|"..SN[163372].."&","==","false"},
								"openwindow",{"8","&list|ArcaneVolatilityunists2&",true,163372},
								--"canceltimer","timerArcaneVolatilityRadar",
								--"scheduletimer",{"timerArcaneVolatilityRadar",1.2},
								--"set",{ArcaneVolatility = "&RaidDebuff|"..SN[163372].."&"},
							},
						},
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"VolatilityDebuff", text = 2},
						"invoke",{
							{
								"expect",{"&playerdebuff|"..SN[163372].."&","==","false"},
								"openwindow",{"8","&list|ArcaneVolatilityunists2&",true,163372},
								--"canceltimer","timerArcaneVolatilityRadar",
								--"scheduletimer",{"timerArcaneVolatilityRadar",1.2},
								--"set",{ArcaneVolatility = "&RaidDebuff|"..SN[163372].."&"},		
							},						
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {163372},
				--dstisplayerunit = true,
				execute = {
					{
						"delete",{"ArcaneVolatilityunists","#5#"},
						"delete",{"ArcaneVolatilityunists2","#5#"},
						"removeraidicon","#5#",
						"quash","VolatilityDebuff",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"set",{volatilityOnMe = 0},
					},					
					{
						"scheduletimer",{"timerRadar",0.1},
					},
				},
			},			
			-- ArcaneWound
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {167200},
				execute = {
					{
						"message","mArcaneWound",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {167200},
				execute = {
					{
						"message",{"mArcaneWound", text = 2},
					},
				},
			},	
			-- Blaze
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {158241},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iBlaze",
					},
				},
			},
			-- ArcaneTwisted
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {163297},
				execute = {
					{
						"message","mArcaneTwisted",
						"alert","ArcaneTwistedCD",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end