local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
do
	local data = {
		version = 3,
		key = "ProtectorOfAuch",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Auchindoun: Vigilant Kaathar"],
		triggers = {
			scan = {75839}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 75839,
		},
		userdata = {

		},	
		arrows = {
			HolyShieldarrow = {
				varname = SN[153002],
				unit = "&upvalue&",
				persist = 5,
				action = "TOWARD",
				msg = L.alert["GO TO HIM!"],
				spell = SN[153002],
				range1 = 6,
				range2 = 7,
				range3 = 8,
				desc = 153002,
				icon = ST[153002],
			},
		},
		announces = { 
			HolyShieldsay = {
				varname = format(L.alert["%s %s %s!"],SN[153002],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[153002],L.alert["on"],L.alert["Me"]),
				desc = 153002,
			},		
		},		
		messages = {
			mHolyShield = {
				varname = format(L.alert["%s %s %s"],SN[153002],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[153002],L.alert["on"]),
				text2 = format(L.alert["%s!"],SN[153002]),
				color1 = "PURPLE",
				sound = "ALERT13",
				desc = 153002,
				icon = ST[153002],
			},
		},
		onstart = {
			{
				"alert",{"FateCD", time = 2},
				"alert",{"HolyShieldCD", time = 2},
			},
		},
		alerts = {
			FateCD = {
				varname = format(L.alert["%s Cooldown"],SN[157465]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157465]),
				time = 37,
				time2 = 25,
				color1 = "GLOBAL",
				icon = ST[157465],
				desc = 157465,
			},
			ConsecratedLightCD = {
				varname = format(L.alert["%s Cooldown"],SN[153006]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153006]),
				time = 7,
				color1 = "GLOBAL",
				icon = ST[153006],
				desc = 153006,
			},
			HolyShieldCD = {
				varname = format(L.alert["%s Cooldown"],SN[153002]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153002]),
				time = 47,
				time2 = 30,
				color1 = "GLOBAL",
				icon = ST[153002],
				desc = 153002,
				audiocd = true,
				audiotime = 5,				
			},			
			-- Alert
			wConsecratedLight = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[153500]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[153500]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153500],
				sound = "ALERT10",
				desc = 153500,
			},
			wFate = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[157465]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[157465]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[157465],
				sound = "ALERT10",
				desc = 157465,
			},				
			-- Inform
			iHolyShieldself = {
				varname = format(L.alert["%s %s %s!"],SN[153002],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[153002],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[153002],
				desc = 153002,
			},
			iSanctifiedGround = {
				varname = format(L.alert["%s %s, %s!"],SN[161457],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[161457],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				icon = ST[161457],
				sound = "ALERT10",
				desc = 161457,
				throttle = 1,
			},				
		},
		events = {
			-- HolyShield
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153002},
				execute = {
					{
						"target",{
							source = "#1#",
							wait = 0.02,
							schedule = 16,
							--raidicon = "FoulStreammark",
							arrow = "HolyShieldarrow",
							--arrowdef = "<",
							--arrowrange = 16,
							announce = "HolyShieldsay",
							message = "mHolyShield",
							alerts = {
								self = "iHolyShieldself",
								--other = 
								--unknown = "",
								unknownmsg = {"mHolyShield", text = 2},
							},
						},
					},
				},
			},
			-- ConsecratedLight
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153006},
				execute = {
					{
						"batchalert",{"ConsecratedLightCD","wConsecratedLight"},
					},
				},
			},
			-- Fate
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {157465},
				execute = {
					{
						"batchalert",{"FateCD","wFate"},
					},
				},
			},
			-- SanctifiedGround
			{
				type = "combatevent",
				eventtype = "SPELL_DAMAGE",
				spellid = {161457},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSanctifiedGround",
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_MISSED",
				spellid = {161457},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iSanctifiedGround",
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end