local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
do
	local data = {
		version = 3,
		key = "Roltall",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Bloodmaul: Roltall"],
		triggers = {
			scan = {75786}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 75786,
		},
		userdata = {
			Boulder = 0,
			burningSlagCast = 0,
		},		
		messages = {
			mBoulder = {
				varname = format(L.alert["%s %s (3)"],L.alert["Incoming"],SN[153247]),
				type = "message",
				text = format(L.alert["%s %s (<Boulder>)"],L.alert["Incoming"],SN[153247]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 153247,
				icon = ST[149975],
			},	
		},
		onstart = {

		},
		alerts = {
			FieryBoulderCD = {
				varname = format(L.alert["%s Cooldown"],SN[153247]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153247]),
				time = 13.3,
				time2 = 3.5,
				color1 = "GLOBAL",
				icon = ST[153247],
				desc = 153247,
			},
			HeatWaveCD = {
				varname = format(L.alert["%s Cooldown"],SN[152940]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[152940]),
				time = 9.5,
				color1 = "GLOBAL",
				icon = ST[152940],
				desc = 152940,
			},
			BurningSlagCD = {
				varname = format(L.alert["%s Cooldown"],SN[152939]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[152939]),
				time = 10.7,
				color1 = "GLOBAL",
				icon = ST[152939],
				desc = 152939,
			},	
			-- Warning
			wHeatWave = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[152940]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[152940]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[152940],
				sound = "ALERT10",
				desc = 152940,
			},
			wBurningSlag = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[152939]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[152939]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[152939],
				sound = "ALERT10",
				desc = 152939,
			},
			-- Inform
			iBurningSlagFire = {
				varname = format(L.alert["%s %s, %s!"],SN[153227],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s, %s!"],SN[153227],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[153227],
				flashscreen = true,
				throttle = 2,
				desc = 153227,
			},					
			-- Casts
			HeatWaveBuff = {
				varname = format(L.alert["%s Active"],SN[152940]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[152940]),
				time = 9.5,
				color1 = "GLOBAL",
				icon = ST[152940],
				desc = 152940,
			},			
		},
		events = {
			-- Boulder
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {153247},
				execute = {
					{
						"set",{Boulder = "INCR|1"},
						"message","mBoulder",
					},
					{
						"expect",{"<Boulder>","==","3"},
						"alert","HeatWaveCD",
						"set",{Boulder = 0},
					},
					{
						"expect",{"<Boulder>","~=","3"},
						"alert",{"FieryBoulderCD", time = 2},
					},	
					{
						"expect",{"<burningSlagCast>","==","1"},
						"set",{burningSlagCast = "0"},
					},					
				},
			},
			-- HeatWave
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {152940},
				execute = {
					{
						"batchalert",{"HeatWaveBuff","HeatWaveCD","wHeatWave"},
					},			
				},
			},	
			-- BurningSlag
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {152939},
				execute = {
					{
						"expect",{"<burningSlagCast>","==","0"},
						"set",{burningSlagCast = "1"},
						"batchalert",{"BurningSlagCD","wBurningSlag"},
					},			
				},
			},		
			-- BurningSlagFire
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {153227},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iBurningSlagFire",
					},				
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {153227},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iBurningSlagFire",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {153227},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iBurningSlagFire",
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end