local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
do
	local data = {
		version = 3,
		key = "Witherbark",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["EverBloom: Witherbark"],
		triggers = {
			scan = {81522,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 81522,
		},
		userdata = {

		},		
		messages = {

		},
		onstart = {

		},
		alerts = {
			wParchedGrasp = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[164357]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[164357]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[164357],
				sound = "ALERT10",
				desc = 164357,
				exhealer = true,
				exdps = true,
			},
			wBrittleBark = {
				varname = format(L.alert["%s!"],SN[164357]),
				type = "simple",
				text = format(L.alert["%s!"],SN[164357]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[164357],
				sound = "ALERT10",
				desc = 164357,
			},
			wUncheckedGrowth = {
				varname = format(L.alert["%s!"],SN["ej10098"]),
				type = "simple",
				text = format(L.alert["%s!"],SN["ej10098"]),
				time = 2,
				color1 = "INDIGO",
				icon = EJST[10098],
				sound = "ALERT10",
				ability = 10098,
			},				
			-- Inform
			iLivingLeaves = {
				varname = format(L.alert["%s %s, %s!"],SN[169495],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[169495],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[169495],
				flashscreen = true,
				throttle = 2,
				desc = 169495,
			},
			iUncheckedGrowth = {
				varname = format(L.alert["%s %s, %s!"],SN[164294],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[164294],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[164294],
				flashscreen = true,
				throttle = 2,
				desc = 164294,
			},	
			iUncheckedGrowthAdd = {
				varname = format(L.alert["%s %s"],SN["ej10098"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s"],SN["ej10098"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = EJST[10098],
				exhealer = true,
				exdps = true,
				ability = 10098,
			},
			iUncheckedGrowthYou = {
				varname = format(L.alert["%s %s %s!"],SN[164294],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[164294],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[164294],
				flashscreen = true,
				desc = 164294,
			},				
			-- Casts
			ParchedGraspCD = {
				varname = format(L.alert["%s Active"],SN[164357]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[164357]),
				time = 12,
				color1 = "GLOBAL",
				icon = ST[164357],
				desc = 164357,
				exdps = true,				
			},				
		},
		events = {
			-- ParchedGrasp
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {164357},
				execute = {
					{
						"batchalert",{"ParchedGraspCD","wParchedGrasp"},
					},			
				},
			},	
			-- BrittleBark
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {164275},
				execute = {
					{
						"alert","wBrittleBark",
						"cancelalert","ParchedGraspCD",
					},			
				},
			},	
			-- LivingLeaves
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {169495},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iLivingLeaves",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {169495},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iLivingLeaves",
					},
				},
			},	
			-- UncheckedGrowth
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {164294},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iUncheckedGrowth",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {164294},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iUncheckedGrowth",
					},
				},
			},	
			-- Emotes
			{
				type = "event",
				event = "EMOTE", 
				execute = {
					-- UncheckedGrowth
					{
						"batchalert",{"wUncheckedGrowth","iUncheckedGrowthAdd"},
					},
				},
			},
			-- BOSS_WHISPER
			{
				type = "event",
				event = "BOSS_WHISPER", 
				execute = {
					-- UncheckedGrowth
					{
						"alert","iUncheckedGrowthYou",
					},
				},
			},						
		},
	}

	DXE:RegisterEncounter(data)
end