local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
do
	local data = {
		version = 3,
		key = "Bonemaw",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["SMBurialGrounds: Bonemaw"],
		triggers = {
			scan = {76177,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	76177, 	},
			unittracing = {	"boss1",},
			defeat = 76177,
		},
		userdata = {

		},		
		messages = {
			mBodySlam = {
				varname = format(L.alert["%s %s %s %s"],L.alert["Incoming"],SN[154175],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s %s #4#"],L.alert["Incoming"],SN[154175],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 154175,
				icon = ST[154175],
				desc = 154175,
			},
		},
		onstart = {
			{
				"alert",{"BodySlamCD", time = 2},
			},
		},
		alerts = {
			BodySlamCD = {
				varname = format(L.alert["%s Cooldown"],SN[154175]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154175]),
				time = 32,
				time2 = 15,
				time3 = 14,
				color1 = "GLOBAL",
				icon = ST[154175],
				desc = 154175,
			},
			CorpseBreathCD = {
				varname = format(L.alert["%s Cooldown"],SN[165578]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[165578]),
				time = 32,
				color1 = "GLOBAL",
				icon = ST[165578],
				desc = 165578,
				enabled = false,
			},
			-- Warning
			wCorpseBreath = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[165578]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[165578]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[165578],
				sound = "ALERT10",
				desc = 165578,
			},
			wInhale = {
				varname = format(L.alert["%s!"],SN[153804]),
				type = "simple",
				text = format(L.alert["%s!"],SN[153804]),
				time = 2,
				color1 = "INDIGO",
				icon = ST[153804],
				desc = 153804,
			},	
			-- Inform
			iInhale = {
				varname = format(L.alert["%s %s!"],SN[153804],L.alert["RUN AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN[153804],L.alert["RUN AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[153804],
				flashscreen = true,
				desc = 153804,
			},				
		},
		events = {
			-- BodySlam
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {154175},
				execute = {
					{
						"message","mBodySlamInc",
					},
					{
						"expect",{"&npcid|#4#&","==","75452"}, -- Bonemaw
						"alert","BodySlamCD",
					},
					{
						"expect",{"&npcid|#4#&","~=","75452"}, -- 
						"alert",{"BodySlamCD", time = 3},
					},					
				},
			},
			-- CorpseBreath
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {165578},
				execute = {
					{
						"batchalert",{"CorpseBreathCD","wCorpseBreath"},
					},			
				},
			},	
			
			
			------------------
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","76057"}, -- Carrion Centipede
						"quash","BodySlamCD",
					},		
				},
			},
			-- Emotes
			{
				type = "event",
				event = "BOSS_EMOTE", 
				execute = {
					-- Inhale
					{
						"expect",{"#1#","find","spell:153804"},
						"batchalert",{"wInhale","iInhale"},
					},
				},
			},
		},			
	}

	DXE:RegisterEncounter(data)
end