local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
do
	local data = {
		version = 3,
		key = "Araknath",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Skyreach: Araknath"],
		triggers = {
			scan = {76141,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	"boss1", 	},
			unittracing = {	"boss1",},
			defeat = 76141,
		},
		userdata = {
			burst = 0,
		},		
		messages = {
			mBurst = {
				varname = format(L.alert["%s %s (3)"],L.alert["Incoming"],SN[154135]),
				type = "message",
				text = format(L.alert["%s %s (<burst>)"],L.alert["Incoming"],SN[154135]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 154135,
				icon = ST[154135],
			},
			mEnergize = {
				varname = format(L.alert["%s!"],SN[154159]),
				type = "message",
				text = format(L.alert["%s!"],SN[154159]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 154159,
				icon = ST[154159],
				throttle = 2,
			},				
		},
		onstart = {
			{
				"alert",{"BurstCD", time = 2},
			},
		},
		alerts = {
			EnergizeCD = {
				varname = format(L.alert["%s Cooldown"],SN[154159]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154159]),
				time = 20,
				color1 = "GLOBAL",
				icon = ST[154159],
				desc = 154159,
				throttle = 2,
			},
			BurstCD = {
				varname = format(L.alert["%s Cooldown"],SN[154135]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154135]),
				time = 23,
				time2 = 20,
				color1 = "GLOBAL",
				icon = ST[154135],
				desc = 154135,
			},			
			-- Inform
			iSmash = {
				varname = format(L.alert["%s, %s!"],SN[154043],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s, %s!"],SN[154043],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT11",
				icon = ST[154043],
				desc = 154043,
				flashscreen = true,
				exhealer = true,
				exdps = true,
			},	
		},
		events = {
			-- Burst
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {154135},
				execute = {
					{
						"set",{burst = "INCR|1"},
						"alert","BurstCD",
						"message","mBurst",
					},
				},
			},
			-- Smash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {154110, 154113},
				execute = {
					{
						"alert","iSmash",
					},
				},
			},
			-- Energize
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {154159},
				execute = {
					{				
						"alert","EnergizeCD",
						"message","mEnergize",
					},						
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end