local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
do
	local data = {
		version = 3,
		key = "Viryx",
		zone = L.zone["Party Module for WoD"],
		category = L.zone["Party Module for WoD"],
		name = L.npc_PartyWoD["Skyreach: Viryx"],
		triggers = {
			scan = {76266,}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	76266, 	},
			unittracing = {	"boss1",},
			defeat = 76266,
		},
		raidicons = {
			CastDownmark = {
				varname = SN[153954],
				type = "FRIENDLY",
				persist = 120,
				unit = "&upvalue&",
				icon = 1,
				desc = 153954,
				icon2 = ST[153954],
			},			
		},
		userdata = {
			lastGrab = "",
		},		
		messages = {
			mShielding = {
				varname = format(L.alert["%s %s %s"],SN[154055],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[154055],L.alert["on"]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 154055,
				icon = ST[154055],
			},
			mShieldingInc = {
				varname = format(L.alert["%s %s %s %s"],L.alert["Incoming"],SN[154055],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s %s #4#"],L.alert["Incoming"],SN[154055],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				desc = 154055,
				icon = ST[154055],
			},
			mForceDemon = {
				varname = format(L.alert["%s"],SN[153954]),
				type = "message",
				text = format(L.alert["%s"],SN[153954]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 153954,
				icon = ST[153954],
			},
			mLensFlare = {
				varname = format(L.alert["%s!"],SN[154043]),
				type = "message",
				text = format(L.alert["%s!"],SN[154043]),
				color1 = "GOLD",
				sound = "ALERT13",
				desc = 154043,
				icon = ST[154043],
			},
			mCastDown = {
				varname = format(L.alert["%s %s %s"],SN[153954],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[153954],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 153954,
				icon = ST[153954],
			},			
		},
		onstart = {
			{
				"alert",{"CastDownCD", time = 2},
				"alert","LenseFlareCD",
			},
		},
		alerts = {
			CastDownCD = {
				varname = format(L.alert["%s Cooldown"],SN[153954]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[153954]),
				time = 38,
				time2 = 15,
				color1 = "GLOBAL",
				icon = ST[153954],
				desc = 153954,
			},
			LenseFlareCD = {
				varname = format(L.alert["%s Cooldown"],SN[154032]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[154032]),
				time = 38,
				time2 = 15,
				color1 = "GLOBAL",
				icon = ST[154032],
				desc = 154032,
			},
			-- Warning
			wCastDown = {
				varname = format(L.alert["%s %s"],SN[153954],L.alert["soon"]),
				type = "simple",
				text = format(L.alert["%s %s"],SN[153954],L.alert["soon"]),
				time = 2,
				color1 = "TAN",
				icon = ST[153954],
				sound = "ALERT10",
				desc = 153954,
			},
			wForceDemon = {
				varname = format(L.alert["%s %s %s"],SN[153954],L.alert["on"],L.alert["player"]),
				type = "simple",
				text = format(L.alert["%s %s &vehiclenames&"],SN[153954],L.alert["on"]),
				time = 2,
				color1 = "TAN",
				icon = ST[153954],
				sound = "ALERT10",
				desc = 153954,
			},
			-- Inform
			iLensFlare = {
				varname = format(L.alert["%s %s, %s!"],SN[154043],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "simple",
				text = format(L.alert["%s %s, %s!"],SN[154043],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT10",
				icon = ST[154043],
				desc = 154043,
				flashscreen = true,
				throttle = 2,
			},					
		},
		events = {
			-- Shielding
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {154055},
				execute = {
					{
						"message","mShielding",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {154055},
				execute = {
					{
						"message","mShieldingInc",
					},
				},
			},	
			-- LensFlare
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {154043},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iLensFlare",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_ABSORBED",
				spellid = {154043},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iLensFlare",
					},
				},
			},	

			-----------------------
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED",
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","153954"}, -- Cast Down
								"alert","wCastDown",
								"target",{
									source = "#1#",
									wait = 0.05,
									schedule = 15,
									message = "mCastDown",
									raidicon = "CastDownmark",
								},
							},
							{
								"expect",{"#5#","==","165834"}, -- Force Demon
								"alert","CastDownCD",
								"message","mForceDemon",
							},
							{
								"expect",{"#5#","==","154032"}, -- Lens Flare
								"message","mLensFlare",
								"alert","LenseFlareCD",
							},							
						},
					},
				},
			},	
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","76267"}, -- Solar Zealot
						"removeraidicon","<lastGrab>",
						"set",{lastGrab = ""},
					},		
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end