local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
local EJName = EJ_GetEncounterInfo(551)
local instance = EJ_GetInstanceInfo(254) or ""
do
	local data = {
		version = 1,
		key = "Skyriss",
		zone = L.zone["TimeWalker"],
		category = L.zone["TimeWalker"],
		name = "["..instance.."] "..EJName,
		triggers = {
			scan = {20912, 20904}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {	20912, 20904 },
			unittracing = {"boss1","boss2"},
			defeat = 20912, 
		},
		userdata = {
			hp = 0,
			splitPhase = 1,
		},		
		messages = {
			mDomination = {
				varname = format(L.alert["%s %s %s"],SN[37162],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU&"],SN[37162],L.alert["on"]),
				color1 = "YELLOW",
				sound = "ALERT13",
				desc = 37162,
				icon = ST[37162],
			},
			mMindRend = {
				varname = format(L.alert["%s %s %s"],SN[36924],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &dstname_or_YOU&"],SN[36924],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 36924,
				icon = ST[36924],
			},
			mSplit = {
				varname = format(L.alert["%s %s"],SN[143024],L.alert["soon"]),
				type = "message",
				text = format(L.alert["%s %s"],SN[143024],L.alert["soon"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 143024,
				icon = ST[143024],
			},			
		},
		onstart = {

		},
		alerts = {
			-- Warning
			wHeal = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[39013]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[39013]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[39013],
				sound = "ALERT10",
				desc = 39013,
				--flashscreen = true,
			},
			wSplit = {
				varname = format(L.alert["%s"],SN[36175]),
				type = "simple",
				text = format(L.alert["%s"],SN[36175]),
				time = 2,
				color1 = "RED",
				icon = ST[36175],
				sound = "ALERT11",
				desc = 36175,
				flashscreen = true,
			},
			-- Casts
			WhirlwindAct = {
				varname = format(L.alert["%s Active"],SN[36175]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[36175]),
				time = 6,
				color1 = "RED",
				icon = ST[36175],
				desc = 36175,
			},	
			-- Debuff
			DominationDebuff = {
				varname = format(L.alert["%s Debuff"],SN[37162]),
				type = "debuff",
				text = format(L.alert["&dstname_or_YOU&: %s"],SN[37162]),
				time = 6,
				color1 = "ORANGE",
				desc = 37162,
				icon = ST[37162],
				tag = "#5#",
				exdps = true,				
			},				
		},
		events = {
			-- Domination 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {37162, 39019},
				execute = {
					{
						"message","mDomination",
						"alert","DominationDebuff",
					},
				},
			},	
			-- MindRend 
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {36924, 36929, 39017, 39021},
				execute = {
					{
						"message","mMindRend",
					},
				},
			},	
			-------------------------
			{
				type = "event",
				event = "YELL", 
				execute = {
					-- Split
					{
						"expect",{"#1#","find",L.chat_TimeWalker["(We span the universe, as countless as the stars!)"]},
						"alert","wSplit",
					},			
				},
			},
			{
                type = "event",
                event = "UNIT_HEALTH_FREQUENT",
                execute = {
					{
						"expect",{"&bossid|#1#&","==","20912"},
						"set",{hp = "&gethp|#1#&"},
						"invoke",{
							{
								"expect",{"<hp>","<","71"},
								"expect",{"<splitPhase>","==","1"},
								"set",{splitPhase = "INCR|1"},
								"message","mSplit",
							},
						},
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end