local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
local EJName = EJ_GetEncounterInfo(1262)
do
	local data = {
		version = 2,
		key = "Rukhmar",
		zone = L.zone["Draenor"],
		category = L.zone["Draenor"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Rukhmar.BLP:35:35",
		triggers = {
			scan = {83746}, 
		},
		onactivate = {
			tracerstart = true,
			combatstop = true,
			tracing = {83746},
			--unittracing = {	"boss1",},
			defeat = {83746},
			delayrecombat = 20,
		},
		userdata = {

		},		
		messages = {
			mPiercedArmor = {
				varname = format(L.alert["%s %s %s (2)"],SN[167615],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s %s (1)"],SN[167615],L.alert["on"],L.alert["player"]),
				text2 = format(L.alert["%s %s %s (#11#)"],SN[167615],L.alert["on"],L.alert["player"]),
				color1 = "YELLOW",
				icon = ST[167615],
				sound = "ALERT13",
				counter2 = true,
			},
		},
		onstart = {

		},
		alerts = {
			SolarRadiationCD = {
				varname = format(L.alert["%s Cooldown"],SN[167710]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[167710]),
				time = 15,
				color1 = "GLOBAL",
				icon = ST[167710],
				desc = 167710,
			},
			-- Warning
			wLooseQuills = {
				varname = format(L.alert["%s!"],SN[159113]),
				type = "simple",
				text = format(L.alert["%s!"],SN[159113]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[159113],
				desc = 159113,
			},	
			-- Inform
			iSolarBreath = {
				varname = format(L.alert["%s!"],SN[167687]),
				type = "inform",
				text = format(L.alert["%s!"],SN[167687]),
				time = 2,
				color1 = "RED",
				icon = ST[167687],
				sound = "ALERT13",
				desc = 167687,
				exhealer = true,
				exdps = true,
			},
			iSolarRadiation = {
				varname = format(L.alert["%s!"],SN[167710]),
				type = "inform",
				text = format(L.alert["%s!"],SN[167710]),
				time = 2,
				color1 = "RED",
				icon = ST[167710],
				sound = "ALERT13",
				desc = 167710,
				extank = true,
				exdps = true,
			},				
			-- Casts
			LooseQuillsActive = {
				varname = format(L.alert["%s Active"],SN[167647]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[167647]),
				time = 30,
				color1 = "GLOBAL",
				icon = ST[167647],
				desc = 167647,
			},			
		},
		events = {
			-- LooseQuills
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {167647},
				execute = {
					{
						"batchalert",{"LooseQuillsActive","wLooseQuills"},
					},						
				},
			},
			-- PiercedArmor
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {167615},
				execute = {
					{
						"message","mPiercedArmor",
					},						
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {167615},
				execute = {
					{
						"message",{"mPiercedArmor", text = 2},
					},						
				},
			},	
			-- SolarBreath
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {167679},
				execute = {
					{
						"alert","wSolarBreath",
					},
				},
			},
			-- SolarRadiation
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {167710},
				execute = {
					{
						"batchalert",{"SolarRadiationCD","iSolarRadiation"},
					},						
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end